SystemOrganization addCategory: #'SMutant-Core'!
SystemOrganization addCategory: #'SMutant-Examples'!
SystemOrganization addCategory: #'SMutant-Test'!
SystemOrganization addCategory: #'SMutant-GUI'!
SystemOrganization addCategory: #'SMutant-Evaluation'!

SequenceableCollection subclass: #SMutantLinkedList
	instanceVariableNames: 'firstLink lastLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!SMutantLinkedList methodsFor: 'adding' stamp: 'Milos 4/20/2011 23:02'!
add: aLink 
	"Add aLink to the end of the receiver's list. Answer aLink."

	^self addLast: aLink! !

!SMutantLinkedList methodsFor: 'adding' stamp: 'Milos 4/20/2011 23:02'!
add: link after: otherLink

	"Add otherLink  after link in the list. Answer aLink."

	| savedLink |
	lastLink == otherLink ifTrue: [^ self addLast: link].
	savedLink := otherLink nextLink.
	otherLink nextLink: link.
	link nextLink:  savedLink.
	^link.! !

!SMutantLinkedList methodsFor: 'adding' stamp: 'Milos 4/20/2011 23:02'!
add: link before: otherLink

	| aLink |
	firstLink == otherLink ifTrue: [^ self addFirst: link].
	aLink := firstLink.
	[aLink == nil] whileFalse: [
		aLink nextLink == otherLink ifTrue: [
			link nextLink: aLink nextLink.
			aLink nextLink: link.
			^ link
		].
		 aLink := aLink nextLink.
	].
	^ self errorNotFound: otherLink! !

!SMutantLinkedList methodsFor: 'adding' stamp: 'Milos 4/20/2011 23:02'!
addFirst: aLink 
	"Add aLink to the beginning of the receiver's list. Answer aLink."

	self isEmpty ifTrue: [lastLink := aLink].
	aLink nextLink: firstLink.
	firstLink := aLink.
	^aLink! !

!SMutantLinkedList methodsFor: 'adding' stamp: 'Milos 4/20/2011 23:02'!
addLast: aLink 
	"Add aLink to the end of the receiver's list. Answer aLink."

	self isEmpty
		ifTrue: [firstLink := aLink]
		ifFalse: [lastLink nextLink: aLink].
	lastLink := aLink.
	^aLink! !

!SMutantLinkedList methodsFor: 'accessing' stamp: 'Milos 4/20/2011 23:02'!
at: index

	| i |
	i := 0.
	self do: [:link |
		(i := i + 1) = index ifTrue: [^ link]].
	^ self errorSubscriptBounds: index! !

!SMutantLinkedList methodsFor: 'enumerating' stamp: 'Milos 4/20/2011 23:02'!
do: aBlock

	| aLink |
	aLink := firstLink.
	[aLink == nil] whileFalse:
		[aBlock value: aLink.
		 aLink := aLink nextLink]! !

!SMutantLinkedList methodsFor: 'accessing' stamp: 'Milos 4/20/2011 23:02'!
first
	"Answer the first link. Create an error notification if the receiver is 
	empty."

	self emptyCheck.
	^firstLink! !

!SMutantLinkedList methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:02'!
isEmpty

	^firstLink isNil! !

!SMutantLinkedList methodsFor: 'accessing' stamp: 'Milos 4/20/2011 23:02'!
last
	"Answer the last link. Create an error notification if the receiver is 
	empty."

	self emptyCheck.
	^lastLink! !

!SMutantLinkedList methodsFor: 'removing' stamp: 'Milos 4/20/2011 23:02'!
remove: aLink ifAbsent: aBlock  
	"Remove aLink from the receiver. If it is not there, answer the result of
	evaluating aBlock."

	| tempLink |
	aLink == firstLink
		ifTrue: [firstLink := aLink nextLink.
				aLink == lastLink
					ifTrue: [lastLink := nil]]
		ifFalse: [tempLink := firstLink.
				[tempLink == nil ifTrue: [^aBlock value].
				 tempLink nextLink == aLink]
					whileFalse: [tempLink := tempLink nextLink].
				tempLink nextLink: aLink nextLink.
				aLink == lastLink
					ifTrue: [lastLink := tempLink]].
	aLink nextLink: nil.
	^aLink! !

!SMutantLinkedList methodsFor: 'removing' stamp: 'Milos 4/20/2011 23:02'!
removeAll
	"Implementation note: this has to be fast"

	firstLink := lastLink := nil! !

!SMutantLinkedList methodsFor: 'removing' stamp: 'Milos 4/20/2011 23:02'!
removeFirst
	"Remove the first element and answer it. If the receiver is empty, create 
	an error notification."

	| oldLink |
	self emptyCheck.
	oldLink := firstLink.
	firstLink == lastLink
		ifTrue: [firstLink := nil. lastLink := nil]
		ifFalse: [firstLink := oldLink nextLink].
	oldLink nextLink: nil.
	^oldLink! !

!SMutantLinkedList methodsFor: 'removing' stamp: 'Milos 4/20/2011 23:02'!
removeLast
	"Remove the receiver's last element and answer it. If the receiver is 
	empty, create an error notification."

	| oldLink aLink |
	self emptyCheck.
	oldLink := lastLink.
	firstLink == lastLink
		ifTrue: [firstLink := nil. lastLink := nil]
		ifFalse: [aLink := firstLink.
				[aLink nextLink == oldLink] whileFalse:
					[aLink := aLink nextLink].
				 aLink nextLink: nil.
				 lastLink := aLink].
	oldLink nextLink: nil.
	^oldLink! !

!SMutantLinkedList methodsFor: 'enumerating' stamp: 'Milos 4/20/2011 23:02'!
species

	^ Array! !

TestResult subclass: #MutationTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MutationTestResult commentStamp: 'Milos 4/29/2011 15:46' prior: 0!
Result for mutation testing run. It knows how to print itself.

Instance Variables!

!MutationTestResult methodsFor: 'printing' stamp: 'Milos 4/25/2011 01:58'!
printOn: aStream
	aStream
		nextPutAll: self runCount printString;
		nextPutAll: ' mutations, ';
		nextPutAll: self expectedPassCount printString;
		nextPutAll: ' killed, ';
		nextPutAll: self unexpectedErrorCount printString;
		nextPutAll: ' live, ';
		nextPutAll:
				(self runCount = 0
						ifTrue: [ 0 ]
						ifFalse: [ self expectedPassCount / self runCount ]) printString;
		nextPutAll: ' score'! !

Set subclass: #SMutantSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!SMutantSet commentStamp: 'Milos 4/29/2011 18:55' prior: 0!
I represent a set of objects without duplicates.  I can hold anything that responds to
#hash and #=, except for nil.  My instances will automatically grow, if necessary,
Note that I rely on #=, not #==.  If you want a set using #==, use IdentitySet.

Instance structure:

  array	An array whose non-nil elements are the elements of the set,
		and whose nil elements are empty slots.  There is always at least one nil.
		In fact I try to keep my "load" at 75% or less so that hashing will work well.

  tally	The number of elements in the set.  The array size is always greater than this.

The core operation is #findElementOrNil:, which either finds the position where an
object is stored in array, if it is present, or finds a suitable position holding nil, if
its argument is not present in array,!

!SMutantSet class methodsFor: 'instance creation' stamp: 'Milos 4/29/2011 18:39'!
new
	^ self basicNew
		initialize: 5;
		yourself! !

!SMutantSet class methodsFor: 'instance creation' stamp: 'Milos 4/29/2011 18:39'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: (self sizeFor: nElements)! !

!SMutantSet class methodsFor: 'instance creation' stamp: 'Milos 4/29/2011 18:39'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^ newCollection
"
	Set newFrom: {1. 2. 3}
	{1. 2. 3} as: Set
"! !

!SMutantSet class methodsFor: 'initialization' stamp: 'Milos 4/29/2011 18:39'!
quickRehashAllSets  "Set rehashAllSets"
	| insts |
	self withAllSubclassesDo:
		[:c |
			insts := c allInstances.
			(insts isEmpty or: [c = MethodDictionary]) ifFalse:
			['Rehashing instances of ' , c name
				displayProgressAt: Sensor cursorPoint
				from: 1 to: insts size
				during: [:bar | 1 to: insts size do: [:x | bar value: x. (insts at: x) rehash]]
			]
		]! !

!SMutantSet class methodsFor: 'initialization' stamp: 'Milos 4/29/2011 18:39'!
rehashAllSets
	"Set rehashAllSets"	
	
	self allSubInstances do: #rehash! !

!SMutantSet class methodsFor: 'instance creation' stamp: 'Milos 4/29/2011 18:39'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"
	nElements <= 0 ifTrue: [^ 1].
	^ nElements+1*4//3! !

!SMutantSet methodsFor: 'testing' stamp: 'Milos 4/29/2011 18:39'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: SMutantSet) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!SMutantSet methodsFor: 'adding' stamp: 'Milos 4/29/2011 18:39'!
add: newObject
	"Include newObject as one of the receiver's elements, but only if
	not already present. Answer newObject."

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) ifNil: [self atNewIndex: index put: newObject].
	^ newObject! !

!SMutantSet methodsFor: 'adding' stamp: 'Milos 4/29/2011 18:39'!
add: newObject withOccurrences: anInteger
	^ self add: newObject! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
array
	^ array! !

!SMutantSet methodsFor: 'converting' stamp: 'Milos 4/29/2011 18:47'!
asSet
	^self! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!SMutantSet methodsFor: 'accessing' stamp: 'Milos 4/29/2011 18:39'!
atRandom: aGenerator
	"Answer a random element of the receiver. Uses aGenerator which
should be kept by the user in a variable and used every time. Use
this instead of #atRandom for better uniformity of random numbers because 
	only you use the generator. Causes an error if self has no elements."
	| rand |

	self emptyCheck.
	rand := aGenerator nextInt: self size.
	self doWithIndex:[:each :ind |
		ind == rand ifTrue:[^each]].
	^ self errorEmptyCollection
! !

!SMutantSet methodsFor: 'accessing' stamp: 'Milos 4/29/2011 18:39'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!SMutantSet methodsFor: 'enumerating' stamp: 'Milos 4/29/2011 18:39'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newSet |
	newSet := SMutantSet new: self size.
	array do: [:each | each ifNotNil: [newSet add: (aBlock value: each)]].
	^ newSet! !

!SMutantSet methodsFor: 'objects from disk' stamp: 'Milos 4/29/2011 18:39'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self rehash.
	"^ self"
! !

!SMutantSet methodsFor: 'copying' stamp: 'Milos 4/29/2011 18:39'!
copy
	^ self shallowCopy withArray: array shallowCopy! !

!SMutantSet methodsFor: 'copying' stamp: 'Milos 4/29/2011 18:39'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!SMutantSet methodsFor: 'removing' stamp: 'Milos 4/29/2011 18:39'!
copyWithout: oldElement 
	"Answer a copy of the receiver that does not contain any
	elements equal to oldElement."

	^ self copy
		remove: oldElement ifAbsent: [];
		yourself! !

!SMutantSet methodsFor: 'enumerating' stamp: 'Milos 4/29/2011 18:39'!
do: aBlock 
	tally = 0 ifTrue: [^ self].
	1 to: array size do:
		[:index |
		| each |
		(each := array at: index) ifNotNil: [aBlock value: each]]! !

!SMutantSet methodsFor: 'enumerating' stamp: 'Milos 4/29/2011 18:39'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
fixCollisionsFrom: index
	"The element at index has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"

	| length oldIndex newIndex element |

	oldIndex := index.
	length := array size.
	[oldIndex = length
			ifTrue: [oldIndex := 1]
			ifFalse: [oldIndex := oldIndex + 1].
	(element := self keyAt: oldIndex) == nil]
		whileFalse: 
			[newIndex := self findElementOrNil: element.
			oldIndex = newIndex ifFalse: [self swap: oldIndex with: newIndex]]! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
grow
	"Grow the elements array and reinsert the old elements"
	| oldElements |
	oldElements := array.
	array := Array new: array size + self growSize.
	tally := 0.
	oldElements do:
		[:each | each == nil ifFalse: [self noCheckAdd: each]]! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
growSize
	^ array size max: 2! !

!SMutantSet methodsFor: 'explorer' stamp: 'Milos 4/29/2011 18:39'!
hasContentsInExplorer

	^self notEmpty! !

!SMutantSet methodsFor: 'testing' stamp: 'Milos 4/29/2011 18:39'!
includes: anObject 
	^ (array at: (self findElementOrNil: anObject)) ~~ nil! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
initialize: n
	"Initialize array to an array size of n"
	array := Array new: n.
	tally := 0! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
keyAt: index
	"May be overridden by subclasses so that fixCollisions will work"
	^ array at: index! !

!SMutantSet methodsFor: 'accessing' stamp: 'Milos 4/29/2011 18:39'!
like: anObject
	"Answer an object in the receiver that is equal to anObject,
	nil if no such object is found. Relies heavily on hash properties"

	| index |

	^(index := self scanFor: anObject) = 0
		ifFalse: [array at: index]! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject) put: anObject.
	tally := tally + 1! !

!SMutantSet methodsFor: 'testing' stamp: 'Milos 4/29/2011 18:39'!
occurrencesOf: anObject 
	^ (self includes: anObject) ifTrue: [1] ifFalse: [0]! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
rehash
	| newSelf |
	newSelf := self species new: self size.
	self do: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!SMutantSet methodsFor: 'removing' stamp: 'Milos 4/29/2011 18:39'!
remove: oldObject ifAbsent: aBlock

	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ oldObject! !

!SMutantSet methodsFor: 'removing' stamp: 'Milos 4/29/2011 18:39'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.
	
	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!SMutantSet methodsFor: 'enumerating' stamp: 'Milos 4/29/2011 18:39'!
select: aBlock 
	"Use copyEmpty instead of self species new to give subclasses a chance to initialize additional inst vars."

	"Note: this code could be moved to super"
	
	| newCollection |
	newCollection := self copyEmpty.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!SMutantSet methodsFor: 'accessing' stamp: 'Milos 4/29/2011 18:39'!
size
	^ tally! !

!SMutantSet methodsFor: 'accessing' stamp: 'Milos 4/29/2011 18:39'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
swap: oneIndex with: otherIndex
	"May be overridden by subclasses so that fixCollisions will work"

	array swap: oneIndex with: otherIndex
! !

!SMutantSet methodsFor: 'enumerating' stamp: 'Milos 4/29/2011 18:39'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

!SMutantSet methodsFor: 'private' stamp: 'Milos 4/29/2011 18:39'!
withArray: anArray
	"private -- for use only in copy"
	array := anArray! !

TestRunner subclass: #MutationTestRunner
	instanceVariableNames: 'operators operatorIndex operatorsSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-GUI'!

!MutationTestRunner commentStamp: 'Sandro 3/18/2011 14:09' prior: 0!
A MutationTestRunner is a TestRunner that automatically does mutation testing on mutation test suites.
To show the gui run the folowing message - MutationTestRunner open.

Instance Variables
!

!MutationTestRunner class methodsFor: 'instance-creation' stamp: 'Milos 4/19/2011 16:46'!
open
	| instance |
	
	instance := self new.
	instance selectNoCategories.
	instance selectNoClasses.
	^ ToolBuilder open: instance.! !

!MutationTestRunner methodsFor: 'testing' stamp: 'Milos 4/24/2011 23:39'!
alwaysTrue
	^ true! !

!MutationTestRunner methodsFor: 'accessing' stamp: 'Sandro 3/18/2011 14:04'!
baseClass
	^ MutationTestCase! !

!MutationTestRunner methodsFor: 'building' stamp: 'Milos 4/24/2011 23:11'!
buildOperatorListWith: aBuilder
	^ aBuilder pluggableMultiSelectionListSpec new
		model: self;
		list: #operatorList;
		menu: #operatorMenu:;
		getIndex: #operatorSelected;
		setIndex: #operatorSelected:;
		getSelectionList: #operatorAt:;
		setSelectionList: #operatorAt:put:;
		yourself.! !

!MutationTestRunner methodsFor: 'building' stamp: 'Milos 4/24/2011 22:55'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.92 );
				yourself);
			add: ((self buildClassesWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.92 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildOperatorListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.92);
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (0.00 @ 0.92 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		yourself.
	^ aBuilder build: window.! !

!MutationTestRunner methodsFor: 'accessing-ui' stamp: 'Milos 4/16/2011 20:04'!
buttons
	^ #(( 'Run Selected' #runAll #hasRunnable )
		"( 'Select All Classes' #selectAllClasses #alwaysTrue )
		( 'Deselect All Classes' #selectNoClasses #hasRunnable )"
	).! !

!MutationTestRunner methodsFor: 'accessing-testing' stamp: 'Milos 4/19/2011 20:37'!
errorSelected: anInteger
	errorSelected := errorList at: anInteger ifAbsent: nil.
	self changed: #errorSelected.! !

!MutationTestRunner methodsFor: 'testing' stamp: 'Milos 4/25/2011 00:58'!
hasRunnable
	^ classesSelected notEmpty and: [operatorsSelected notEmpty]! !

!MutationTestRunner methodsFor: 'initialization' stamp: 'Milos 4/24/2011 23:14'!
initialize
	super initialize.
	operatorIndex := 0! !

!MutationTestRunner methodsFor: 'accessing-ui' stamp: 'Sandro 3/18/2011 13:47'!
label
	^ 'Mutation Runner'! !

!MutationTestRunner methodsFor: 'private' stamp: 'Milos 4/19/2011 20:28'!
label: aString forSuite: aTestSuite
	^ String streamContents: [ :stream |
		stream nextPutAll: 'Running '; print: aTestSuite tests size; space; nextPutAll: 'Mutation'.
		aTestSuite tests size > 1 ifTrue: [ stream nextPut: $s ] ]. ! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/25/2011 01:08'!
operatorAt: anInteger
	^ operatorsSelected includes: (operators at: anInteger ifAbsent: [ ^ false ]).! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/25/2011 00:39'!
operatorAt: anInteger put: aBoolean
	operatorsSelected := operatorsSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (operators at: anInteger ifAbsent: [ ^ self ]).
	self changed: #operatorSelected; changed: #hasRunnable! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/24/2011 23:28'!
operatorList
	^ operators! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/25/2011 15:06'!
operatorMenu: aMenu
	^ aMenu
		title: 'Mutation Operators';
		add: 'Select all' action: #selectAllOperators;
		add: 'Select inversion' action: #selectInverseOperators;
		add: 'Select none' action: #selectNoOperators;
		addLine;
		add: 'Refresh' action: #updateOperators;
		yourself.! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/24/2011 23:13'!
operatorSelected
	^ operatorIndex! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/25/2011 00:40'!
operatorSelected: anInteger
	operatorIndex := anInteger.
	self changed: #operatorSelected! !

!MutationTestRunner methodsFor: 'private' stamp: 'Milos 4/25/2011 15:26'!
operatorsSelectedTrimmed
	^ operatorsSelected collect: [ :operator | operator asString withBlanksTrimmed ]! !

!MutationTestRunner methodsFor: 'mapping' stamp: 'Milos 4/25/2011 15:25'!
operatorsToFactories
	| factories retroReplacementOperators operatorsSelectedTrimmed |
	factories := OrderedCollection new.
	retroReplacementOperators := OrderedCollection new.
	operatorsSelectedTrimmed := self operatorsSelectedTrimmed.
	(operatorsSelectedTrimmed includes: #callOperator)
		ifTrue: [ factories add: (CallMutationFactory mutationClasses: nil) ].
	operatorsSelectedTrimmed
		do: [ :operatorRuntimeName | 
			| operator |
			operator := RetroReplacementOperatorFactory singleton runtime: operatorRuntimeName.
			operator ifNotNil: [ retroReplacementOperators add: operator ] ].
	factories
		add:
			((RetroMutationFactory mutationClasses: nil replacementOperators: nil) replacementOperators: retroReplacementOperators).
	^ factories! !

!MutationTestRunner methodsFor: 'actions' stamp: 'Milos 4/19/2011 14:37'!
reset
	self result: MutationTestResult new; updateResults.! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/25/2011 15:05'!
selectAllOperators
	operatorsSelected := operators asSet.
	self
		changed: #allSelections;
		changed: #operatorSelected;
		changed: #hasRunnable! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/25/2011 15:05'!
selectInverseOperators
	operatorsSelected := operators asSet 
		removeAll: operatorsSelected;
		yourself.
	self
		changed: #allSelections;
		changed: #operatorSelected;
		changed: #hasRunnable! !

!MutationTestRunner methodsFor: 'accessing-operators' stamp: 'Milos 4/25/2011 15:05'!
selectNoOperators
	operatorsSelected := Set new.
	self
		changed: #allSelections;
		changed: #operatorSelected;
		changed: #hasRunnable! !

!MutationTestRunner methodsFor: 'accessing' stamp: 'Milos 4/25/2011 00:28'!
suiteAll
	^ TestSuite new
		in: [ :suite | 
			classesSelected
				do: [ :each | 
					each isAbstract
						ifFalse: [ each addToSuiteFromSelectors: suite factories: self operatorsToFactories ] ].
			suite name: (self label: 'Test' forSuite: suite) ]! !

!MutationTestRunner methodsFor: 'updating' stamp: 'Milos 4/24/2011 23:24'!
update
	super update.
	self updateOperators! !

!MutationTestRunner methodsFor: 'updating' stamp: 'Milos 5/26/2011 09:28'!
updateOperators
	| ident |
	ident := String new: 2 withAll: $ .
	operators := OrderedCollection new.
	operators add: (CallMutationFactory name asText addAttribute: TextEmphasis italic).
	operators add: ident , #callOperator.
	operators add: (RetroReplacementOperatorFactory singleton aorName asText addAttribute: TextEmphasis italic).
	RetroReplacementOperatorFactory singleton aor
		do: [ :operator | operators add: ident , operator asString ].
	operators add: (RetroReplacementOperatorFactory singleton rorName asText addAttribute: TextEmphasis italic).
	RetroReplacementOperatorFactory singleton ror
		do: [ :operator | operators add: ident , operator asString ].
	operators add: (RetroReplacementOperatorFactory singleton corName asText addAttribute: TextEmphasis italic).
	RetroReplacementOperatorFactory singleton cor
		do: [ :operator | operators add: ident , operator asString ].
	operatorIndex := 0.
	operatorsSelected := Set new.
	self
		changed: #operatorList;
		changed: #operatorSelected;
		changed: #hasRunnable! !

Object subclass: #AllDifferentMessages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!AllDifferentMessages commentStamp: 'Milos 4/7/2011 10:37' prior: 0!
AllDifferentMessages is used to test StaticMutations.

Instance Variables
!

!AllDifferentMessages methodsFor: 'testing' stamp: 'Milos 4/7/2011 10:33'!
message0
	"no args"! !

!AllDifferentMessages methodsFor: 'testing' stamp: 'Milos 4/7/2011 10:34'!
message1: anArg
	"one arg"! !

!AllDifferentMessages methodsFor: 'testing' stamp: 'Milos 4/7/2011 10:34'!
message2: anArg1 and: anArg2
	"two args"! !

Object subclass: #AllSameMessages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!AllSameMessages commentStamp: 'Milos 4/7/2011 10:38' prior: 0!
AllSameMessages is used to test StaticMutations.

Instance Variables
!

!AllSameMessages methodsFor: 'testing' stamp: 'Milos 4/7/2011 10:35'!
message0: anArg! !

!AllSameMessages methodsFor: 'testing' stamp: 'Milos 4/7/2011 10:35'!
message1: anArg! !

!AllSameMessages methodsFor: 'testing' stamp: 'Milos 4/7/2011 10:35'!
message2: anArg! !

Object subclass: #BankAccount
	instanceVariableNames: 'balance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!BankAccount class methodsFor: 'initialization' stamp: 'Milos 3/13/2011 19:20'!
balance: aBalance
	^super new balance: aBalance.! !

!BankAccount class methodsFor: 'instance creation' stamp: 'Milos 3/13/2011 19:22'!
new
	self error: 'use balance to create an object'.! !

!BankAccount methodsFor: 'accessing' stamp: 'Milos 3/13/2011 18:51'!
balance
	^balance.! !

!BankAccount methodsFor: 'private' stamp: 'Milos 3/13/2011 19:19'!
balance: aBalance
	balance := aBalance.! !

!BankAccount methodsFor: 'banking' stamp: 'Milos 4/23/2011 10:01'!
deposit: anAmount
	balance := balance + anAmount.! !

!BankAccount methodsFor: 'banking' stamp: 'Milos 3/13/2011 19:12'!
withdraw: anAmount
	balance >= anAmount
		ifTrue: [balance := balance - anAmount].! !

Object subclass: #ConditionalExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!ConditionalExample methodsFor: 'examples' stamp: 'Milos 5/25/2011 21:14'!
andToOr
	| a b c |
	c := a and: b! !

Object subclass: #Falsifier
	instanceVariableNames: 'classesToMutate classesWithTests newClassesToMutate newClassesWithTests oldToNewNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!Falsifier commentStamp: 'Milos 5/26/2011 10:29' prior: 0!
Copies classes to be mutated and test classes (avoid system modifications during mutation testing).  Also it replaces all occurrences of class names as appropriate. At this point, we do not look at class hierarchy and interaction with other classes.

Instance Variables
!

!Falsifier class methodsFor: 'as yet unclassified' stamp: 'Milos 5/26/2011 13:27'!
falsify: theClassesToMutate and: theClassesWithTests
	^ self new setFalsify: theClassesToMutate and: theClassesWithTests! !

!Falsifier methodsFor: 'actions' stamp: 'Milos 5/26/2011 13:38'!
duplicateClasses: theClasses andSaveIn: theNewClasses
	theClasses
		do: [ :class | 
			| newClass |
			newClass := class duplicateClassWithNewName: self prefix , class name.
			theNewClasses add: newClass.
			oldToNewNames at: class name asSymbol put: newClass name asSymbol ]! !

!Falsifier methodsFor: 'accessing' stamp: 'Milos 5/26/2011 13:08'!
newNameFor: aSymbol
	(oldToNewNames includesKey: aSymbol)
		ifTrue: [ ^ oldToNewNames at: aSymbol ]
		ifFalse: [ ^ nil ]! !

!Falsifier methodsFor: 'private' stamp: 'Milos 5/26/2011 10:18'!
prefix
	^ 'False'! !

!Falsifier methodsFor: 'actions' stamp: 'Milos 5/26/2011 13:55'!
renameInAllClasses: theClasses
	theClasses
		do: [ :newClass | 
			self renameInClass: newClass.
			self renameInClass: newClass class ]! !

!Falsifier methodsFor: 'actions' stamp: 'Milos 5/26/2011 13:51'!
renameInClass: aClass
	aClass selectors do: [ :each | self renameInClass: aClass inSelector: each ]! !

!Falsifier methodsFor: 'actions' stamp: 'Milos 5/26/2011 13:33'!
renameInClass: aClass inSelector: aSelector
	| methodTree rewriter |
	rewriter := FalsifierTreeRewriter withFalsifier: self.
	methodTree := (aClass methodDict at: aSelector) parseTree.
	rewriter acceptMethodNode: methodTree.
	aClass compile: methodTree formattedCode! !

!Falsifier methodsFor: 'actions' stamp: 'Milos 5/26/2011 13:41'!
setFalsify: theClassesToMutate and: theClassesWithTests
	oldToNewNames := Dictionary new.
	classesToMutate := theClassesToMutate.
	classesWithTests := theClassesWithTests.
	newClassesToMutate := OrderedCollection new.
	newClassesWithTests := OrderedCollection new.
	self duplicateClasses: classesToMutate andSaveIn: newClassesToMutate.
	self duplicateClasses: classesWithTests andSaveIn: newClassesWithTests.
	self renameInAllClasses: newClassesToMutate.
	self renameInAllClasses: newClassesWithTests! !

Object subclass: #FalsifierExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!FalsifierExample class methodsFor: 'as yet unclassified' stamp: 'Milos 5/26/2011 13:56'!
testing
	^ FalsifierExample new! !

!FalsifierExample methodsFor: 'as yet unclassified' stamp: 'Milos 5/26/2011 13:56'!
mmm
	| tmp |
	tmp := false.
	tmp := 33.
	tmp := FalsifierExample new! !

Object subclass: #MessageInterceptor
	instanceVariableNames: 'reference method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MessageInterceptor commentStamp: 'Milos 4/29/2011 16:02' prior: 0!
Instances of this class can be used as the replacement for existing methods in any class.

Instance Variables
	method:		<Object>
	reference:		<Object>

method
	- xxxxx

reference
	- xxxxx
!

!MessageInterceptor class methodsFor: 'initialize-release' stamp: 'Milos 4/12/2011 14:35'!
on: aMethodReference
	^self new initializeOn: aMethodReference.! !

!MessageInterceptor methodsFor: 'private' stamp: 'Milos 3/14/2011 23:59'!
flushCache! !

!MessageInterceptor methodsFor: 'actions' stamp: 'Milos 4/7/2011 10:07'!
install
	reference actualClass methodDictionary
		at: reference methodSymbol
		put: self.! !

!MessageInterceptor methodsFor: 'evaluation' stamp: 'Milos 3/16/2011 15:51'!
run: aSelector with: anArray in: aReceiver
	self subclassResponsibility.! !

!MessageInterceptor methodsFor: 'actions' stamp: 'Milos 3/14/2011 23:04'!
uninstall
	reference actualClass methodDictionary
		at: reference methodSymbol
		put: method.! !

MessageInterceptor subclass: #NewMessageInterceptor
	instanceVariableNames: 'mutationRunner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!NewMessageInterceptor commentStamp: 'Milos 4/29/2011 16:03' prior: 0!
A concrete implementation of a message interceptor; this intercepts calls to 'new'.

Instance Variables
	mutationRunner:		<Object>

mutationRunner
	- xxxxx
!

!NewMessageInterceptor class methodsFor: 'instance creation' stamp: 'Milos 4/8/2011 10:43'!
initializeWithRunner: aMutationRunner
	| instance |
	instance := super new.
	instance initializeWithRunner: aMutationRunner.
	^instance.! !

!NewMessageInterceptor class methodsFor: 'instance creation' stamp: 'Sandro 3/16/2011 17:38'!
new
	self error: 'Do not call new'.! !

!NewMessageInterceptor methodsFor: 'initialization' stamp: 'Milos 4/8/2011 10:42'!
initializeWithRunner: aMutationRunner
	mutationRunner := aMutationRunner.
	reference := (Behavior methodDictionary at: #new) methodReference.
	method := reference compiledMethod.! !

!NewMessageInterceptor methodsFor: 'evaluation' stamp: 'Milos 4/16/2011 14:03'!
run: aSelector with: anArray in: aReceiver
	| instance mutationClasses |

	instance := aReceiver withArgs: anArray executeMethod: method.
	(mutationRunner mutationClasses includes: instance class)
		ifTrue: [mutationRunner mutationObjects add: instance].
	^ instance.

"Version with object proxy."
"	mutationClasses := mutationRunner mutationClasses.
	(mutationClasses includes: instance class) ifTrue: [
		^ MutantObjectProxy initializeWithRunner: mutationRunner proxy: instance.
	] ifFalse: [
		^instance.
	]"! !

Object subclass: #MessageReplacer
	instanceVariableNames: 'originalMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-GUI'!

MessageReplacer subclass: #MainMenuItemsMessageReplacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-GUI'!

!MainMenuItemsMessageReplacer methodsFor: 'evaluation' stamp: 'Milos 4/13/2011 00:26'!
run: aSelector with: anArray in: aReceiver

	^#(
		('Class Browser' 			#openClassBrowser)
		('Workspace'				#openWorkspace)
		('Test Runner'				#openTestRunner)
		('Mutation Runner'		#openMutationRunner)
		('Monticello Browser'		#openMonticelloBrowser)
	).! !

MessageReplacer subclass: #MenuItemsReplacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-GUI'!

!MenuItemsReplacer methodsFor: 'evaluation' stamp: 'Milos 4/16/2011 10:32'!
run: aSelector with: anArray in: aReceiver
	^#(
		('Class Browser' 			#openClassBrowser)
		('Message Names'				#openMessageNames)
		('Method Finder'				#openMethodFinder)
		-
		('Workspace'					#openWorkspace)
		('Transcript' 				#openTranscript)
		('File Browser'				#openFileList)
		-
		('Test Runner'				#openTestRunner)
		('Mutation Runner'			#openMutationRunner)
		('Process Browser' 			#openProcessBrowser)
		-
		('Monticello Browser'		#openMonticelloBrowser)
		"('Monticello Configurations' #openMonticelloConfigurations)"
		('Recover lost changes...'	#openRecentChangesLog)
		"('Simple Change Sorter'		#openChangeSorter)"
		('Change Sorter'				#openDualChangeSorter)
	).! !

!MessageReplacer class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 21:28'!
originalMethod: theOriginalMethod
	^ super new originalMethod: theOriginalMethod! !

!MessageReplacer methodsFor: 'error handling' stamp: 'Milos 4/24/2011 21:31'!
doesNotUnderstand: aMessage
	^ originalMethod perform: aMessage selector withArguments: aMessage arguments! !

!MessageReplacer methodsFor: 'private' stamp: 'Milos 4/12/2011 20:41'!
flushCache! !

!MessageReplacer methodsFor: 'accessing' stamp: 'Milos 4/24/2011 21:26'!
originalMethod
	^ originalMethod! !

!MessageReplacer methodsFor: 'accessing' stamp: 'Milos 4/24/2011 21:26'!
originalMethod: theOriginalMethod
	originalMethod := theOriginalMethod! !

MessageReplacer subclass: #MethodProxy
	instanceVariableNames: 'mutationRunner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MethodProxy commentStamp: 'Milos 4/29/2011 15:17' prior: 0!
Used for call mutations to intercept each method call and perform a mutation if appropriate.

Instance Variables
!

!MethodProxy class methodsFor: 'initialization' stamp: 'Milos 4/16/2011 11:17'!
initializeWithRunner: aMutationRunner

	^ super new initializeWithRunner: aMutationRunner.! !

!MethodProxy class methodsFor: 'instance creation' stamp: 'Milos 4/16/2011 11:17'!
new
	
	self error: 'Do not use new!!'.! !

!MethodProxy methodsFor: 'initialization' stamp: 'Milos 4/16/2011 11:15'!
initializeWithRunner: aMutationRunner

	mutationRunner := aMutationRunner.! !

!MethodProxy methodsFor: 'evaluation' stamp: 'Milos 4/16/2011 14:11'!
run: aSelector with: anArray in: aReceiver
	| currentMutation selector |

	currentMutation := mutationRunner currentMutation.
	((mutationRunner mutationObjects includes: aReceiver) and: [currentMutation originalSelector = aSelector])
		ifTrue: [currentMutation hit: true. selector := currentMutation replacementSelector]
		ifFalse: [selector := aSelector].
	
	^ aReceiver withArgs: anArray executeMethod: ((mutationRunner classToDict at: (aReceiver class)) at: selector).

"	(currentMutation originalSelector = aMessage selector)
		ifTrue: [
			currentMutation hit: true.
			selector := currentMutation replacementSelector.
		] ifFalse: [
			selector := aMessage selector
		].
	^ realSubject perform: selector withArguments: (aMessage arguments). "
	
"	^ self perform: aSelector withArguments: anArray."! !

MessageReplacer subclass: #QuitSessionReplacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-GUI'!

!QuitSessionReplacer methodsFor: 'evaluation' stamp: 'Milos 5/3/2011 11:30'!
run: aSelector with: anArray in: aReceiver
	SmalltalkImage current snapshot: false andQuit: true! !

Object subclass: #Mutation
	instanceVariableNames: 'mutatedClass originalMessage replacementMessage killed hit installationStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!Mutation commentStamp: 'Milos 4/29/2011 15:16' prior: 0!
A concrete mutation to be performed on the original code.  Contains a strategy for the (un)installation and the information that is required to perform the mutation.

Instance Variables
	inClass:		<Object>
	originalMessage:		<Object>
	replacementMessage:		<Object>

inClass
	- xxxxx

originalMessage
	- xxxxx

replacementMessage
	- xxxxx
!

!Mutation class methodsFor: 'instance creation' stamp: 'Milos 4/23/2011 14:03'!
in: aClass original: anOriginalMessage replace: aReplacementMessage installationStrategy: anInstallationStarategy
	^super new in: aClass original: anOriginalMessage replace: aReplacementMessage installationStrategy: anInstallationStarategy.! !

!Mutation class methodsFor: 'instance creation' stamp: 'Milos 4/7/2011 09:25'!
new
	self error: 'Do not use new'.! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/10/2011 21:12'!
hit
	^hit.! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/10/2011 21:12'!
hit: aBoolean
	hit := aBoolean.! !

!Mutation methodsFor: 'initialize-release' stamp: 'Milos 4/23/2011 14:06'!
in: aClass original: anOriginalMessage replace: aReplacementMessage installationStrategy: anInstallationStrategy
	mutatedClass := aClass.
	originalMessage := anOriginalMessage.
	replacementMessage := aReplacementMessage.
	installationStrategy := anInstallationStrategy.
	killed := false.
	hit := false.! !

!Mutation methodsFor: 'testing' stamp: 'Milos 4/10/2011 20:33'!
includes: aClass origMsgName: anOriginaMessageName replMsgName: aReplacementMessageName
	^(mutatedClass = aClass
		and: [self originalSelector nameForViewer = anOriginaMessageName ]
		and: [self replacementSelector nameForViewer = aReplacementMessageName]).! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/23/2011 14:06'!
installationStrategy
	^ installationStrategy! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/8/2011 11:18'!
killed
	^killed.! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/8/2011 11:18'!
killed: aBoolean
	killed := aBoolean.! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/8/2011 11:07'!
mutatedClass
	^mutatedClass.! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/7/2011 09:22'!
originalMessage
	^originalMessage.! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/8/2011 11:03'!
originalSelector
	^originalMessage selector.! !

!Mutation methodsFor: 'printing' stamp: 'Milos 5/7/2011 12:16'!
printOn: aStream
	aStream
		nextPutAll: mutatedClass printString;
		nextPutAll: '>>#';
		nextPutAll: self originalSelector;
		nextPutAll: '=>';
		nextPutAll: '#';
		nextPutAll: self replacementSelector! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/7/2011 09:22'!
replacementMessage
	^replacementMessage.! !

!Mutation methodsFor: 'accessing' stamp: 'Milos 4/8/2011 11:07'!
replacementSelector
	^replacementMessage selector.! !

Mutation subclass: #RetroMutation
	instanceVariableNames: 'operator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!RetroMutation class methodsFor: 'instance creation' stamp: 'Milos 5/7/2011 11:59'!
in: aClass original: anOriginalMessage replace: aReplacementMessage because: anOperator installationStrategy: anInstallationStarategy
	| instance |
	instance := super in: aClass original: anOriginalMessage replace: aReplacementMessage installationStrategy: anInstallationStarategy.
	instance operator: anOperator.
	^ instance! !

!RetroMutation class methodsFor: 'instance creation' stamp: 'Milos 5/7/2011 11:55'!
in: aClass original: anOriginalMessage replace: aReplacementMessage installationStrategy: anInstallationStarategy
	self error: 'See constructors!!'! !

!RetroMutation methodsFor: 'accessing' stamp: 'Milos 5/7/2011 11:56'!
operator
	^ operator! !

!RetroMutation methodsFor: 'accessing' stamp: 'Milos 5/7/2011 11:56'!
operator: anOperator
	operator := anOperator! !

!RetroMutation methodsFor: 'printing' stamp: 'Milos 5/7/2011 12:20'!
printOn: aStream
	aStream
		nextPutAll: mutatedClass printString;
		nextPutAll: '>>#';
		nextPutAll: self originalSelector;
		nextPutAll: '    #';
		nextPutAll: operator first;
		nextPutAll: '=>';
		nextPutAll: '#';
		nextPutAll: operator second! !

Object subclass: #MutationConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MutationConfig commentStamp: 'Milos 4/29/2011 15:20' prior: 0!
TODO: delete/refactor. Contains the information about the timeout for single mutation test.

Instance Variables
!

!MutationConfig class methodsFor: 'constants' stamp: 'Sandro 4/20/2011 22:44'!
maxSecondsPerMutation
	"Max time to execute test suite for each mutation. TODO: base on original test suite."

	^ 5.! !

Object subclass: #MutationFactory
	instanceVariableNames: 'mutationClasses mutations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MutationFactory commentStamp: 'Milos 4/29/2011 15:27' prior: 0!
An Abstract Mutation Factory that is used to create mutation instances for the given set of classes.

Instance Variables
	mutationClasses:		<Object>
	mutations:		<Object>

mutationClasses
	- xxxxx

mutations
	- xxxxx
!

MutationFactory subclass: #CallMutationFactory
	instanceVariableNames: 'callInstallationStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!CallMutationFactory commentStamp: 'Milos 4/29/2011 15:27' prior: 0!
A Concrete Mutation Factory. For each message (from the classes under mutation testing) it finds all possible replacements. Replacements are messages that belong to the same class and have the same number of arguments.

Instance Variables
	mutationClasses:		<Object>

mutationClasses
	- xxxxx
!

!CallMutationFactory methodsFor: 'creating' stamp: 'Milos 4/23/2011 14:11'!
createInstallationStrategy
	callInstallationStrategy ifNil: [ callInstallationStrategy := CallMutationInstallationStrategy new ].
	^ callInstallationStrategy! !

!CallMutationFactory methodsFor: 'creating' stamp: 'Milos 4/24/2011 01:47'!
createMutationsForClass: aClass
	aClass
		methodsDo: [ :method1 | 
			aClass
				methodsDo: [ :method2 | 
					(method1 name ~= method2 name
						and: [ method1 numArgs = method2 numArgs ]
						and: [ (self shouldIgnore: method1 selector) not ]
						and: [ (self shouldIgnore: method2 selector) not ])
						ifTrue: [ 
							mutations
								add:
									(Mutation
										in: aClass
										original: method1
										replace: method2
										installationStrategy: self createInstallationStrategy) ] ] ]! !

!CallMutationFactory methodsFor: 'private' stamp: 'Milos 4/23/2011 10:07'!
shouldIgnore: aSelector
	^ (ProtoObject selectors includes: aSelector).! !

!MutationFactory class methodsFor: 'instance creation' stamp: 'Milos 4/23/2011 10:52'!
mutationClasses: theMutationClasses
	^ super new mutationClasses: theMutationClasses! !

!MutationFactory class methodsFor: 'instance creation' stamp: 'Milos 4/23/2011 10:45'!
new
	self error: 'Do not use new!!'! !

!MutationFactory methodsFor: 'creating' stamp: 'Milos 4/23/2011 14:10'!
createInstallationStrategy
	^ self subclassResponsibility! !

!MutationFactory methodsFor: 'creating' stamp: 'Sandro 4/23/2011 16:35'!
createMutations
	(mutationClasses asOrderedCollection) do: [ :mutationClass | self createMutationsForClass: mutationClass ]! !

!MutationFactory methodsFor: 'creating' stamp: 'Milos 4/23/2011 13:38'!
createMutationsForClass: aClass
	^ self subclassresponsibility! !

!MutationFactory methodsFor: 'testing' stamp: 'Milos 4/23/2011 10:44'!
includes: aClass origMsgName: anOriginalMessageName replMsgName: aReplacementMessageName
	mutations
		do: [ :mutation | 
			(mutation includes: aClass origMsgName: anOriginalMessageName replMsgName: aReplacementMessageName)
				ifTrue: [ ^ true ] ].
	^ false! !

!MutationFactory methodsFor: 'initialize-release' stamp: 'Milos 4/23/2011 10:44'!
mutationClasses: theMutationClasses
	mutationClasses := theMutationClasses.
	mutations := OrderedCollection new! !

!MutationFactory methodsFor: 'accessing' stamp: 'Milos 4/23/2011 10:44'!
mutations
	^ mutations! !

!MutationFactory methodsFor: 'accessing' stamp: 'Milos 4/23/2011 10:44'!
numOfMutations
	^ mutations size! !

MutationFactory subclass: #RetroMutationFactory
	instanceVariableNames: 'retroInstallationStrategy replacementOperators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!RetroMutationFactory commentStamp: 'Milos 4/29/2011 15:54' prior: 0!
A Concrete Mutation Factory. It creates the retro replacement mutations, e.g. changing + to -, at one specific point in the code (Note: as appose to call mutations each mutation does not replace all calls).

Instance Variables
	replacementOperators:		<Object>
	retroInstallationStrategy:		<Object>

replacementOperators
	- xxxxx

retroInstallationStrategy
	- xxxxx
!

!RetroMutationFactory class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 15:14'!
mutationClasses: theMutationClasses
	self error: 'Do not call mutationClasses!!'! !

!RetroMutationFactory class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 15:10'!
mutationClasses: theMutationClasses replacementOperators: theReplacementOperators
	^ (super mutationClasses: theMutationClasses) replacementOperators: theReplacementOperators! !

!RetroMutationFactory methodsFor: 'creating' stamp: 'Milos 4/23/2011 14:12'!
createInstallationStrategy
	retroInstallationStrategy ifNil: [ retroInstallationStrategy := RetroMutationInstallationStrategy new ].
	^ retroInstallationStrategy! !

!RetroMutationFactory methodsFor: 'creating' stamp: 'Milos 4/24/2011 15:31'!
createMutationsForClass: aClass
	replacementOperators
		do: [ :operator | aClass selectors do: [ :selector | self createMutationsForClass: aClass andOperator: operator andSelector: selector ] ]! !

!RetroMutationFactory methodsFor: 'creating' stamp: 'Milos 5/7/2011 11:58'!
createMutationsForClass: aClass andOperator: anOperator andSelector: aSelector
	| methodTree initialMessage rewriter |
	rewriter := MutationTreeRewriter new foundMutation: true.
	initialMessage := self numOfMutations.
	[ rewriter foundMutation ]
		whileTrue: [ 
			rewriter foundMutation: false mutateMessageId: self numOfMutations currentMessageId: initialMessage operator: anOperator.
			methodTree := (aClass methodDict at: aSelector) parseTree.
			rewriter acceptMethodNode: methodTree.
			rewriter foundMutation
				ifTrue: [ 
					| originalMethod replacementMethod |
					originalMethod := aClass methodDict at: aSelector.
					aClass compile: methodTree formattedCode. "Replaces the original method with the mutated method"
					replacementMethod := aClass methodDict at: aSelector.
					aClass methodDict at: aSelector put: originalMethod. "Puts the original method back into the class"
					mutations add: (RetroMutation in: aClass original: originalMethod replace: replacementMethod because: anOperator installationStrategy: self createInstallationStrategy) ] ]! !

!RetroMutationFactory methodsFor: 'initialize-release' stamp: 'Milos 4/24/2011 15:08'!
replacementOperators: theReplacementOperators
	replacementOperators := theReplacementOperators! !

Object subclass: #MutationInstallationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MutationInstallationStrategy commentStamp: 'Milos 4/29/2011 15:33' prior: 0!
A Strategy for installing and uninstalling mutations.  Installation/uninstallation are called before/after execution of each mutation.

Instance Variables
!

MutationInstallationStrategy subclass: #CallMutationInstallationStrategy
	instanceVariableNames: 'newMessageInterceptor mutation mutationTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!CallMutationInstallationStrategy commentStamp: 'Milos 4/29/2011 15:40' prior: 0!
A Concrete Installation Strategy. Replaces the new message in Behavior with a proxy message that monitors for the creation of objects that should be mutated.

Instance Variables
	mutation:		<Object>
	mutationTester:		<Object>
	newMessageInterceptor:		<Object>

mutation
	- xxxxx

mutationTester
	- xxxxx

newMessageInterceptor
	- xxxxx
!

!CallMutationInstallationStrategy methodsFor: 'installing' stamp: 'Milos 4/23/2011 15:16'!
installMutation: aMutation whileRunning: aMutationTester
	mutation := aMutation.
	mutationTester := aMutationTester.
	newMessageInterceptor := NewMessageInterceptor initializeWithRunner: aMutationTester.
	newMessageInterceptor install.
	self instrumetClassesToMutateWithMethodProxy! !

!CallMutationInstallationStrategy methodsFor: 'actions' stamp: 'Milos 4/23/2011 14:26'!
instrumetClassesToMutateWithMethodProxy
	"Save method dict for each class that should be mutated."

	mutationTester mutationClasses do: [ :class | mutationTester classToDict at: class put: class methodDict copy ].
	mutationTester mutationClasses
		do: [ :class | class selectors do: [ :selector | class methodDict at: selector put: mutationTester methodProxy ] ]! !

!CallMutationInstallationStrategy methodsFor: 'installing' stamp: 'Milos 4/23/2011 14:19'!
uninstallMutation: aMutation whileRunning: aMutationTester
	newMessageInterceptor uninstall.
	self uninstrumetClassesToMutateWithMethodProxy! !

!CallMutationInstallationStrategy methodsFor: 'actions' stamp: 'Milos 4/23/2011 14:27'!
uninstrumetClassesToMutateWithMethodProxy
	"Set the original method dict for each class that should have been mutated."

	mutationTester mutationClasses do: [ :class | class methodDict: (mutationTester classToDict at: class) ]! !

!MutationInstallationStrategy methodsFor: 'installing' stamp: 'Milos 4/23/2011 13:56'!
installMutation: aMutation whileRunning: aMutationTester
	^ self subclassResponsibility! !

!MutationInstallationStrategy methodsFor: 'installing' stamp: 'Milos 4/23/2011 13:59'!
uninstallMutation: aMutation whileRunning: aMutationTester
	^ self subclassResponsibility! !

MutationInstallationStrategy subclass: #RetroMutationInstallationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!RetroMutationInstallationStrategy commentStamp: 'Milos 4/29/2011 15:42' prior: 0!
A Concrete Installation Strategy.  Replaces the original code with that defined by the mutation.

Instance Variables
!

!RetroMutationInstallationStrategy methodsFor: 'installing' stamp: 'Sandro 4/23/2011 15:56'!
installMutation: aMutation whileRunning: aMutationTester
	aMutation mutatedClass methodDict at: (aMutation originalSelector) put: (aMutation replacementMessage).! !

!RetroMutationInstallationStrategy methodsFor: 'installing' stamp: 'Sandro 4/23/2011 15:56'!
uninstallMutation: aMutation whileRunning: aMutationTester
	aMutation mutatedClass methodDict at: (aMutation originalSelector) put: (aMutation originalMessage).! !

Object subclass: #MutationTester
	instanceVariableNames: 'testClasses mutationClasses mutationObjects currentMutation classToDict methodProxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MutationTester commentStamp: 'Milos 4/29/2011 15:05' prior: 0!
Executes the given test cases after the given mutation is applied.  It runs in three phases: (1) istalls the mutation; (2) executes all test cases; (3) uninstalls mutation.

Instance Variables
	mutationClasses:		<Object>
	testClasses:		<Object>

mutationClasses
	- xxxxx

testClasses
	- xxxxx
!

MutationTester subclass: #CmdMutationTester
	instanceVariableNames: 'mutations mutationFactories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!CmdMutationTester commentStamp: 'Milos 4/29/2011 15:11' prior: 0!
CmdMutationTester allows mutation testing to be done without using a GUI.  It generates all mutations for the given set of classes and executes set of given test cases for each generated mutantion.

Instance Variables
	mutationFactories:		<Object>
	mutations:		<Object>

mutationFactories
	- xxxxx

mutations
	- xxxxx
!

!CmdMutationTester class methodsFor: 'initialize-release' stamp: 'Milos 4/24/2011 03:10'!
testClasses: theTestClasses mutationClasses: theMutationClasses mutationFactories: theMutationFactories
	^ (super testClasses: theTestClasses mutationClasses: theMutationClasses) mutationFactories: theMutationFactories! !

!CmdMutationTester methodsFor: 'initialize-release' stamp: 'Milos 4/24/2011 03:10'!
mutationFactories: theMutationFactories
	mutationFactories := theMutationFactories.
	mutations := OrderedCollection new! !

!CmdMutationTester methodsFor: 'calculating' stamp: 'Milos 4/24/2011 01:18'!
mutationScore
	^ self numOfAllMutations ~= 0
		ifTrue: [ self numOfKilledMutations / self numOfAllMutations ]
		ifFalse: [ 0 ]! !

!CmdMutationTester methodsFor: 'calculating' stamp: 'Milos 4/24/2011 01:21'!
numOfAllMutations
	^ mutations size! !

!CmdMutationTester methodsFor: 'calculating' stamp: 'Milos 4/24/2011 01:20'!
numOfHitMutations
	^ mutations
		inject: 0
		into: [ :num :mutation | 
			num
				+
					(mutation hit
						ifTrue: [ 1 ]
						ifFalse: [ 0 ]) ]! !

!CmdMutationTester methodsFor: 'calculating' stamp: 'Milos 4/24/2011 01:21'!
numOfKilledMutations
	^ mutations
		inject: 0
		into: [ :num :mutation | 
			num
				+
					(mutation killed
						ifTrue: [ 1 ]
						ifFalse: [ 0 ]) ]! !

!CmdMutationTester methodsFor: 'actions' stamp: 'Milos 4/24/2011 14:46'!
runMutations
	"Main loop. for each mutant runs all test cases."
	| newMessageInterceptor beginTime endTime |

	beginTime := Time now.
	Transcript cr; show: 'MutationTesting start: '; show: Date today; show: ', '; show: beginTime; cr.

	mutationFactories do: [:mutationFactory | mutations addAll: mutationFactory createMutations mutations].
	mutations do: [:mutation |	self runSingleMutation: mutation	].

	endTime := Time now.
	Transcript show: 'MutationTesting finish: '; show: Date today; show: ', '; show: endTime; cr.
	Transcript show: 'MutationTesting elapsed time: '; show: (endTime subtractTime: beginTime) asSeconds; show: 's'; cr.

	Transcript show: Character cr.
	Transcript show: 'numOfAllMutations = '; show: (self numOfAllMutations); show: Character cr.
	Transcript show: 'numOfHitMutations = '; show: (self numOfHitMutations); show: Character cr.
	Transcript show: 'numOfKilledMutations = '; show: (self numOfKilledMutations); show: Character cr.
	Transcript show: 'mutationScore = '; show: (self mutationScore); show: Character cr.
! !

!MutationTester class methodsFor: 'initialize-release' stamp: 'Milos 4/24/2011 01:33'!
new
	self error: 'Do not use new!!'! !

!MutationTester class methodsFor: 'initialize-release' stamp: 'Milos 4/24/2011 03:11'!
testClasses: theTestClasses mutationClasses: theMutationClasses
	^ super new testClasses: theTestClasses mutationClasses: theMutationClasses! !

!MutationTester methodsFor: 'accessing' stamp: 'Milos 4/24/2011 00:56'!
classToDict
	^ classToDict! !

!MutationTester methodsFor: 'accessing' stamp: 'Milos 4/24/2011 00:57'!
currentMutation
	^ currentMutation! !

!MutationTester methodsFor: 'accessing' stamp: 'Milos 4/23/2011 15:42'!
methodProxy
	^ methodProxy! !

!MutationTester methodsFor: 'accessing' stamp: 'Milos 4/24/2011 03:09'!
mutationClasses
	^ mutationClasses! !

!MutationTester methodsFor: 'accessing' stamp: 'Milos 4/24/2011 00:57'!
mutationObjects
	^ mutationObjects! !

!MutationTester methodsFor: 'private' stamp: 'Milos 4/24/2011 00:55'!
runAllTestCases
	"Runs all test cases until the result is negative (mutant is killed)."

	testClasses
		do: [ :testClass | 
			testClass
				ifNotNil: [ 
					[ 
					| result |
					result := testClass suite run.
					currentMutation killed: result hasPassed not.
					currentMutation killed
						ifTrue: [ ^ self ] ]
						valueWithin: (Duration seconds: MutationConfig maxSecondsPerMutation)
						onTimeout: [ currentMutation killed: true ] ] ]
"
	testClasses do:
		[:testClass |
			(testClass) ifNotNil: [
				| testSuiteProcess timeToTest success |
				timeToTest := DelayWaitTimeout forSeconds: MutationConfig maxSecondsPerMutation.
				success := false.
				testSuiteProcess := [
					testResult := testClass suite run.
					currentMutation killed: testResult hasPassed not.
					success := true.
					timeToTest signalWaitingProcess.
				] fork.
				timeToTest wait.
				(success not)
					ifTrue: [
						testSuiteProcess terminate.
						currentMutation killed: true.
					].
				(currentMutation killed)
					ifTrue: [^ self].
			]
		].
	"! !

!MutationTester methodsFor: 'private' stamp: 'Milos 4/23/2011 14:27'!
runSingleMutation: theMutation
	currentMutation := theMutation.
	currentMutation installationStrategy installMutation: currentMutation whileRunning: self.
	[ self runAllTestCases ]
		ensure: [ currentMutation installationStrategy uninstallMutation: currentMutation whileRunning: self ]! !

!MutationTester methodsFor: 'actions' stamp: 'Milos 4/24/2011 03:11'!
testClasses: theTestClasses mutationClasses: theMutationClasses
	testClasses := theTestClasses.
	mutationClasses := theMutationClasses.
	mutationObjects := OrderedCollection new.
	classToDict := Dictionary new.
	methodProxy := MethodProxy initializeWithRunner: self! !

Object subclass: #PlusExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!PlusExample methodsFor: 'examples' stamp: 'Milos 4/24/2011 17:46'!
methodWithPlus: a and: b
	| c |
	c := a + b.
	^ c! !

!PlusExample methodsFor: 'examples' stamp: 'Milos 4/24/2011 17:46'!
methodWithPlusTwice: a and: b
	| c |
	c := a + b.
	c := a + b.
	^ c! !

!PlusExample methodsFor: 'examples' stamp: 'Milos 4/24/2011 17:47'!
methodWithPluses: a and: b
	| c |
	c := a + b + 7.
	^ c! !

Object subclass: #RelationalExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!RelationalExample methodsFor: 'examples' stamp: 'Milos 5/7/2011 11:39'!
gtToX
	| a b c |
	c := a > b! !

Object subclass: #RetroReplacementOperator
	instanceVariableNames: 'first second third'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!RetroReplacementOperator commentStamp: 'Milos 4/29/2011 15:54' prior: 0!
A RetroReplacementOperator defines a replacement retro mutation operator. Defines an "x" operation to be replaced with an "y" eg. "+" can be tranformed to "-".

Instance Variables
	first:		<Object>
	second:		<Object>
	third:		<Object>

first
	- xxxxx

second
	- xxxxx

third
	- xxxxx
!

!RetroReplacementOperator class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 12:07'!
first: theFirstSelector second: theSecondSelector
	^ self first: theFirstSelector second: theSecondSelector third: nil! !

!RetroReplacementOperator class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 12:07'!
first: theFirstSelector second: theSecondSelector third: theThirdSelector
	^ super new first: theFirstSelector second: theSecondSelector third: theThirdSelector! !

!RetroReplacementOperator class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 11:46'!
new
	self error: 'Do not use new!!'! !

!RetroReplacementOperator methodsFor: 'comparing' stamp: 'Milos 4/24/2011 11:57'!
= anObject
	anObject class = self class
		ifFalse: [ ^ false ].
	^ self first = anObject first and: [ self second = anObject second ]! !

!RetroReplacementOperator methodsFor: 'converting' stamp: 'Milos 4/24/2011 23:04'!
asString
	^ third asString.! !

!RetroReplacementOperator methodsFor: 'accessing' stamp: 'Milos 4/24/2011 11:51'!
first
	^ first! !

!RetroReplacementOperator methodsFor: 'initialize-release' stamp: 'Milos 4/24/2011 12:06'!
first: theFirstSelector second: theSecondSelector third: theThirdSelector
	first := theFirstSelector.
	second := theSecondSelector.
	third := theThirdSelector! !

!RetroReplacementOperator methodsFor: 'accessing' stamp: 'Milos 4/24/2011 11:51'!
second
	^ second! !

!RetroReplacementOperator methodsFor: 'accessing' stamp: 'Milos 4/24/2011 12:06'!
third
	^ third! !

Object subclass: #RetroReplacementOperatorFactory
	instanceVariableNames: 'md5 aor ror cor'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'SMutant-Core'!

!RetroReplacementOperatorFactory commentStamp: 'Milos 4/29/2011 15:56' prior: 0!
A Flyweight Factory for replacement operators.

Instance Variables
	md5:		<Object>
	replacementOperators:		<Object>

md5
	- xxxxx

replacementOperators
	- xxxxx
!

!RetroReplacementOperatorFactory class methodsFor: 'private' stamp: 'Milos 4/24/2011 22:40'!
md5
	| source |
	source := ''.
	RetroReplacementOperatorFactory class selectors
		do: [ :selector | source := source , (RetroReplacementOperatorFactory class methodDict at: selector) getSource asString ].
	RetroReplacementOperatorFactory selectors
		do: [ :selector | source := source , (RetroReplacementOperatorFactory methodDict at: selector) getSource asString ].
	^ MD5 new hashMessage: source! !

!RetroReplacementOperatorFactory class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 22:37'!
new
	self error: 'Do not use new, use singleton!!'! !

!RetroReplacementOperatorFactory class methodsFor: 'reseting' stamp: 'Milos 4/24/2011 17:42'!
resetSingleton
	UniqueInstance := nil! !

!RetroReplacementOperatorFactory class methodsFor: 'instance creation' stamp: 'Milos 4/24/2011 22:45'!
singleton
	| md5 |
	md5 := self md5.
	(UniqueInstance = nil or: [ UniqueInstance md5 ~= md5 ])
		ifTrue: [ UniqueInstance := self basicNew initializeAndSetMD5: md5 ].
	^ UniqueInstance! !

!RetroReplacementOperatorFactory methodsFor: 'private' stamp: 'Milos 5/26/2011 09:06'!
addTo: aCollection original: anOriginalSelector replacement: aReplacementSelector runtime: aRuntimeSelector
	aCollection
		add: (RetroReplacementOperator first: anOriginalSelector second: aReplacementSelector third: aRuntimeSelector)! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 5/26/2011 09:17'!
aor
	^ aor! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 5/26/2011 09:22'!
aorName
	^ 'ArithmeticOperatorReplacement'! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 5/26/2011 09:18'!
cor
	^ cor! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 5/26/2011 09:22'!
corName
	^ 'ConditionalOperatorReplacement'! !

!RetroReplacementOperatorFactory methodsFor: 'initialization' stamp: 'Milos 5/26/2011 09:13'!
initializeAndSetMD5: aMd5
	md5 := aMd5.
	aor := OrderedCollection new.
	ror := OrderedCollection new.
	cor := OrderedCollection new.
	self
		addTo: aor
		original: #+
		replacement: #-
		runtime: #plus:toMinus:.
	self
		addTo: aor
		original: #+
		replacement: #*
		runtime: #plus:toMul:.
	self
		addTo: aor
		original: #+
		replacement: #/
		runtime: #plus:toDiv:.
	self
		addTo: aor
		original: #-
		replacement: #+
		runtime: #minus:toPlus:.
	self
		addTo: aor
		original: #-
		replacement: #*
		runtime: #minus:toMul:.
	self
		addTo: aor
		original: #-
		replacement: #/
		runtime: #minus:toDiv:.
	self
		addTo: aor
		original: #*
		replacement: #+
		runtime: #mul:toPlus:.
	self
		addTo: aor
		original: #*
		replacement: #-
		runtime: #mul:toMinus:.
	self
		addTo: aor
		original: #*
		replacement: #/
		runtime: #mul:toDiv:.
	self
		addTo: aor
		original: #/
		replacement: #+
		runtime: #div:toPlus:.
	self
		addTo: aor
		original: #/
		replacement: #-
		runtime: #div:toMinus:.
	self
		addTo: aor
		original: #/
		replacement: #*
		runtime: #div:toMul:.
	self
		addTo: ror
		original: #>
		replacement: #>=
		runtime: #gt:toGe:.
	self
		addTo: ror
		original: #>
		replacement: #<
		runtime: #gt:toLt:.
	self
		addTo: ror
		original: #>
		replacement: #<=
		runtime: #gt:toLe:.
	self
		addTo: ror
		original: #>
		replacement: #=
		runtime: #gt:toEq:.
	self
		addTo: ror
		original: #>
		replacement: #~=
		runtime: #gt:toNe:.
	self
		addTo: ror
		original: #>=
		replacement: #>
		runtime: #ge:toGt:.
	self
		addTo: ror
		original: #>=
		replacement: #<
		runtime: #ge:toLt:.
	self
		addTo: ror
		original: #>=
		replacement: #<=
		runtime: #ge:toLe:.
	self
		addTo: ror
		original: #>=
		replacement: #=
		runtime: #ge:toEq:.
	self
		addTo: ror
		original: #>=
		replacement: #~=
		runtime: #ge:toNe:.
	self
		addTo: ror
		original: #<
		replacement: #>
		runtime: #lt:toGt:.
	self
		addTo: ror
		original: #<
		replacement: #>=
		runtime: #lt:toGe:.
	self
		addTo: ror
		original: #<
		replacement: #<=
		runtime: #lt:toLe:.
	self
		addTo: ror
		original: #<
		replacement: #=
		runtime: #lt:toEq:.
	self
		addTo: ror
		original: #<
		replacement: #~=
		runtime: #lt:toNe:.
	self
		addTo: ror
		original: #<=
		replacement: #>
		runtime: #le:toGt:.
	self
		addTo: ror
		original: #<=
		replacement: #>=
		runtime: #le:toGe:.
	self
		addTo: ror
		original: #<=
		replacement: #<
		runtime: #le:toLt:.
	self
		addTo: ror
		original: #<=
		replacement: #=
		runtime: #le:toEq:.
	self
		addTo: ror
		original: #<=
		replacement: #~=
		runtime: #le:toNe:.
	self
		addTo: ror
		original: #=
		replacement: #>
		runtime: #eq:toGt:.
	self
		addTo: ror
		original: #=
		replacement: #>=
		runtime: #eq:toGe:.
	self
		addTo: ror
		original: #=
		replacement: #<
		runtime: #eq:toLt:.
	self
		addTo: ror
		original: #=
		replacement: #<=
		runtime: #eq:toLe:.
	self
		addTo: ror
		original: #=
		replacement: #~=
		runtime: #eq:toNe:.
	self
		addTo: ror
		original: #~=
		replacement: #>
		runtime: #ne:toGt:.
	self
		addTo: ror
		original: #~=
		replacement: #>=
		runtime: #ne:toGe:.
	self
		addTo: ror
		original: #~=
		replacement: #<
		runtime: #ne:toLt:.
	self
		addTo: ror
		original: #~=
		replacement: #<=
		runtime: #ne:toLe:.
	self
		addTo: ror
		original: #~=
		replacement: #=
		runtime: #ne:toEq:.
	self
		addTo: cor
		original: #and:
		replacement: #or:
		runtime: #and:toOr:.
	self
		addTo: cor
		original: #or:
		replacement: #and:
		runtime: #or:toAnd:! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 4/24/2011 22:41'!
md5
	^ md5! !

!RetroReplacementOperatorFactory methodsFor: 'getting' stamp: 'Milos 5/26/2011 09:13'!
original: anOriginalSelector replacement: aReplacementSelector
	^ self replacementOperators
		detect: [ :operator | operator first = anOriginalSelector and: [ operator second = aReplacementSelector ] ]
		ifNone: [ nil ]! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 5/26/2011 09:12'!
replacementOperators
	^ aor , ror , cor! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 5/26/2011 09:17'!
ror
	^ ror! !

!RetroReplacementOperatorFactory methodsFor: 'accessing' stamp: 'Milos 5/26/2011 09:23'!
rorName
	^ 'RelationalOperatorReplacement'! !

!RetroReplacementOperatorFactory methodsFor: 'getting' stamp: 'Milos 5/26/2011 09:12'!
runtime: aRuntimeName
	^ self replacementOperators detect: [ :operator | operator third = aRuntimeName ] ifNone: [ nil ]! !

Object subclass: #RetroReplacementOperatorRuntime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!RetroReplacementOperatorRuntime commentStamp: 'Milos 4/29/2011 16:00' prior: 0!
A set of methods that are called when a replacement mutation is encountered at runtime. This checks the type of the arguments to see if a mutation should be applied and applies it if the type is appropriate.

Instance Variables
!

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/25/2011 21:08'!
and: first toOr: second
	(self areBooleans: first and: second)
		ifTrue: [ ^ first or: second ]
		ifFalse: [ ^ first and: second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'private' stamp: 'Milos 5/25/2011 21:26'!
areBooleans: first and: second
	^ first class = Boolean and: [ second class = Boolean ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'private' stamp: 'Milos 4/24/2011 18:02'!
areIntegers: first and: second
	^ first isInteger and: [ second isInteger ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:52'!
div: first toMinus: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first - second ]
		ifFalse: [ ^ first / second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:52'!
div: first toMul: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first * second ]
		ifFalse: [ ^ first / second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:52'!
div: first toPlus: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first + second ]
		ifFalse: [ ^ first / second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:34'!
eq: first toGe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first >= second ]
		ifFalse: [ ^ first = second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:34'!
eq: first toGt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first > second ]
		ifFalse: [ ^ first = second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:34'!
eq: first toLe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first <= second ]
		ifFalse: [ ^ first = second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:34'!
eq: first toLt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first < second ]
		ifFalse: [ ^ first = second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:34'!
eq: first toNe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first ~= second ]
		ifFalse: [ ^ first = second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:32'!
ge: first toEq: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first = second ]
		ifFalse: [ ^ first >= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:32'!
ge: first toGt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first > second ]
		ifFalse: [ ^ first >= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:32'!
ge: first toLe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first <= second ]
		ifFalse: [ ^ first >= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:32'!
ge: first toLt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first < second ]
		ifFalse: [ ^ first >= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:32'!
ge: first toNe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first ~= second ]
		ifFalse: [ ^ first >= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:31'!
gt: first toEq: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first = second ]
		ifFalse: [ ^ first > second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:30'!
gt: first toGe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first >= second ]
		ifFalse: [ ^ first > second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:30'!
gt: first toLe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first <= second ]
		ifFalse: [ ^ first > second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:30'!
gt: first toLt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first < second ]
		ifFalse: [ ^ first > second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:31'!
gt: first toNe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first ~= second ]
		ifFalse: [ ^ first > second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:34'!
le: first toEq: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first = second ]
		ifFalse: [ ^ first <= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:33'!
le: first toGe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first >= second ]
		ifFalse: [ ^ first <= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:33'!
le: first toGt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first > second ]
		ifFalse: [ ^ first <= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:33'!
le: first toLt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first < second ]
		ifFalse: [ ^ first <= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:34'!
le: first toNe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first ~= second ]
		ifFalse: [ ^ first <= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:33'!
lt: first toEq: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first = second ]
		ifFalse: [ ^ first < second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:32'!
lt: first toGe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first >= second ]
		ifFalse: [ ^ first < second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:32'!
lt: first toGt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first > second ]
		ifFalse: [ ^ first < second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:33'!
lt: first toLe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first <= second ]
		ifFalse: [ ^ first < second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:33'!
lt: first toNe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first ~= second ]
		ifFalse: [ ^ first < second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:51'!
minus: first toDiv: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first / second ]
		ifFalse: [ ^ first - second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:51'!
minus: first toMul: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first * second ]
		ifFalse: [ ^ first - second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:51'!
minus: first toPlus: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first + second ]
		ifFalse: [ ^ first - second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:50'!
mul: first toDiv: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first / second ]
		ifFalse: [ ^ first * second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:50'!
mul: first toMinus: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first - second ]
		ifFalse: [ ^ first * second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/24/2011 17:54'!
mul: first toPlus: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first + second ]
		ifFalse: [ ^ first * second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:35'!
ne: first toEq: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first = second ]
		ifFalse: [ ^ first ~= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:35'!
ne: first toGe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first >= second ]
		ifFalse: [ ^ first ~= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:35'!
ne: first toGt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first > second ]
		ifFalse: [ ^ first ~= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:35'!
ne: first toLe: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first <= second ]
		ifFalse: [ ^ first ~= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/7/2011 11:35'!
ne: first toLt: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first < second ]
		ifFalse: [ ^ first ~= second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 5/25/2011 21:08'!
or: first toAnd: second
	(self areBooleans: first and: second)
		ifTrue: [ ^ first and: second ]
		ifFalse: [ ^ first or: second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/25/2011 14:50'!
plus: first toDiv: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first / second ]
		ifFalse: [ ^ first + second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/24/2011 17:55'!
plus: first toMinus: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first - second ]
		ifFalse: [ ^ first + second ]! !

!RetroReplacementOperatorRuntime class methodsFor: 'runtime' stamp: 'Milos 4/24/2011 17:56'!
plus: first toMul: second
	(self areIntegers: first and: second)
		ifTrue: [ ^ first * second ]
		ifFalse: [ ^ first + second ]! !

Object subclass: #SMutantInstaller
	instanceVariableNames: 'hasExtra installed newMainMenuItems newMenuItems newBuildWorldMenu'
	classVariableNames: 'MutationInstallerInstance'
	poolDictionaries: ''
	category: 'SMutant-GUI'!

!SMutantInstaller commentStamp: 'Milos 4/12/2011 18:40' prior: 0!
MutationInstaller modifies image to make mutation applicable.

Instance Variables
	menuItemsInterceptor:		<Object>

menuItemsInterceptor
	- xxxxx
!

!SMutantInstaller class methodsFor: 'install' stamp: 'Milos 5/3/2011 11:27'!
install
	self install: false! !

!SMutantInstaller class methodsFor: 'install' stamp: 'Milos 5/3/2011 11:27'!
install: includeExtra
	| installed |
	(MutationInstallerInstance = nil)
		ifTrue: [installed := nil]
		ifFalse: [installed := MutationInstallerInstance installed].
	(installed = nil or: [installed not])
		ifTrue: [MutationInstallerInstance := super new install: includeExtra].! !

!SMutantInstaller class methodsFor: 'install' stamp: 'Milos 4/13/2011 00:22'!
uninstall
	(MutationInstallerInstance installed)
		ifTrue: [MutationInstallerInstance uninstall].! !

!SMutantInstaller methodsFor: 'install' stamp: 'Milos 5/3/2011 11:29'!
install: includeExtra
	hasExtra := includeExtra.
	includeExtra ifTrue: [self installExtra].
	newMainMenuItems := MainMenuItemsMessageReplacer originalMethod: (StandardToolSet class methodDict at: #mainMenuItems).
	newMenuItems := MenuItemsReplacer originalMethod: (StandardToolSet class methodDict at: #menuItems).
	StandardToolSet class methodDict at: #mainMenuItems put: newMainMenuItems.
	StandardToolSet class methodDict at: #menuItems put: newMenuItems.
	StandardToolSet class compile: 'openMutationRunner ^ MutationTestRunner open'.
	self installed: true! !

!SMutantInstaller methodsFor: 'install' stamp: 'Milos 5/3/2011 11:28'!
installExtra
	newBuildWorldMenu := QuitSessionReplacer originalMethod: (TheWorldMenu methodDict at: #quitSession).
	TheWorldMenu methodDict at: #quitSession put: newBuildWorldMenu! !

!SMutantInstaller methodsFor: 'accessing' stamp: 'Milos 4/13/2011 00:05'!
installed
	^ installed.! !

!SMutantInstaller methodsFor: 'accessing' stamp: 'Milos 4/13/2011 00:05'!
installed: aBoolean
	installed := aBoolean.! !

!SMutantInstaller methodsFor: 'install' stamp: 'Milos 5/3/2011 11:29'!
uninstall
	hasExtra ifTrue: [ self uninstallExtra ].
	TheWorldMenu methodDict at: #quitSession put: newBuildWorldMenu originalMethod.
	StandardToolSet class methodDict at: #mainMenuItems put: newMainMenuItems originalMethod.
	StandardToolSet class methodDict at: #menuItems put: newMenuItems originalMethod.
	StandardToolSet class methodDict removeKey: #openMutationRunner ifAbsent: [  ].
	self installed: false! !

!SMutantInstaller methodsFor: 'install' stamp: 'Milos 5/3/2011 11:25'!
uninstallExtra
	TheWorldMenu methodDict at: #quitSession put: newBuildWorldMenu originalMethod! !

CollectionRootTest subclass: #SMutantSetTest
	uses: TAddForUniquenessTest + TIncludesWithIdentityCheckTest + TCloneTest + TCopyTest + TSetArithmetic + TRemoveTest + TCreationWithTest - {#testOfSize} + TGrowableTest + TStructuralEqualityTest + TSizeTest + TPrintTest + TAsStringCommaAndDelimiterTest + TConvertTest + TConvertAsSortedTest + TConcatenationEqualElementsRemovedTest + TOccurrencesTest
	instanceVariableNames: 'full empty collection result emptyButAllocatedWith20 elementNotIn collectionOfFloat collectionIncluded nonEmpty1element withoutEqualElements collection5Elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

SMutantSetTest class
	uses: TAddForUniquenessTest classTrait + TIncludesWithIdentityCheckTest classTrait + TCloneTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TRemoveTest classTrait + TCreationWithTest classTrait + TGrowableTest classTrait + TStructuralEqualityTest classTrait + TSizeTest classTrait + TPrintTest classTrait + TAsStringCommaAndDelimiterTest classTrait + TConvertTest classTrait + TConvertAsSortedTest classTrait + TConcatenationEqualElementsRemovedTest classTrait + TOccurrencesTest classTrait
	instanceVariableNames: ''!

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
anotherElementNotIn
	^ 42! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection  anyOne! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ elementNotIn ! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
assertNoDuplicates: aCollection whenConvertedTo: aClass 
	| result |
	result := self collectionWithEqualElements asIdentitySet.
	self assert: (result class includesBehavior: IdentitySet).
	self collectionWithEqualElements do: [ :initial | self assert: (result occurrencesOf: initial) = 1 ]! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
assertNonDuplicatedContents: aCollection whenConvertedTo: aClass 
	| result |
	result := aCollection perform: ('as' , aClass name) asSymbol.
	self assert: (result class includesBehavior: aClass).
	result do: 
		[ :each | 
		self assert: (aCollection occurrencesOf: each) = (result occurrencesOf: each) ].
	^ result! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
assertSameContents: aCollection whenConvertedTo: aClass 
	| result |
	result := self assertNonDuplicatedContents: aCollection whenConvertedTo: aClass.
	self assert: result size = aCollection size! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:40'!
classToBeTested
^ SMutantSet.! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collection

	^ collection! !

!SMutantSetTest methodsFor: 'test - creation' stamp: 'Milos 4/29/2011 18:41'!
collectionClass 
	
	^ SMutantSet! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionInForIncluding
	^ collectionIncluded ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionMoreThan5Elements
" return a collection including at least 5 elements"
	
	^ collection5Elements ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionNotIncluded
	^ self classToBeTested  with: elementNotIn. ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionOfFloat
	^ collectionOfFloat ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionWithCopyNonIdentical
	" return a collection that include elements for which 'copy' return a different object (this is not the case of SmallInteger)"
	^ collectionOfFloat! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionWithElement
	^ full! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionWithElementsToRemove
	^ collectionIncluded ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionWithSortableElements
" return a collection elements that can be sorte ( understanding message ' < '  or ' > ')"
	^collectionOfFloat ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionWithoutElement
	" return a collection that does not include 'element' "
	^ collection ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^ withoutEqualElements ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^ collection ! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
containsAll: union of: one andOf: another
			
	self assert: (one allSatisfy: [:each | union includes: each]).
	self assert: (another allSatisfy: [:each | union includes: each])! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
element
	^ 4! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
elementInForIncludesTest
" return an element included in nonEmpty "
	^ self nonEmpty anyOne! !

!SMutantSetTest methodsFor: 'ambiguous' stamp: 'Milos 4/29/2011 18:36'!
elementNotIn
	^elementNotIn ! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
elementNotInForOccurrences
	^ 666! !

!SMutantSetTest methodsFor: 'test - copy' stamp: 'Milos 4/29/2011 18:36'!
elementToAdd
	^ 42! !

!SMutantSetTest methodsFor: 'tests - empty' stamp: 'Milos 4/29/2011 18:36'!
empty
	
	^ empty! !

!SMutantSetTest methodsFor: 'tests - size capacity' stamp: 'Milos 4/29/2011 18:37'!
emptyButAllocatedWith20

	^ emptyButAllocatedWith20! !

!SMutantSetTest methodsFor: 'test - iterate' stamp: 'Milos 4/29/2011 18:36'!
expectedSizeAfterReject
	^1! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
firstCollection
" return a collection that will be the first part of the concatenation"
	^ nonEmpty1element ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
integerCollectionWithoutEqualElements
" return a collection of integer without equal elements"
	^ withoutEqualElements ! !

!SMutantSetTest methodsFor: 'tests - empty' stamp: 'Milos 4/29/2011 18:36'!
nonEmpty
	
	^ full! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^ nonEmpty1element ! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
nonEmptyWithoutEqualElements
" return a collection without equal elements "
	^ withoutEqualElements ! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
numberOfSimilarElementsInIntersection
	^ self collection occurrencesOf: self anotherElementOrAssociationIn! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
otherCollection
	"Returns a collection that does not include what is returned by #element."
	^ result! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
result

	 ^ result! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
resultForCollectElementsClass
" return the retsult expected by collecting the class of each element of collectionWithoutNilElements"
	^ result! !

!SMutantSetTest methodsFor: 'requirements' stamp: 'Milos 4/29/2011 18:36'!
secondCollection
" return a collection that will be the second part of the concatenation"
	^ collection ! !

!SMutantSetTest methodsFor: 'test - iterate' stamp: 'Milos 4/29/2011 18:36'!
selectedNumber

	^ 2
	! !

!SMutantSetTest methodsFor: 'initialize' stamp: 'Milos 4/29/2011 18:36'!
setUp
	empty := self classToBeTested  new.
	full := self classToBeTested  with: 1 with: 2 with: 3 with: 4.
	collectionIncluded := self classToBeTested  with: 2 with: 3 .
	collection := self classToBeTested  new.
	collection add: 1; add: -2; add: 3. 
	result := self classToBeTested  new add: SmallInteger ; yourself.
	emptyButAllocatedWith20 := self classToBeTested  new: 20.
	elementNotIn := 99.
	collectionOfFloat := self classToBeTested  with: 2.5 with: 4.6 with: 4.2.
	nonEmpty1element := self classToBeTested  with: 32.
	withoutEqualElements := self classToBeTested  with: 4 with: 5 with: 2.
	collection5Elements := self classToBeTested with: 1 with: 2 with: 3 with: 4 with: 5.! !

!SMutantSetTest methodsFor: 'tests - size capacity' stamp: 'Milos 4/29/2011 18:37'!
sizeCollection

	^ full! !

!SMutantSetTest methodsFor: 'test - iterate' stamp: 'Milos 4/29/2011 18:41'!
speciesClass
	
	^ SMutantSet! !

!SMutantSetTest methodsFor: 'private' stamp: 'Milos 4/29/2011 18:50'!
targetClass
  |className|

  className := self class name asText copyFrom: 0 to: self class name size - 4.
  ^ Smalltalk at: (className asString asSymbol)! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0CopyTest
	self shouldnt: [ self empty ]raise: Error.
	self assert: self empty size = 0.
	self shouldnt: [ self nonEmpty ]raise: Error.
	self assert: (self nonEmpty size = 0) not.
	self shouldnt: [ self collectionWithElementsToRemove ]raise: Error.
	self assert: (self collectionWithElementsToRemove size = 0) not.
	self collectionWithElementsToRemove do: [:each | self assert: ( self nonEmpty includes: each)].
	
	self shouldnt: [ self elementToAdd ]raise: Error.
	self deny: (self nonEmpty includes: self elementToAdd ).
	self shouldnt: [ self collectionNotIncluded ]raise: Error.
	self collectionNotIncluded do: [ :each | self deny: (self nonEmpty includes: each) ]! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureAddForUniquenessTest
	self 
		shouldnt: [ self element ]
		raise: Error.
	self 
		shouldnt: [ self collectionWithElement ]
		raise: Error.
	self assert: (self collectionWithElement includes: self element).
	self 
		shouldnt: [ self collectionWithoutElement ]
		raise: Error.
	self assert: (self collectionWithElement includes: self element)! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureAsStringCommaAndDelimiterTest
	
	self shouldnt: [self nonEmpty] raise:Error .
	self deny: self nonEmpty isEmpty.
	
	self shouldnt: [self empty] raise:Error .
	self assert: self empty isEmpty.
	
       self shouldnt: [self nonEmpty1Element ] raise:Error .
	self assert: self nonEmpty1Element size=1.! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureCloneTest

self shouldnt: [ self nonEmpty ] raise: Error.
self deny: self nonEmpty isEmpty.

self shouldnt: [ self empty ] raise: Error.
self assert: self empty isEmpty.

! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureConcatenationTest
	self shouldnt: [ self firstCollection ]raise: Error.
	self deny: self firstCollection isEmpty.
	
	self shouldnt: [ self firstCollection ]raise: Error.
	self deny: self firstCollection isEmpty.
	
	self shouldnt: [ self empty ]raise: Error.
	self assert: self empty isEmpty! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureConverAsSortedTest

	self shouldnt: [self collectionWithSortableElements ] raise: Error.
	self deny: self collectionWithSortableElements isEmpty .! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureCreationWithTest

self shouldnt: [ self collectionMoreThan5Elements ] raise: Error.
self assert: self collectionMoreThan5Elements size >= 5.! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureIncludeTest
	| elementIn |
	self shouldnt: [ self nonEmpty ]raise: Error.
	self deny: self nonEmpty isEmpty.
	
	self shouldnt: [ self elementNotIn ]raise: Error.
		
	elementIn := true.
	self nonEmpty detect: 
		[ :each | each = self elementNotIn ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	
	self shouldnt: [ self anotherElementNotIn ]raise: Error.
		
	elementIn := true.
	self nonEmpty detect: 
	[ :each | each = self anotherElementNotIn ]
	ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	
	self shouldnt: [ self empty ] raise: Error.
	self assert: self empty isEmpty.
	
! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureIncludeWithIdentityTest
	| element |
	self	shouldnt: [ self collectionWithCopyNonIdentical ]raise: Error.
	element := self collectionWithCopyNonIdentical anyOne.
	self deny: element == element copy.
! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureOccurrencesTest
	| tmp |
	self shouldnt: [self empty ]raise: Error.
	self assert: self empty isEmpty.

	self shouldnt: [ self collectionWithoutEqualElements ] raise: Error.
	self deny: self collectionWithoutEqualElements isEmpty.
	
	tmp := OrderedCollection new.
	self collectionWithoutEqualElements do: [ 
		:each |
		self deny: (tmp includes: each).
		tmp add: each.
		 ].
	
	
	self shouldnt: [ self elementNotInForOccurrences ] raise: Error.
	self deny: (self collectionWithoutEqualElements includes: self elementNotInForOccurrences)! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixturePrintTest

	self shouldnt: [self nonEmpty ] raise: Error.
	self deny: self nonEmpty  isEmpty.! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureRequirementsOfTGrowableTest
	self shouldnt: [self empty] raise: Exception.
	self shouldnt: [self nonEmpty] raise: Exception.
	self shouldnt: [self element] raise: Exception.
	self shouldnt: [self elementNotIn] raise: Exception.
	self assert: self empty isEmpty.
	self deny: self nonEmpty isEmpty.
	self assert: (self nonEmpty includes: self element).
	self deny: (self nonEmpty includes: self elementNotIn).! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureSetAritmeticTest
	self 
		shouldnt: [ self collection ]
		raise: Error.
	self deny: self collection isEmpty.
	self 
		shouldnt: [ self nonEmpty ]
		raise: Error.
	self deny: self nonEmpty isEmpty.
	self 
		shouldnt: [ self anotherElementOrAssociationNotIn ]
		raise: Error.
	self collection isDictionary 
		ifTrue: 
			[ self deny: (self collection associations includes: self anotherElementOrAssociationNotIn key) ]
		ifFalse: 
			[ self deny: (self collection includes: self anotherElementOrAssociationNotIn) ].
	self 
		shouldnt: [ self collectionClass ]
		raise: Error! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureTConvertTest
	"a collection of number without equal elements:"
	| res |
	self shouldnt: [ self collectionWithoutEqualElements ]raise: Error.
		
	res := true.
	self collectionWithoutEqualElements 
		detect: [ :each | (self collectionWithoutEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false.
	
	
! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0FixtureTRemoveTest
	| duplicate |
	self shouldnt: [ self empty ]raise: Error.
	self shouldnt: [ self nonEmptyWithoutEqualElements]  raise:Error.
	self deny: self nonEmptyWithoutEqualElements isEmpty.
	duplicate := true.
	self nonEmptyWithoutEqualElements detect: 
		[:each | (self nonEmptyWithoutEqualElements occurrencesOf: each) > 1] 			
		ifNone: [duplicate := false].
	self assert: duplicate = false.
	
	
	self shouldnt: [ self elementNotIn ] raise: Error.
	self assert: self empty isEmpty.
	self deny: self nonEmptyWithoutEqualElements isEmpty.
	self deny: (self nonEmptyWithoutEqualElements includes: self elementNotIn)! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0TSizeTest
	self shouldnt: [self empty] raise: Error.
	self shouldnt: [self sizeCollection] raise: Error.
	self assert: self empty isEmpty.
	self deny: self sizeCollection isEmpty.! !

!SMutantSetTest methodsFor: 'tests - fixture' stamp: 'Milos 4/29/2011 18:36'!
test0TStructuralEqualityTest
	self shouldnt: [self empty] raise: Error.
	self shouldnt: [self nonEmpty] raise: Error.
	self assert: self empty isEmpty.
	self deny: self nonEmpty isEmpty.! !

!SMutantSetTest methodsFor: 'sunit original tests' stamp: 'Milos 4/29/2011 18:36'!
testAdd 
	empty add: 5.
	self assert: (empty includes: 5).! !

!SMutantSetTest methodsFor: 'tests - adding uniquely' stamp: 'Milos 4/29/2011 18:36'!
testAddAlreadyThereDoesNotCount

	| added oldSize |
	oldSize := self collectionWithElement size.
	self assert: (self collectionWithElement includes: self element).

	added := self collectionWithElement add: self element.
	
	self assert: added = self element.
	self assert: (self collectionWithElement includes: self element).
	self assert: self collectionWithElement size = oldSize.! !

!SMutantSetTest methodsFor: 'tests - growable' stamp: 'Milos 4/29/2011 18:36'!
testAddEmptyGrows
	"self debug: #testAddEmptyGrows"
	
	| oldSize |
	oldSize := self empty size.
	self empty add: self element.
	self assert: self empty size = (oldSize + 1).! !

!SMutantSetTest methodsFor: 'tests - adding uniquely' stamp: 'Milos 4/29/2011 18:36'!
testAddNewElementIncrementsSize
	| added oldSize |
	oldSize := self collectionWithoutElement size.
	self deny: (self collectionWithoutElement includes: self element).
	added := self collectionWithoutElement add: self element.
	self assert: added = self element.
	self assert: (self collectionWithoutElement includes: self element).
	self assert: self collectionWithoutElement size = (oldSize + 1)! !

!SMutantSetTest methodsFor: 'tests - growable' stamp: 'Milos 4/29/2011 18:37'!
testAddNonEmptyGrowsWhenNewElement
	"self debug: #testAddNonEmptyGrowsWhenNewElement"
	| oldSize |
	oldSize := self nonEmpty size.
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self nonEmpty add: self elementNotInForOccurrences.
	self assert: self nonEmpty size > oldSize! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:36'!
testAddWithOccurences
 
	empty add: 2 withOccurrences: 3.
	self assert: (empty includes: 2).
	self assert: ((empty occurrencesOf: 2) = 1).! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: Array! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
testAsBag

	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: Bag! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
testAsByteArray
| res |
self shouldnt: [self integerCollectionWithoutEqualElements ] raise: Error.
	self integerCollectionWithoutEqualElements  do: [ :each | self assert: each class = SmallInteger] .  
	
	res := true.
	self integerCollectionWithoutEqualElements  
		detect: [ :each | (self integerCollectionWithoutEqualElements  occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false.
	

	self assertSameContents: self integerCollectionWithoutEqualElements  whenConvertedTo: ByteArray! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsCommaStringEmpty

	self assert: self empty asCommaString = ''.
	self assert: self empty asCommaStringAnd = ''.
	
! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsCommaStringMore

	| result resultAnd index allElementsAsString tmp |
	result:= self nonEmpty asCommaString .
	resultAnd:= self nonEmpty asCommaStringAnd .
	tmp :=OrderedCollection new. 
	self nonEmpty do: [ :each | tmp add: each asString].

	"verifying result  :"
	index := 1.
	allElementsAsString := (result findBetweenSubStrs: ', ' ).
	allElementsAsString do:
		[:each |
		self assert: (tmp occurrencesOf: each)=(allElementsAsString occurrencesOf: each).
		].
	
	"verifying esultAnd :"
	allElementsAsString:=(resultAnd findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 ) | i= allElementsAsString size
			ifTrue: [self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self assert: (allElementsAsString at:i)=('and')].
			].! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsCommaStringOne
	
	self nonEmpty1Element do: 
		[:each | 
		self assert: each asString =self nonEmpty1Element  asCommaString.
		self assert: each asString=self nonEmpty1Element  asCommaStringAnd.].

	! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
testAsIdentitySet
	"test with a collection without equal elements :"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: IdentitySet.
! !

!SMutantSetTest methodsFor: 'tests - converting' stamp: 'Milos 4/29/2011 18:36'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: OrderedCollection! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:36'!
testAsSet
	"could be moved in Array or Collection"

	| newFull |
	newFull := #(1 2 3 ) asSet.
	newFull add: 4.
	self assert: (newFull = full).! !

!SMutantSetTest methodsFor: 'tests - as sorted collection' stamp: 'Milos 4/29/2011 18:36'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asSortedArray.
	self assert: (result class includesBehavior: Array).
	self assert: result isSorted.
	self assert: result size = collection size! !

!SMutantSetTest methodsFor: 'tests - as sorted collection' stamp: 'Milos 4/29/2011 18:36'!
testAsSortedCollection

	| aCollection result |
	aCollection := self collectionWithSortableElements .
	result := aCollection asSortedCollection.
	
	self assert: (result class includesBehavior: SortedCollection).
	result do: 
		[ :each | 
		self assert: (aCollection occurrencesOf: each) = (result occurrencesOf: each) ].
	
	self assert: result size = aCollection size.! !

!SMutantSetTest methodsFor: 'tests - as sorted collection' stamp: 'Milos 4/29/2011 18:36'!
testAsSortedCollectionWithSortBlock
	| result tmp |
	result := self collectionWithSortableElements  asSortedCollection: [:a :b | a > b].
	self assert: (result class includesBehavior: SortedCollection).
	result do: 
		[ :each | 
		self assert: (self collectionWithSortableElements   occurrencesOf: each) = (result occurrencesOf: each) ].
	self assert: result size = self collectionWithSortableElements  size.
	tmp:=result at: 1.
	result do: [:each| self assert: tmp>=each. tmp:=each].
	! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsStringOnDelimiterEmpty

	| delim emptyStream |
	delim := ', '.
	emptyStream := ReadWriteStream on: ''.
	self empty asStringOn: emptyStream delimiter: delim.
	self assert: emptyStream contents = ''.
! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsStringOnDelimiterLastEmpty

	| delim emptyStream |
	delim := ', '.
	emptyStream := ReadWriteStream on: ''.
	self empty asStringOn: emptyStream delimiter: delim last:'and'.
	self assert: emptyStream contents = ''.
! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsStringOnDelimiterLastMore

	| delim multiItemStream result last allElementsAsString tmp |
	
	delim := ', '.
	last := 'and'.
	result:=''.
	tmp := self nonEmpty collect: [:each | each asString].
	multiItemStream := ReadWriteStream on:result.
	self nonEmpty  asStringOn: multiItemStream delimiter: ', ' last: last.
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 ) | i= allElementsAsString size
			ifTrue: [self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString 			occurrencesOf:(allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self assert: (allElementsAsString at:i)=('and')].
			].
! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsStringOnDelimiterLastOne

	| delim oneItemStream result |
	
	delim := ', '.
	result:=''.
	oneItemStream := ReadWriteStream on: result.
	self nonEmpty1Element  asStringOn: oneItemStream delimiter: delim last: 'and'.
	oneItemStream  do:
		[:each1 |
		self nonEmpty1Element do: [:each2 |self assert: each1 = (each2 asString) ]
		 ].
	

! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsStringOnDelimiterMore

	| delim multiItemStream result allElementsAsString tmp |
	
	
	delim := ', '.
	result:=''.
	tmp:= self nonEmpty collect:[:each | each asString].
	multiItemStream := ReadWriteStream on:result.
	self nonEmpty  asStringOn: multiItemStream delimiter: ', '.
	
	allElementsAsString := (result findBetweenSubStrs: ', ' ).
	allElementsAsString do:
		[:each |
		self assert: (tmp occurrencesOf: each)=(allElementsAsString occurrencesOf: each).
		].! !

!SMutantSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'Milos 4/29/2011 18:36'!
testAsStringOnDelimiterOne

	| delim oneItemStream result |

	delim := ', '.
	result:=''.
	oneItemStream := ReadWriteStream on: result.
	self nonEmpty1Element  asStringOn: oneItemStream delimiter: delim.
	oneItemStream  do:
		[:each1 |
		self nonEmpty1Element do: [:each2 |self assert: each1 = (each2 asString) ]
		 ].
	
! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:36'!
testAtRandom
	| rand |
	rand := Random new.
	full add: 3.
	full add: 2.
	full add: 4.
	full add: 1.
	self assert: (full includes: (full atRandom: rand)).
	! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:42'!
testCollect2
	| newFull |
	newFull := SMutantSet withAll: (1 to: 10).
	result := newFull collect: [:each | each >= 1 ifTrue: [each] ifFalse: ['no']].
	self assert: (result = newFull).
	result := newFull collect: [:each | each >= 5 ifTrue: [each] ifFalse: ['no']].
	self assert: (result = ((SMutantSet withAll: (5 to: 10)) add: 'no'; yourself)).! !

!SMutantSetTest methodsFor: 'tests - concatenation' stamp: 'Milos 4/29/2011 18:36'!
testConcatenation

| collection1 collection2 result |
collection1 := self firstCollection .
collection2 := self secondCollection .
result := collection1 , collection2.

collection1 do:[ :each | self assert: (result includes: each)].
collection2 do:[ :each | self assert: (result includes: each)].
! !

!SMutantSetTest methodsFor: 'tests - concatenation' stamp: 'Milos 4/29/2011 18:36'!
testConcatenationWithDuplicate


| collection1 collection2 result |
collection1 := self firstCollection .
collection2 := self firstCollection  .
result := collection1 , collection2.

collection1 do:[ :each | self assert: (result includes: each)].
self assert: result size = collection1 size.! !

!SMutantSetTest methodsFor: 'tests - concatenation' stamp: 'Milos 4/29/2011 18:36'!
testConcatenationWithEmpty
	| result |
	result := self firstCollection , self empty.
	self assert: result = self firstCollection! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:36'!
testCopy
	| newFull |
	full add: 3.
	full add: 2.
	newFull := full copy.
	self assert: (full size = newFull size).
	self assert: ((full select: [:each | (newFull includes: each) not]) isEmpty).
	self assert: ((newFull select: [:each | (full includes: each) not]) isEmpty).! !

!SMutantSetTest methodsFor: 'tests - copy - clone' stamp: 'Milos 4/29/2011 18:36'!
testCopyCreatesNewObject
	"self debug: #testCopyCreatesNewObject"
	
	| copy | 
	copy := self nonEmpty copy.
	self deny: self nonEmpty == copy.
	! !

!SMutantSetTest methodsFor: 'tests - copy - clone' stamp: 'Milos 4/29/2011 18:36'!
testCopyEmpty
	"self debug: #testCopyEmpty"
	
	| copy | 
	copy := self empty copy.
	self assert: copy isEmpty.! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!SMutantSetTest methodsFor: 'tests - copy - clone' stamp: 'Milos 4/29/2011 18:36'!
testCopyNonEmpty
	"self debug: #testCopyNonEmpty"
	
	| copy | 
	copy := self nonEmpty copy.
	self deny: copy isEmpty.
	self assert: copy size = self nonEmpty size.
	self nonEmpty do: 
		[:each | copy includes: each]! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyNonEmptyWithout
	"self debug: #testCopyNonEmptyWithout"
	
	| res anElementOfTheCollection |
	anElementOfTheCollection :=  self nonEmpty anyOne.
	res := (self nonEmpty copyWithout: anElementOfTheCollection).
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self deny: (res includes: anElementOfTheCollection).
	self nonEmpty do:
		[:each | (each = anElementOfTheCollection) 
					ifFalse: [self assert: (res includes: each)]].
	
! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!SMutantSetTest methodsFor: 'tests - copy' stamp: 'Milos 4/29/2011 18:36'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:44'!
testCopyWithout
	| newFull | 
	full add: 3.
	full add: 2.
	newFull := full copyWithout: 3.
	self assert: (newFull size = (full size - 1)).
	self deny: (newFull includes: 3).
	self assert: ((newFull select: [:each | (full includes: each) not]) isEmpty).
	self assert: ((full select: [:each | (newFull includes: each) not]) = (SMutantSet with: 3)).
	! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testDifference
	"Answer the set theoretic difference of two collections."
	"self debug: #testDifference"
	
	self assert: (self collection difference: self collection) isEmpty.
	self assert: (self empty difference: self collection) isEmpty.
	self assert: (self collection difference: self empty) = self collection	
! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testDifferenceWithNonNullIntersection
	"Answer the set theoretic difference of two collections."
	"self debug: #testDifferenceWithNonNullIntersection"
	"	#(1 2 3) difference: #(2 4) 
	->  #(1 3)"
	| res overlapping |
	overlapping := self collectionClass 
		with: self anotherElementOrAssociationNotIn
		with: self anotherElementOrAssociationIn.
	res := self collection difference: overlapping.
	self deny: (res includes: self anotherElementOrAssociationIn).
	overlapping do: [ :each | self deny: (res includes: each) ]! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testDifferenceWithSeparateCollection
	"Answer the set theoretic difference of two collections."
	"self debug: #testDifferenceWithSeparateCollection"
	| res separateCol |
	separateCol := self collectionClass with: self anotherElementOrAssociationNotIn.
	res := self collection difference: separateCol.
	self deny: (res includes: self anotherElementOrAssociationNotIn).
	self assert: res = self collection.
	res := separateCol difference: self collection.
	self deny: (res includes: self collection anyOne).
	self assert: res = separateCol! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:42'!
testDo2
	| newFull |
	newFull := SMutantSet withAll: (1 to: 5).
	result := 0.
	newFull do: [:each | result := (result + each)].
	self assert: (result = 15).! !

!SMutantSetTest methodsFor: 'test - iterate' stamp: 'Milos 4/29/2011 18:36'!
testDoWithoutNoDuplicates
	"self debug: #testDoWithoutNoDuplicates"
	| res |
	res := self speciesClass new.  
	self collection do: [:each | res add: each] without: -2.
	self assert: res size = self doWithoutNumber.! !

!SMutantSetTest methodsFor: 'test - equality' stamp: 'Milos 4/29/2011 18:36'!
testEqualSign
	"self debug: #testEqualSign"

	self deny: (self empty = self nonEmpty).! !

!SMutantSetTest methodsFor: 'test - equality' stamp: 'Milos 4/29/2011 18:36'!
testEqualSignIsTrueForNonIdenticalButEqualCollections
	"self debug: #testEqualSignIsTrueForNonIdenticalButEqualCollections"
		
	self assert: (self empty = self empty copy). 
	self assert: (self empty copy = self empty).
	self assert: (self empty copy = self empty copy).
		
	self assert: (self nonEmpty = self nonEmpty copy). 
	self assert: (self nonEmpty copy = self nonEmpty).
	self assert: (self nonEmpty copy = self nonEmpty copy).! !

!SMutantSetTest methodsFor: 'test - equality' stamp: 'Milos 4/29/2011 18:36'!
testEqualSignOfIdenticalCollectionObjects
	"self debug: #testEqualSignOfIdenticalCollectionObjects"
	
	self assert: (self empty = self empty). 
	self assert: (self nonEmpty = self nonEmpty). 
	! !

!SMutantSetTest methodsFor: 'sunit original tests' stamp: 'Milos 4/29/2011 18:36'!
testGrow 
	empty addAll: (1 to: 100).
	self assert: (empty size = 100).
			! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIdentityIncludes
	" test the comportement in presence of elements 'includes' but not 'identityIncludes' "
	" can not be used by collections that can't include elements for wich copy doesn't return another instance "
	| collection element |
	self 
		shouldnt: [ self collectionWithCopyNonIdentical ]
		raise: Error.
	collection := self collectionWithCopyNonIdentical.
	element := collection anyOne copy.
	"self assert: (collection includes: element)."
	self deny: (collection identityIncludes: element)! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIdentityIncludesNonSpecificComportement
	" test the same comportement than 'includes: '  "
	| collection |	
	collection := self nonEmpty  .
	
	self deny: (collection identityIncludes: self elementNotIn ).
	self assert:(collection identityIncludes: collection anyOne)
! !

!SMutantSetTest methodsFor: 'sunit original tests' stamp: 'Milos 4/29/2011 18:36'!
testIllegal
	self should: [empty at: 5] raise: TestResult error.
	self should: [empty at: 5 put: #abc] raise: TestResult error.
			! !

!SMutantSetTest methodsFor: 'sunit original tests' stamp: 'Milos 4/29/2011 18:36'!
testIncludes
	self assert: (full includes: 4).
	self assert: (full includes: 3).
	self deny: (full includes: 6).
			! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIncludesAllOfAllThere
	"self debug: #testIncludesAllOfAllThere'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: { self nonEmpty anyOne }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty).! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIncludesAllOfNoneThere
	"self debug: #testIncludesAllOfNoneThere'"
	self deny: (self empty includesAllOf: self collection).
	self deny: (self nonEmpty includesAllOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIncludesAnyOfAllThere
	"self debug: #testIncludesAnyOfAllThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self assert: (self nonEmpty includesAnyOf: { self nonEmpty anyOne }).
	self assert: (self nonEmpty includesAnyOf: self nonEmpty).! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIncludesAnyOfNoneThere
	"self debug: #testIncludesAnyOfNoneThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self deny: (self nonEmpty includesAnyOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIncludesElementIsNotThere
	"self debug: #testIncludesElementIsNotThere"
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self assert: (self nonEmpty includes: self nonEmpty anyOne).
	self deny: (self empty includes: self elementNotInForOccurrences)! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIncludesElementIsThere
	"self debug: #testIncludesElementIsThere"
	
	self assert: (self nonEmpty includes: self nonEmpty anyOne).! !

!SMutantSetTest methodsFor: 'tests - includes' stamp: 'Milos 4/29/2011 18:37'!
testIncludesSubstringAnywhere
	"self debug: #testIncludesSubstringAnywher'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: {  (self nonEmpty anyOne)  }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty)! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:43'!
testIntersection 
	| newFull col |
	full add: 3; add: 2.
	col := full intersection: full.
	self assert: (full = col).

	newFull := SMutantSet with: 8 with: 9 with: #z.
	col := newFull intersection: full.
	self assert: (col isEmpty).
	
	newFull add: 5; add: #abc; add: 7.
	col := newFull intersection: full.
	self assert: ((full select: [:each | (newFull includes: each)]) = col).
	
	
	! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testIntersectionBasic
	"self debug: #testIntersectionBasic"
	| inter |
	inter := self collection intersection: (self collectionClass with: self anotherElementOrAssociationIn).
	self deny: inter isEmpty.
	self assert: (inter includes: self anotherElementOrAssociationIn value)! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testIntersectionEmpty
	"self debug: #testIntersectionEmpty"
	
	| inter |
	inter := self empty intersection: self empty.
	self assert: inter isEmpty. 
	inter := self empty intersection: self collection .
	self assert: inter =  self empty.
	! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testIntersectionItself
	"self debug: #testIntersectionItself"
	
	self assert: (self collection intersection: self collection) = self collection.
	! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testIntersectionTwoSimilarElementsInIntersection
	"self debug: #testIntersectionBasic"
	| inter |
	inter := self collection intersection: (self collectionClass with: self anotherElementOrAssociationIn).
	self assert: (self collection occurrencesOf: self anotherElementOrAssociationIn) = self numberOfSimilarElementsInIntersection.
	self assert: (inter includes: self anotherElementOrAssociationIn value)! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:36'!
testLike
	self assert: ((full like: 3) = 3).
	self assert: ((full like: 8) isNil).! !

!SMutantSetTest methodsFor: 'sunit original tests' stamp: 'Milos 4/29/2011 18:36'!
testOccurrences
	self assert: ((empty occurrencesOf: 0) = 0).
	self assert: ((full occurrencesOf: 4) = 1).
	full add: 4.
	self assert: ((full occurrencesOf: 4) = 1).! !

!SMutantSetTest methodsFor: 'tests - occurrencesOf' stamp: 'Milos 4/29/2011 18:37'!
testOccurrencesOf
	| collection |
	collection := self collectionWithoutEqualElements .
	
	collection do: [ :each | self assert: (collection occurrencesOf: each) = 1 ].! !

!SMutantSetTest methodsFor: 'tests - occurrencesOf' stamp: 'Milos 4/29/2011 18:37'!
testOccurrencesOfEmpty
	| result |
	result := self empty occurrencesOf: (self collectionWithoutEqualElements anyOne).
	self assert: result = 0! !

!SMutantSetTest methodsFor: 'tests - occurrencesOf' stamp: 'Milos 4/29/2011 18:37'!
testOccurrencesOfNotIn
	| result |
	result := self collectionWithoutEqualElements occurrencesOf: self elementNotInForOccurrences.
	self assert: result = 0! !

!SMutantSetTest methodsFor: 'tests - printing' stamp: 'Milos 4/29/2011 18:37'!
testPrintElementsOn

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printElementsOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).
			].! !

!SMutantSetTest methodsFor: 'tests - printing' stamp: 'Milos 4/29/2011 18:37'!
testPrintNameOn

	| aStream result |
	result:=''.
	aStream:= ReadWriteStream on: result.
	
	self nonEmpty printNameOn: aStream .
	Transcript show: result asString.
	self nonEmpty class name first isVowel
		ifTrue:[ self assert: aStream contents =('an ',self nonEmpty class name ) ]
		ifFalse:[self assert: aStream contents =('a ',self nonEmpty class name)].! !

!SMutantSetTest methodsFor: 'tests - printing' stamp: 'Milos 4/29/2011 18:37'!
testPrintOn
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i=1
			ifTrue:[
			self accessCollection class name first isVowel 
				ifTrue:[self assert: (allElementsAsString at:i)='an' ]
				ifFalse:[self assert: (allElementsAsString at:i)='a'].].
		i=2
			ifTrue:[self assert: (allElementsAsString at:i)=self accessCollection class name].
		i>2
			ifTrue:[self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).].	
			].! !

!SMutantSetTest methodsFor: 'tests - printing' stamp: 'Milos 4/29/2011 18:37'!
testPrintOnDelimiter
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	
	
	self nonEmpty printOn: aStream delimiter: ', ' .
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i))
			].! !

!SMutantSetTest methodsFor: 'tests - printing' stamp: 'Milos 4/29/2011 18:37'!
testPrintOnDelimiterLast

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream delimiter: ', ' last: 'and'.
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 )
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self deny: (allElementsAsString at:i)=('and')asString].
		i=(allElementsAsString size)
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
			].! !

!SMutantSetTest methodsFor: 'sunit original tests' stamp: 'Milos 4/29/2011 18:36'!
testRemove
	full remove: 4.
	self assert: (full includes: 3).
	self deny: (full includes: 4).! !

!SMutantSetTest methodsFor: 'tests' stamp: 'Milos 4/29/2011 18:36'!
testRemoveAll
	"Allows one to remove all elements of a collection" 
	
	| c1 c2 s2 |
	c1 := full.
	c2 := c1 copy.
	s2 := c2 size.
	
	c1 removeAll.
	
	self assert: c1 size = 0.
	self assert: c2 size = s2 description: 'the copy has not been modified'.! !

!SMutantSetTest methodsFor: 'tests - remove' stamp: 'Milos 4/29/2011 18:37'!
testRemoveAllError
	"self debug: #testRemoveElementThatExists"
	| el res subCollection |
	el := self elementNotIn.
	subCollection := self nonEmptyWithoutEqualElements copyWith: el.
	self 
		should: [ res := self nonEmptyWithoutEqualElements removeAll: subCollection ]
		raise: Error! !

!SMutantSetTest methodsFor: 'tests - remove' stamp: 'Milos 4/29/2011 18:37'!
testRemoveAllFoundIn
	"self debug: #testRemoveElementThatExists"
	| el res subCollection |
	el := self nonEmptyWithoutEqualElements anyOne.
	subCollection := (self nonEmptyWithoutEqualElements copyWithout: el) copyWith: self elementNotIn.
	self 
		shouldnt: 
			[ res := self nonEmptyWithoutEqualElements removeAllFoundIn: subCollection ]
		raise: Error.
	self assert: self nonEmptyWithoutEqualElements size = 1.
	self nonEmptyWithoutEqualElements do: [ :each | self assert: each = el ]! !

!SMutantSetTest methodsFor: 'tests - remove' stamp: 'Milos 4/29/2011 18:37'!
testRemoveAllSuchThat
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self nonEmptyWithoutEqualElements anyOne.
	subCollection := self nonEmptyWithoutEqualElements copyWithout: el.
	self nonEmptyWithoutEqualElements removeAllSuchThat: [ :each | subCollection includes: each ].
	self assert: self nonEmptyWithoutEqualElements size = 1.
	self nonEmptyWithoutEqualElements do: [ :each | self assert: each = el ]! !

!SMutantSetTest methodsFor: 'tests - remove' stamp: 'Milos 4/29/2011 18:37'!
testRemoveElementFromEmpty
	"self debug: #testRemoveElementFromEmpty"
	self 
		should: [ self empty remove: self nonEmptyWithoutEqualElements anyOne ]
		raise: Error! !

!SMutantSetTest methodsFor: 'tests - remove' stamp: 'Milos 4/29/2011 18:37'!
testRemoveElementReallyRemovesElement
	"self debug: #testRemoveElementReallyRemovesElement"
	| size |
	size := self nonEmptyWithoutEqualElements size.
	self nonEmptyWithoutEqualElements remove: self nonEmptyWithoutEqualElements anyOne.
	self assert: size - 1 = self nonEmptyWithoutEqualElements size! !

!SMutantSetTest methodsFor: 'tests - remove' stamp: 'Milos 4/29/2011 18:37'!
testRemoveElementThatExists
	"self debug: #testRemoveElementThatExists"
	| el res |
	el := self nonEmptyWithoutEqualElements anyOne.
	self 
		shouldnt: [ res := self nonEmptyWithoutEqualElements remove: el ]
		raise: Error.
	self assert: res == el! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:36'!
testRemoveIfAbsent
	| result1 result2  |
	result1 := true.
	result2 := true.
	full remove: 8 ifAbsent: [ result1 := false ].
	self assert: (result1 = false).
	full remove: 4 ifAbsent: [ result2 := false ].
	self assert: (result2 = true).
	
	
	! !

!SMutantSetTest methodsFor: 'tests - size capacity' stamp: 'Milos 4/29/2011 18:37'!
testSize

	| size |
	self assert: self empty size = 0.
	size := 0.
	self sizeCollection do: [ :each | size := size + 1].
	
	self assert: self sizeCollection size = size.! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:36'!
testSize2
	self assert: (empty size = 0).
	self assert: (full size = 4).
	empty add: 2.
	empty add: 1.
	full add: 2.
	self assert: (empty size = 2).
	self assert: (full size = 4).
	empty remove: 2.
	self assert: (empty size = 1).! !

!SMutantSetTest methodsFor: 'tests - printing' stamp: 'Milos 4/29/2011 18:37'!
testStoreOn
" for the moment work only for collection that include simple elements such that Integer"

"| string str result cuttedResult index elementsAsStringExpected elementsAsStringObtained tmp |
string := ''.
str := ReadWriteStream  on: string.
elementsAsStringExpected := OrderedCollection new.
elementsAsStringObtained := OrderedCollection new.
self nonEmpty do: [ :each | elementsAsStringExpected  add: each asString].

self nonEmpty storeOn: str.
result := str contents .
cuttedResult := ( result findBetweenSubStrs: ';' ).

index := 1.

cuttedResult do:
	[ :each |
	index = 1 
		ifTrue: [ self assert: (each beginsWith: ( tmp := '((' , self nonEmpty class asString , ' new) add: '           )).
				tmp := each copyFrom: ( tmp size + 1) to: ( each size ).
				elementsAsStringObtained add: tmp.
				index := index + 1. ]
		ifFalse:  [ 
		 index < cuttedResult size
			ifTrue:[self assert: (each beginsWith: ( tmp:=  ' add: '   )).
				tmp := each copyFrom: ( tmp size + 1) to: ( each size ).
				elementsAsStringObtained add: tmp.
					index := index + 1.]
			ifFalse: [self assert: ( each = ' yourself)' ) ].
			]
	
	].


	elementsAsStringExpected do: [ :each | self assert: (elementsAsStringExpected occurrencesOf: each ) = ( elementsAsStringObtained occurrencesOf: each) ]"

! !

!SMutantSetTest methodsFor: 'tests - adding uniquely' stamp: 'Milos 4/29/2011 18:36'!
testTAddIfNotPresentWithElementAlreadyIn

	| added oldSize |
	oldSize := self collectionWithElement size.
	self assert: (self collectionWithElement includes: self element).

	added := self collectionWithElement addIfNotPresent: self element.
	
	self assert: added = self element.
	self assert: (self collectionWithElement includes: self element).
	self assert: self collectionWithElement size = oldSize.! !

!SMutantSetTest methodsFor: 'tests - adding uniquely' stamp: 'Milos 4/29/2011 18:36'!
testTAddIfNotPresentWithNewElement
	| added oldSize |
	oldSize := self collectionWithoutElement size.
	self deny: (self collectionWithoutElement includes: self element).
	added := self collectionWithoutElement addIfNotPresent: self element.
	self assert: added = self element.
	self assert: (self collectionWithoutElement includes: self element).
	self assert: self collectionWithoutElement size = (oldSize + 1)! !

!SMutantSetTest methodsFor: 'some tests' stamp: 'Milos 4/29/2011 18:44'!
testUnion
	| newFull col newCol |
	full add: 3.
	full add: 2.
	col := full union: full.
	self assert: (full = col).

	newFull := SMutantSet with: 8 with: 9 with: #z.
	col := newFull union: full.
	self assert: (col size = (full size + newFull size)).
	self assert: ((col select: [:each | (full includes: each) not]) = newFull).
	self assert: ((col select: [:each | (newFull includes: each) not]) = full).

	full add: 9.
	col := newFull union: full.
	newCol := newFull copy.
	newCol remove: 9.
	self assert: (col size = (full size + newFull size - 1)).
	self assert: ((col select: [:each | (full includes: each) not]) = newCol).
	newCol := full copy.
	newCol remove: 9.
	self assert: ((col select: [:each | (newFull includes: each) not]) = newCol).
	
	
	! !

!SMutantSetTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/29/2011 18:37'!
testUnionOfEmpties
	"self debug: #testUnionOfEmpties"
	
	self assert:  (self empty union: self empty) isEmpty.
	
	! !

!SMutantSetTest methodsFor: 'test - creation' stamp: 'Milos 4/29/2011 18:36'!
testWith
	"self debug: #testWith"
	
	| aCol element |
	element := self collectionMoreThan5Elements anyOne.
	aCol := self collectionClass with: element.
	self assert: (aCol includes: element).! !

!SMutantSetTest methodsFor: 'test - creation' stamp: 'Milos 4/29/2011 18:36'!
testWithAll
	"self debug: #testWithAll"
	
	| aCol collection |
	collection := self collectionMoreThan5Elements asOrderedCollection .
	aCol := self collectionClass withAll: collection  .
	
	collection do: [ :each | self assert: (aCol occurrencesOf: each ) = ( collection occurrencesOf: each ) ].
	
	self assert: (aCol size = collection size ).! !

!SMutantSetTest methodsFor: 'test - creation' stamp: 'Milos 4/29/2011 18:36'!
testWithWith
	"self debug: #testWithWith"
	
	| aCol collection element1 element2 |
	collection := self collectionMoreThan5Elements asOrderedCollection copyFrom: 1 to: 2  .
	element1 := collection at: 1.
	element2 := collection at:2.
	
	aCol := self collectionClass with: element1  with: element2 .
	self assert: (aCol occurrencesOf: element1 ) == ( collection occurrencesOf: element1).
	self assert: (aCol occurrencesOf: element2 ) == ( collection occurrencesOf: element2).
	
	! !

!SMutantSetTest methodsFor: 'test - creation' stamp: 'Milos 4/29/2011 18:36'!
testWithWithWith
	"self debug: #testWithWithWith"
	
	| aCol collection |
	collection := self collectionMoreThan5Elements asOrderedCollection copyFrom:1 to: 3 .
	aCol := self collectionClass with: (collection at:1) with: ( collection at:2 ) with: ( collection at: 3).

	1 to: 3 do: [ :i | self assert: ( aCol occurrencesOf: ( collection at: i ) ) = ( collection occurrencesOf: ( collection at: i ) ) ].! !

!SMutantSetTest methodsFor: 'test - creation' stamp: 'Milos 4/29/2011 18:36'!
testWithWithWithWith
	"self debug: #testWithWithWithWith"
	
	| aCol collection |
	collection := self collectionMoreThan5Elements asOrderedCollection copyFrom: 1 to: 4.
	aCol := self collectionClass with: (collection at:1) with: ( collection at:2 ) with: ( collection at: 3) with: ( collection at: 4).

	1 to: 3 do: [ :i | self assert: ( aCol occurrencesOf: ( collection at: i ) ) = ( collection occurrencesOf: ( collection at: i ) ) ].! !

!SMutantSetTest methodsFor: 'test - creation' stamp: 'Milos 4/29/2011 18:36'!
testWithWithWithWithWith
	"self debug: #testWithWithWithWithWith"
	
	| aCol collection |
	collection := self collectionMoreThan5Elements asOrderedCollection copyFrom: 1 to: 5 .
	aCol := self collectionClass with: (collection at:1) with: ( collection at:2 ) with: ( collection at: 3) with: (collection at: 4 ) with: ( collection at: 5 ).

	1 to: 3 do: [ :i | self assert: ( aCol occurrencesOf: ( collection at: i ) ) = ( collection occurrencesOf: ( collection at: i ) ) ].! !

RBParseTreeRewriter subclass: #FalsifierTreeRewriter
	instanceVariableNames: 'falsifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!FalsifierTreeRewriter class methodsFor: 'instance creation' stamp: 'Milos 5/26/2011 13:01'!
withFalsifier: aFalsifier
	^ self new setWithFalsifier: aFalsifier! !

!FalsifierTreeRewriter methodsFor: 'visitor-double dispatching' stamp: 'Milos 5/26/2011 13:10'!
acceptVariableNode: aVariableNode
	| newName |
	newName := falsifier newNameFor: aVariableNode name asSymbol.
	newName notNil
		ifTrue: [ aVariableNode identifierToken: newName ]! !

!FalsifierTreeRewriter methodsFor: 'initialize-release' stamp: 'Milos 5/26/2011 13:03'!
setWithFalsifier: aFalsifier
	falsifier := aFalsifier! !

RBParseTreeRewriter subclass: #MutationTreeRewriter
	instanceVariableNames: 'foundMutation mutateMessageId currentMessageId operator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MutationTreeRewriter commentStamp: 'Milos 4/29/2011 15:52' prior: 0!
Traverses the AST of the original method and detects single points in code to be mutated.

Instance Variables
	currentMessageId:		<Object>
	foundMutation:		<Object>
	mutateMessageId:		<Object>
	operator:		<Object>

currentMessageId
	- xxxxx

foundMutation
	- xxxxx

mutateMessageId
	- xxxxx

operator
	- xxxxx
!

!MutationTreeRewriter methodsFor: 'visitor-double dispatching' stamp: 'Milos 4/24/2011 18:26'!
acceptMessageNode: aMessageNode
	| plusSelector variableNode messageNode arguments |
	aMessageNode selector = operator first
		ifTrue: [ 
			(currentMessageId = mutateMessageId and: [ foundMutation not ])
				ifTrue: [ 
					foundMutation := true.
					variableNode := RBVariableNode named: #RetroReplacementOperatorRuntime.
					plusSelector := (RetroReplacementOperatorRuntime class methodDict at: operator third) selector.
					arguments := Array with: aMessageNode receiver with: (aMessageNode arguments at: 1).
					aMessageNode
						receiver: variableNode;
						arguments: arguments;
						selector: plusSelector ].
			currentMessageId := currentMessageId + 1 ].
	super acceptMessageNode: aMessageNode! !

!MutationTreeRewriter methodsFor: 'accessing' stamp: 'Milos 4/23/2011 12:53'!
foundMutation
	^ foundMutation! !

!MutationTreeRewriter methodsFor: 'accessing' stamp: 'Milos 4/23/2011 13:16'!
foundMutation: aBoolean
	foundMutation := aBoolean! !

!MutationTreeRewriter methodsFor: 'initialize-release' stamp: 'Milos 4/24/2011 15:33'!
foundMutation: aBoolean mutateMessageId: aMutateMessageId currentMessageId: aCurrentMessageId operator: anOperator
	foundMutation := aBoolean.
	mutateMessageId := aMutateMessageId.
	currentMessageId := aCurrentMessageId.
	operator := anOperator! !

TestCase subclass: #BankAccountTest
	instanceVariableNames: 'bankAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!BankAccountTest methodsFor: 'running' stamp: 'Milos 3/13/2011 19:24'!
setUp
	bankAccount := BankAccount balance: 50.! !

!BankAccountTest methodsFor: 'tests' stamp: 'Milos 4/22/2011 20:52'!
testDeposit
	bankAccount deposit: 50.
	bankAccount deposit: 20.
	self assert: [bankAccount balance = 120].! !

!BankAccountTest methodsFor: 'tests' stamp: 'Milos 3/13/2011 19:25'!
testWithdrawSuccessful
	bankAccount withdraw: 30.
	self assert: [bankAccount balance = 20].! !

!BankAccountTest methodsFor: 'tests' stamp: 'Milos 3/13/2011 19:25'!
testWithdrawUnsuccessful
	bankAccount withdraw: 70.
	self assert: [bankAccount balance = 50].! !

TestCase subclass: #CallMutationFactoryTest
	instanceVariableNames: 'callMutationFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Test'!

!CallMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 4/23/2011 11:10'!
testAllDifferentMessages
	callMutationFactory := CallMutationFactory mutationClasses: ({AllDifferentMessages}).
	callMutationFactory createMutations.
	self should: [ callMutationFactory mutations size = 0 ]! !

!CallMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 01:44'!
testAllSameMessages
	callMutationFactory := CallMutationFactory mutationClasses: ({AllSameMessages}).
	callMutationFactory createMutations.
	self should: [ callMutationFactory mutations size = 6 ].
	self should: [ callMutationFactory includes: AllSameMessages origMsgName: #message0: replMsgName: #message1: ].
	self should: [ callMutationFactory includes: AllSameMessages origMsgName: #message0: replMsgName: #message2: ].
	self should: [ callMutationFactory includes: AllSameMessages origMsgName: #message1: replMsgName: #message0: ].
	self should: [ callMutationFactory includes: AllSameMessages origMsgName: #message1: replMsgName: #message2: ].
	self should: [ callMutationFactory includes: AllSameMessages origMsgName: #message2: replMsgName: #message0: ].
	self should: [ callMutationFactory includes: AllSameMessages origMsgName: #message2: replMsgName: #message1: ].
	self
		shouldnt: [ callMutationFactory includes: AllSameMessages origMsgName: #message2: replMsgName: #message11: ]
		raise: 'incorrect mutation'! !

!CallMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 4/23/2011 11:10'!
testMultipleClasses
	callMutationFactory := CallMutationFactory
		mutationClasses:
			({BankAccount.
			AllDifferentMessages.
			AllSameMessages}).
	callMutationFactory createMutations.
	self should: [ callMutationFactory mutations size = 12 ]! !

!CallMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 4/23/2011 11:10'!
testWithBankAccount
	callMutationFactory := CallMutationFactory mutationClasses: ({BankAccount}).
	callMutationFactory createMutations.
	self should: [ callMutationFactory mutations size = 6 ]! !

TestCase subclass: #CmdMutationTesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Test'!

!CmdMutationTesterTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 14:57'!
testWithCallMutationFactory
	| cmdMutationTester mutationClasses mutationFactories |
	mutationClasses := {BankAccount}.
	mutationFactories := {CallMutationFactory mutationClasses: mutationClasses}.
	cmdMutationTester := CmdMutationTester
		testClasses: {BankAccountTest}
		mutationClasses: mutationClasses
		mutationFactories: mutationFactories.
	cmdMutationTester runMutations.
	self should: [ cmdMutationTester numOfAllMutations = 6 ].
	self should: [ cmdMutationTester numOfHitMutations = 6 ].
	self should: [ cmdMutationTester numOfKilledMutations = 6 ]! !

!CmdMutationTesterTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 14:57'!
testWithCallMutationFactory2
	| cmdMutationTester mutationClasses mutationFactories |
	mutationClasses := {BankAccount}.
	mutationFactories := {CallMutationFactory mutationClasses: mutationClasses}.
	cmdMutationTester := CmdMutationTester
		testClasses: {SimpleBankAccountTest}
		mutationClasses: mutationClasses
		mutationFactories: mutationFactories.
	cmdMutationTester runMutations.
	self should: [ cmdMutationTester numOfAllMutations = 6 ].
	self should: [ cmdMutationTester numOfHitMutations = 4 ].
	self should: [ cmdMutationTester numOfKilledMutations = 4 ]! !

!CmdMutationTesterTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 18:11'!
testWithMutationFactories
	| cmdMutationTester |
	cmdMutationTester := CmdMutationTester
		testClasses: ({BankAccountTest})
		mutationClasses: ({BankAccount})
		mutationFactories:
			({CallMutationFactory mutationClasses: ({BankAccount}).
			RetroMutationFactory
				mutationClasses: ({BankAccount})
				replacementOperators: ({RetroReplacementOperatorFactory singleton original: #+ replacement: #-})}).
	cmdMutationTester runMutations.
	self should: [ cmdMutationTester numOfAllMutations = 7 ].
	self should: [ cmdMutationTester numOfHitMutations = 6 ]. "to fix"
	self should: [ cmdMutationTester numOfKilledMutations = 7 ]! !

!CmdMutationTesterTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 18:11'!
testWithRetroMutationFactory
	| cmdMutationTester |
	cmdMutationTester := CmdMutationTester
		testClasses: ({BankAccountTest})
		mutationClasses: ({BankAccount})
		mutationFactories:
			({RetroMutationFactory
				mutationClasses: ({BankAccount})
				replacementOperators: ({RetroReplacementOperatorFactory singleton original: #+ replacement: #-})}).
	cmdMutationTester runMutations.
	self should: [ cmdMutationTester numOfAllMutations = 1 ].
	self should: [ cmdMutationTester numOfHitMutations = 0 ]. "to fix"
	self should: [ cmdMutationTester numOfKilledMutations = 1 ]! !

!CmdMutationTesterTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 18:14'!
testWithRetroMutationFactory2
	| cmdMutationTester |
	cmdMutationTester := CmdMutationTester
		testClasses: ({PlusExampleTest})
		mutationClasses: ({PlusExample})
		mutationFactories:
			({RetroMutationFactory
				mutationClasses: ({PlusExample})
				replacementOperators: ({RetroReplacementOperatorFactory singleton original: #+ replacement: #-})}).
	cmdMutationTester runMutations.
	self should: [ cmdMutationTester numOfAllMutations = 5 ].
	self should: [ cmdMutationTester numOfHitMutations = 0 ]. "to fix"
	self should: [ cmdMutationTester numOfKilledMutations = 0 ]! !

TestCase subclass: #MutationTestCase
	instanceVariableNames: 'mutation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!MutationTestCase commentStamp: 'Milos 4/29/2011 15:44' prior: 0!
Contains a list of classes to be mutated, a list of test cases to be used, and a list of mutation factories.

Instance Variables
!

MutationTestCase subclass: #BankAccountMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!BankAccountMutationTest methodsFor: 'mutation' stamp: 'Milos 4/8/2011 13:14'!
classesToMutate
	^ { BankAccount }.! !

!BankAccountMutationTest methodsFor: 'mutation' stamp: 'Milos 4/8/2011 13:14'!
classesWithTestCases
	^ { BankAccountTest }.! !

MutationTestCase subclass: #DictionaryMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!DictionaryMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/10/2011 20:15'!
classesToMutate 
	^ { Dictionary }! !

!DictionaryMutationTest methodsFor: 'mutation' stamp: 'Milos 4/13/2011 09:31'!
classesWithTestCases 
	^ { DictionaryTest }! !

MutationTestCase subclass: #KeyedSetMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!KeyedSetMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/21/2011 00:08'!
classesToMutate
	^ { KeyedSet }.
	! !

!KeyedSetMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/21/2011 00:05'!
classesWithTestCases
	^ { KeyedSetTest }.! !

MutationTestCase subclass: #LinkedListMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!LinkedListMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/20/2011 22:52'!
classesToMutate
	^ { LinkedList }.! !

!LinkedListMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/20/2011 22:52'!
classesWithTestCases 
	^ { LinkedListTest }.! !

MutationTestCase subclass: #MatrixMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!MatrixMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/20/2011 23:29'!
classesToMutate
	^ { Matrix }.! !

!MatrixMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/20/2011 23:34'!
classesWithTestCases
	^ { MatrixTest }.! !

!MutationTestCase class methodsFor: 'building suites' stamp: 'Milos 4/25/2011 00:33'!
addToSuite: suite fromMethods: testMethods factories: theFactories
	| thisTestCase mutations |
	thisTestCase := self new.
	mutations := OrderedCollection new.
	theFactories
		do: [ :factory | 
			factory mutationClasses: thisTestCase classesToMutate.
			factory createMutations.
			mutations addAll: factory mutations ].
	mutations do: [ :mutation | suite addTest: (self new mutation: mutation) ].
	^ suite! !

!MutationTestCase class methodsFor: 'building suites' stamp: 'Milos 4/25/2011 00:15'!
addToSuiteFromSelectors: suite factories: theFactories
	^self addToSuite: suite fromMethods: (self shouldInheritSelectors
		ifTrue: [ self allTestSelectors ]
		ifFalse: [self testSelectors ]) factories: theFactories! !

!MutationTestCase class methodsFor: 'testing' stamp: 'Milos 4/8/2011 13:24'!
isAbstract
	(name = #MutationTestCase)
		ifTrue: [^true]
		ifFalse: [^super isAbstract].! !

!MutationTestCase class methodsFor: 'mapping' stamp: 'Milos 4/25/2011 00:08'!
operatorsToFactories! !

!MutationTestCase class methodsFor: 'testing' stamp: 'Sandro 4/18/2011 22:25'!
selector: aSymbol
	^self new setTestSelector: aSymbol.! !

!MutationTestCase methodsFor: 'mutation' stamp: 'Milos 4/8/2011 13:11'!
classesToMutate
	^self subclassResponsibility.! !

!MutationTestCase methodsFor: 'mutation' stamp: 'Milos 4/8/2011 13:13'!
classesWithTestCases
	^self subclassResponsibility.! !

!MutationTestCase methodsFor: 'private' stamp: 'Sandro 4/23/2011 16:23'!
cleanUpInstanceVariables
	self class allInstVarNames do: [ :name |
		(name = 'testSelector' or: [name = 'mutation']) ifFalse: [
			self instVarNamed: name put: nil ] ].! !

!MutationTestCase methodsFor: 'mutation' stamp: 'Sandro 4/23/2011 16:22'!
mutation: theMutation
	super setTestSelector: #testEntry.
	mutation := theMutation! !

!MutationTestCase methodsFor: 'mutation' stamp: 'Milos 4/25/2011 00:07'!
mutationFactories
	"This method is valid only if cmd version is used."
	^ {CallMutationFactory mutationClasses: self classesToMutate.
	RetroMutationFactory mutationClasses: self classesToMutate replacementOperators: ({})}! !

!MutationTestCase methodsFor: 'mutation' stamp: 'Milos 4/24/2011 03:12'!
performTest
	| runner |
	runner := MutationTester testClasses: self classesWithTestCases asOrderedCollection mutationClasses: self classesToMutate.
	runner runSingleMutation: mutation.
	mutation killed not
		ifTrue: [ self error: 'Mutation not killed.' ]! !

!MutationTestCase methodsFor: 'printing' stamp: 'Milos 5/7/2011 12:18'!
printOn: aStream
	mutation printOn: aStream
	"	aStream
		nextPutAll: mutation mutatedClass printString;
		nextPutAll: '>>#';
		nextPutAll: mutation originalSelector;
		nextPutAll: '=>';
		nextPutAll: '#';
		nextPutAll: mutation replacementSelector"! !

!MutationTestCase methodsFor: 'mutation' stamp: 'Milos 4/20/2011 14:50'!
testEntry! !

MutationTestCase subclass: #SMutantLinkedListMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!SMutantLinkedListMutationTest methodsFor: 'mutation' stamp: 'Milos 4/20/2011 23:15'!
classesToMutate
	^ { SMutantLinkedList }.! !

!SMutantLinkedListMutationTest methodsFor: 'mutation' stamp: 'Milos 4/20/2011 23:15'!
classesWithTestCases
	^ { SMutantLinkedListTest }.! !

MutationTestCase subclass: #SMutantSetMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!SMutantSetMutationTest methodsFor: 'mutation' stamp: 'Milos 4/29/2011 18:49'!
classesToMutate
	^ { SMutantSet }! !

!SMutantSetMutationTest methodsFor: 'mutation' stamp: 'Milos 4/29/2011 18:49'!
classesWithTestCases
	^ { SMutantSetTest }! !

MutationTestCase subclass: #StackMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!StackMutationTest methodsFor: 'mutation' stamp: 'Milos 4/13/2011 10:49'!
classesToMutate 
	^ { Stack }! !

!StackMutationTest methodsFor: 'mutation' stamp: 'Milos 4/13/2011 10:49'!
classesWithTestCases
	^ { StackTest }! !

MutationTestCase subclass: #TranscriptMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!TranscriptMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/10/2011 20:11'!
classesToMutate 
	^ { ThreadSafeTranscript }! !

!TranscriptMutationTest methodsFor: 'mutation' stamp: 'Milos 4/13/2011 09:31'!
classesWithTestCases 
	^ { TranscriptTest }! !

MutationTestCase subclass: #WriteStreamMutationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Evaluation'!

!WriteStreamMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/10/2011 19:43'!
classesToMutate
	^ { WriteStream }! !

!WriteStreamMutationTest methodsFor: 'mutation' stamp: 'Sandro 4/10/2011 19:44'!
classesWithTestCases
	^ { WriteStreamTest }! !

TestCase subclass: #PlusExampleTest
	instanceVariableNames: 'plusExample'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!PlusExampleTest methodsFor: 'running' stamp: 'Milos 4/24/2011 18:07'!
setUp
	plusExample := PlusExample new! !

!PlusExampleTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 18:14'!
testMethodWithPlus
	| result |
	result := plusExample methodWithPlus: 3 and: 5.
	self should: [ result = 8 or: [ result = -2 ] ]! !

TestCase subclass: #RetroMutationFactoryTest
	instanceVariableNames: 'retroMutationFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Test'!

!RetroMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 5/25/2011 21:35'!
testAndToOr
	retroMutationFactory := RetroMutationFactory
		mutationClasses: ({ConditionalExample})
		replacementOperators:
			({RetroReplacementOperatorFactory singleton original: #and: replacement: #or:}).
	retroMutationFactory createMutations.
	self should: [ retroMutationFactory numOfMutations = 1 ]! !

!RetroMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 5/7/2011 11:43'!
testGtToX
	retroMutationFactory := RetroMutationFactory
		mutationClasses: ({RelationalExample})
		replacementOperators:
			({RetroReplacementOperatorFactory singleton original: #> replacement: #>=.
			RetroReplacementOperatorFactory singleton original: #> replacement: #=.
			RetroReplacementOperatorFactory singleton original: #> replacement: #~=.
			RetroReplacementOperatorFactory singleton original: #> replacement: #<=.
			RetroReplacementOperatorFactory singleton original: #> replacement: #<}).
	retroMutationFactory createMutations.
	self should: [ retroMutationFactory numOfMutations = 5 ]! !

!RetroMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 17:37'!
testNoOperators
	retroMutationFactory := RetroMutationFactory mutationClasses: ({PlusExample}) replacementOperators: ({}).
	retroMutationFactory createMutations.
	self should: [ retroMutationFactory numOfMutations = 0 ]! !

!RetroMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 17:42'!
testNoOperators2
	retroMutationFactory := RetroMutationFactory
		mutationClasses: ({PlusExample})
		replacementOperators: ({RetroReplacementOperatorFactory singleton original: #* replacement: #+}).
	retroMutationFactory createMutations.
	self should: [ retroMutationFactory numOfMutations = 0 ]! !

!RetroMutationFactoryTest methodsFor: 'testing' stamp: 'Milos 4/24/2011 17:32'!
testPlusToMinus
	retroMutationFactory := RetroMutationFactory
		mutationClasses: ({PlusExample})
		replacementOperators: ({RetroReplacementOperatorFactory singleton original: #+ replacement: #-}).
	retroMutationFactory createMutations.
	self should: [ retroMutationFactory numOfMutations = 5 ]! !

TestCase subclass: #RetroReplacementOperatorFactoryTest
	instanceVariableNames: 'replacementOperatorFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Test'!

!RetroReplacementOperatorFactoryTest methodsFor: 'running' stamp: 'Milos 4/24/2011 16:16'!
setUp
	replacementOperatorFactory := RetroReplacementOperatorFactory singleton! !

!RetroReplacementOperatorFactoryTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 16:17'!
testExist
	| replacementOperator |
	replacementOperator := replacementOperatorFactory original: #+ replacement: #-.
	self should: [ replacementOperator notNil ].
	self should: [ replacementOperator first = #+ ].
	self should: [ replacementOperator second = #- ].
	self should: [ replacementOperator third = #plus:toMinus: ]! !

!RetroReplacementOperatorFactoryTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 16:17'!
testNotExist
	self should: [ (replacementOperatorFactory original: #+ replacement: #!!) = nil ]! !

!RetroReplacementOperatorFactoryTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 16:17'!
testSingleton
	self should: [ replacementOperatorFactory == RetroReplacementOperatorFactory singleton ]! !

TestCase subclass: #RetroReplacementOperatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Test'!

!RetroReplacementOperatorTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 18:28'!
testEqualThree
	| triple1 triple2 |
	triple1 := RetroReplacementOperator first: #+ second: #- third: #something.
	triple2 := RetroReplacementOperator first: #+ second: #- third: #else.
	self should: [ triple1 = triple2 ]! !

!RetroReplacementOperatorTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 18:28'!
testEqualTwo
	| triple1 triple2 |
	triple1 := RetroReplacementOperator first: #+ second: #-.
	triple2 := RetroReplacementOperator first: #+ second: #-.
	self should: [ triple1 = triple2 ]! !

!RetroReplacementOperatorTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 18:28'!
testNotEqual
	| triple1 triple2 |
	triple1 := RetroReplacementOperator first: #+ second: #-.
	triple2 := RetroReplacementOperator first: #+ second: #*.
	self shouldnt: [ triple1 = triple2 ]! !

TestCase subclass: #SMutantLinkedListTest
	uses: TAddTest - {#testTAddWithOccurences. #testTAddTwice. #testTWriteTwice} + TEmptyTest + TIterateTest + TIterateSequencedReadableTest + TPrintTest + TAsStringCommaAndDelimiterSequenceableTest + TIndexAccess + TSequencedElementAccessTest + TSubCollectionAccess + TConvertTest - {#testAsByteArray. #integerCollectionWithoutEqualElements} + TCopyPartOfSequenceable - {#testCopyEmptyMethod} + TCopySequenceableSameContents - {#testSortBy. #integerCollection} + TCopySequenceableWithOrWithoutSpecificElements + TCopyTest + TCopySequenceableWithReplacement - {#testCopyReplaceAllWithManyOccurence. #collectionWith2TimeSubcollection} + TBeginsEndsWith + TRemoveTest + TSetArithmetic + TIncludesWithIdentityCheckTest + TStructuralEqualityTest + TOccurrencesTest
	instanceVariableNames: 'nextLink n list link1 link2 link3 link4 nonEmpty otherList link result collectionWithNil collectionWithoutNil nonEmpty1Element collectionWithoutEqualElements elementNotIn elementIn sameAtendAndBegining collection5Elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

SMutantLinkedListTest class
	uses: TAddTest classTrait + TEmptyTest classTrait + TIterateTest classTrait + TIterateSequencedReadableTest classTrait + TPrintTest classTrait + TAsStringCommaAndDelimiterSequenceableTest classTrait + TIndexAccess classTrait + TSequencedElementAccessTest classTrait + TSubCollectionAccess classTrait + TConvertTest classTrait + TCopyPartOfSequenceable classTrait + TCopySequenceableSameContents classTrait + TCopySequenceableWithOrWithoutSpecificElements classTrait + TCopyTest classTrait + TCopySequenceableWithReplacement classTrait + TBeginsEndsWith classTrait + TRemoveTest classTrait + TSetArithmetic classTrait + TIncludesWithIdentityCheckTest classTrait + TStructuralEqualityTest classTrait + TOccurrencesTest classTrait
	instanceVariableNames: ''!

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
accessCollection
	^collectionWithoutEqualElements ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
anotherElementNotIn
" return an element included  in 'collection' "
	^ elementNotIn ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection anyOne! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ elementNotIn ! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
assertNoDuplicates: aCollection whenConvertedTo: aClass 
	| result |
	result := self collectionWithEqualElements asIdentitySet.
	self assert: (result class includesBehavior: IdentitySet).
	self collectionWithEqualElements do: [ :initial | self assert: (result occurrencesOf: initial) = 1 ]! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
assertNonDuplicatedContents: aCollection whenConvertedTo: aClass 
	| result |
	result := aCollection perform: ('as' , aClass name) asSymbol.
	self assert: (result class includesBehavior: aClass).
	result do: 
		[ :each | 
		self assert: (aCollection occurrencesOf: each) = (result occurrencesOf: each) ].
	^ result! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
assertSameContents: aCollection whenConvertedTo: aClass 
	| result |
	result := self assertNonDuplicatedContents: aCollection whenConvertedTo: aClass.
	self assert: result size = aCollection size! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collection
	^ self nonEmpty! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:06'!
collectionClass
" return the class to be used to create instances of the class tested"
	^ SMutantLinkedList! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionMoreThan1NoDuplicates
	" return a collection of size 5 without equal elements"
	^ collectionWithoutEqualElements! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionNotIncluded
" return a collection for wich each element is not included in 'nonEmpty' "
	^ collectionWithoutNil ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWith1TimeSubcollection
" return a collection including 'oldSubCollection'  only one time "
	^ self oldSubCollection ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWithCopyNonIdentical
	" return a collection that include elements for which 'copy' return a different object (this is not the case of SmallInteger)"
	^ collectionWithoutEqualElements! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWithElement
	"Returns a collection that already includes what is returned by #element."
	^ self collection! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWithElementsToRemove
" return a collection of elements included in 'nonEmpty'  "
	^ self nonEmpty ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWithSortableElements
	" return a collection only including elements that can be sorted (understanding '<' )"
	^ collection5Elements ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^collectionWithoutEqualElements ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWithoutEqualsElements

" return a collection not including equal elements "
	^collectionWithoutEqualElements ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element "
	^collectionWithoutNil ! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
containsAll: union of: one andOf: another
			
	self assert: (one allSatisfy: [:each | union includes: each]).
	self assert: (another allSatisfy: [:each | union includes: each])! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
element
	^ link ifNil: [link := StackLink with: 42. "so that we can recognize this link"]! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
elementInForElementAccessing
" return an element inculded in 'accessCollection '"
	^ elementIn ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
elementInForIndexAccessing
" return an element included in 'accessCollection' "
	^ elementIn ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
elementNotIn
	^ Link new! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
elementNotInForElementAccessing
" return an element not included in 'accessCollection' "
	^ elementNotIn ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
elementNotInForIndexAccessing
" return an element not included in 'accessCollection' "
	^ elementNotIn ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
elementNotInForOccurrences
" return an element notIncluded in #collectionWithoutEqualElements"
	^ elementNotIn ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
elementToAdd
" return an element of type 'nonEmpy' elements'type'"
	^ Link new! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
empty
	^ list! !

!SMutantLinkedListTest methodsFor: 'tests - copying with replacement' stamp: 'Milos 4/20/2011 23:04'!
firstIndexesOf: subCollection in: collection
" return an OrderedCollection with the first indexes of the occurrences of subCollection in  collection "
	| tmp result currentIndex |
	tmp:= collection.
	result:= OrderedCollection new.
	currentIndex := 1.
	
	[tmp isEmpty ]whileFalse:
		[
		(tmp beginsWith: subCollection)
			ifTrue: [ 	
				result add: currentIndex.
				1 to: subCollection size do: 
					[:i | 
					tmp := tmp copyWithoutFirst.
					currentIndex := currentIndex + 1]
				]
			ifFalse: [
				tmp := tmp copyWithoutFirst.
				currentIndex := currentIndex +1.
				]
		 ].
	
	^ result.
	! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
howMany: subCollection in: collection
" return an integer representing how many time 'subCollection'  appears in 'collection'  "
	| tmp nTime |
	tmp:= collection.
	nTime:= 0.
	
	[tmp isEmpty ]whileFalse:
		[
		(tmp beginsWith: subCollection)
			ifTrue: [ 	
				nTime := nTime + 1.
				1 to: subCollection size do: [:i | tmp := tmp copyWithoutFirst.]
				]
			ifFalse: [tmp := tmp copyWithoutFirst.]
		 ].
	
	^ nTime.
	! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
indexInForCollectionWithoutDuplicates
" return an index between 'collectionWithoutEqualsElements'  bounds"
	^ 2! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
indexInNonEmpty
" return an index between bounds of 'nonEmpty' "

	^ self nonEmpty size! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
moreThan3Elements
	" return a collection including atLeast 3 elements"
	^ collectionWithoutEqualElements ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
moreThan4Elements

" return a collection including at leat 4 elements"
	^ collectionWithoutEqualElements ! !

!SMutantLinkedListTest methodsFor: 'accessing' stamp: 'Milos 4/20/2011 23:04'!
n
	^n! !

!SMutantLinkedListTest methodsFor: 'accessing' stamp: 'Milos 4/20/2011 23:04'!
n: number
	n := number.
	! !

!SMutantLinkedListTest methodsFor: 'accessing' stamp: 'Milos 4/20/2011 23:04'!
nextLink
	^nextLink! !

!SMutantLinkedListTest methodsFor: 'accessing' stamp: 'Milos 4/20/2011 23:04'!
nextLink: aLink
	nextLink := aLink! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
nonEmpty
	^ nonEmpty ifNil: [nonEmpty := LinkedList with: self element with: Link new]! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^ nonEmpty1Element ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
nonEmptyMoreThan1Element
" return a collection that don't includes equl elements'" 
	^collectionWithoutNil ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
nonEmptyWithoutEqualElements
" return a collection without equal elements "
	^ collectionWithoutEqualElements ! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
numberOfSimilarElementsInIntersection
	^ self collection occurrencesOf: self anotherElementOrAssociationIn! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
oldSubCollection
" return a subCollection included in collectionWith1TimeSubcollection .
ex :   subCollection := #( 2 3 4) and collectionWith1TimeSubcollection := #(1 2 3 4 5)"
	^ self nonEmpty ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:07'!
otherCollection
	^ otherList ifNil: [otherList := SMutantLinkedList with: Link new with: Link new]! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
replacementCollection
" return a collection that will be used to replace 'oldSubcollection' in ' collectionWith1TimeSubcollection'  " 
	^ collectionWithoutNil ! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
result
	"Returns a collection of the classes of elements in #collection"
	 ^ result! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
resultForCollectElementsClass
" return the retsult expected by collecting the class of each element of collectionWithoutNilElements"
	^ result .! !

!SMutantLinkedListTest methodsFor: 'running' stamp: 'Milos 4/20/2011 23:07'!
setUp
	
	super setUp.
	list := SMutantLinkedList new.
	link1 := Link new.
	link2 := Link new.
	link3 := Link new.
	link4 := Link new.
	elementNotIn := Link new.
	collectionWithoutNil := SMutantLinkedList new add: Link new; add: Link new ; add: Link new; yourself.
	elementIn := Link new.
	collectionWithoutEqualElements := SMutantLinkedList new add: elementIn ; add: Link new ; add: Link new; add: Link new;add: Link new;yourself.
	collection5Elements := collectionWithoutEqualElements .
	
	"sameAtendAndBegining := LinkedList new add: Link new; add: Link new ; add: Link new; yourself."
	result := {Link. Link. Link.}.
	link := StackLink with: 42.
	nonEmpty1Element :=  SMutantLinkedList new add: Link new; yourself.
	 "so that we can recognize this link"
	"nonEmpty := LinkedList with: link with: Link new."
	"otherList := LinkedList with: Link new with: Link new."
! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:08'!
speciesClass
	
	^SMutantLinkedList! !

!SMutantLinkedListTest methodsFor: 'requirements' stamp: 'Milos 4/20/2011 23:04'!
subCollectionNotIn
" return a collection for which at least one element is not included in 'accessCollection' "
	^ collectionWithoutNil ! !

!SMutantLinkedListTest methodsFor: 'running' stamp: 'Milos 4/20/2011 23:04'!
tearDown
	list := nil.
	link1 := nil.
	link2 := nil.
	link3 := nil.
	link4 := nil.
	
	link := nil.
	nonEmpty := nil.
	otherList := nil.
	
	^ super tearDown! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test01add
	self assert: list isEmpty.
	list add: link1.
	self assert: list size = 1.
	self assert: list first = link1.
	
	list add: link2.
	self assert: list size = 2.
	self assert: list first = link1.
	self assert: list second = link2.
	
	list add: link3.
	self assert: list size = 3.
	self assert: list first = link1.
	self assert: list second = link2.
	self assert: list third = link3.
	
	list add: link4.
	self assert: list size = 4.
	self assert: list first = link1.
	self assert: list second = link2.
	self assert: list third = link3.
	self assert: list fourth = link4! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test02addLast
	self assert: list isEmpty.
	
	list addLast: link1.
	self assert: list size = 1.
	self assert: list first = link1.
	
	list addLast: link2.
	self assert: list size = 2.
	self assert: list first = link1.
	self assert: list second = link2.
	
	list addLast: link3.
	self assert: list size = 3.
	self assert: list first = link1.
	self assert: list second = link2.
	self assert: list third = link3.
	
	list addLast: link4.
	self assert: list size = 4.
	self assert: list first = link1.
	self assert: list second = link2.
	self assert: list third = link3.
	self assert: list fourth = link4! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test03addFirst
	self assert: list isEmpty.
	
	list addFirst: link1.
	self assert: list size = 1.
	self assert: list first = link1.
	
	list addFirst: link2.
	self assert: list size = 2.
	self assert: list first = link2.
	self assert: list second = link1.
	
	list addFirst: link3.
	self assert: list size = 3.
	self assert: list first = link3.
	self assert: list second = link2.
	self assert: list third = link1.
	
	list addFirst: link4.
	self assert: list size = 4.
	self assert: list first = link4.
	self assert: list second = link3.
	self assert: list third = link2.
	self assert: list fourth = link1! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test04addBefore
	self assert: list isEmpty.
	
	list add: link1.
	self assert: list size = 1.
	self assert: list first == link1.
	
	list add: link2 before: link1.
	self assert: list size = 2.
	self assert: list first == link2.
	self assert: list second == link1.
	
	list add: link3 before: link1.
	self assert: list size = 3.
	self assert: list first == link2.
	self assert: list second == link3.
	self assert: list third == link1.
	
	list add: link4 before: link1.
	self assert: list size = 4.
	self assert: list first == link2.
	self assert: list second == link3.
	self assert: list third == link4.
	self assert: list fourth == link1! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test05addBefore
	self assert: list isEmpty.
	
	list add: link1.
	self assert: list size = 1.
	self assert: list first == link1.
	
	list add: link2 before: link1.
	self assert: list size = 2.
	self assert: list first == link2.
	self assert: list second == link1.
	
	list add: link3 before: link2.
	self assert: list size = 3.
	self assert: list first == link3.
	self assert: list second == link2.
	self assert: list third == link1.
	
	list add: link4 before: link3.
	self assert: list size = 4.
	self assert: list first == link4.
	self assert: list second == link3.
	self assert: list third == link2.
	self assert: list fourth == link1! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test06addAfter
	self assert: list isEmpty.
	
	list add: link1.
	self assert: list size = 1.
	self assert: list first == link1.
	
	list add: link2 after: link1.
	self assert: list size = 2.
	self assert: list first == link1.
	self assert: list second == link2.
	
	list add: link3 after: link2.
	self assert: list size = 3.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link3.
	
	list add: link4 after: link3.
	self assert: list size = 4.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link3.
	self assert: list fourth == link4! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test07addAfter
	self assert: list isEmpty.
	
	list add: link1.
	self assert: list size = 1.
	self assert: list first == link1.
	
	list add: link2 after: link1.
	self assert: list size = 2.
	self assert: list first == link1.
	self assert: list second == link2.
	
	list add: link3 after: link1.
	self assert: list size = 3.
	self assert: list first == link1.
	self assert: list second == link3.
	self assert: list third == link2.
	
	list add: link4 after: link1.
	self assert: list size = 4.
	self assert: list first == link1.
	self assert: list second == link4.
	self assert: list third == link3.
	self assert: list fourth == link2! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:08'!
test08addAfter
	| l first |
	l := SMutantLinkedList new.
	first := self class new n: 1.
	
	l add: first.
	l add: (self class new n: 3).

	self assert: (l collect:[:e | e n]) asArray  = #(1 3).
	
	l add: (self class new n: 2) after: first.

	self assert: (l collect:[:e | e n]) asArray  = #(1 2 3).! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:08'!
test09addAfter
	| l last |
	l := SMutantLinkedList new.
	last := self class new n: 2.
	l add: (self class new n: 1).
	l add: last.
	
	self assert: (l collect:[:e | e n]) asArray  = #(1 2).
	 
	l add: (self class new n: 3) after: last.

	self assert: (l collect:[:e | e n]) asArray  = #(1 2 3).! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0CopyTest
	self shouldnt: [ self empty ]raise: Error.
	self assert: self empty size = 0.
	self shouldnt: [ self nonEmpty ]raise: Error.
	self assert: (self nonEmpty size = 0) not.
	self shouldnt: [ self collectionWithElementsToRemove ]raise: Error.
	self assert: (self collectionWithElementsToRemove size = 0) not.
	self collectionWithElementsToRemove do: [:each | self assert: ( self nonEmpty includes: each)].
	
	self shouldnt: [ self elementToAdd ]raise: Error.
	self deny: (self nonEmpty includes: self elementToAdd ).
	self shouldnt: [ self collectionNotIncluded ]raise: Error.
	self collectionNotIncluded do: [ :each | self deny: (self nonEmpty includes: each) ]! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureAsStringCommaAndDelimiterTest
	
	self shouldnt: [self nonEmpty] raise:Error .
	self deny: self nonEmpty isEmpty.
	
	self shouldnt: [self empty] raise:Error .
	self assert: self empty isEmpty.
	
       self shouldnt: [self nonEmpty1Element ] raise:Error .
	self assert: self nonEmpty1Element size=1.! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureBeginsEndsWithTest

	self shouldnt: [self nonEmpty ] raise: Error.
	self deny: self nonEmpty isEmpty.
	self assert: self nonEmpty size>1.
	
	self shouldnt: [self empty ] raise: Error.
	self assert: self empty isEmpty.! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureCopyPartOfSequenceableTest
	
	self shouldnt: [self collectionWithoutEqualsElements ] raise: Error.
	self collectionWithoutEqualsElements do:
		[:each | self assert: (self collectionWithoutEqualsElements occurrencesOf: each)=1].
	
	self shouldnt: [self indexInForCollectionWithoutDuplicates ] raise: Error.
	self assert: self indexInForCollectionWithoutDuplicates >0 & self indexInForCollectionWithoutDuplicates < self collectionWithoutEqualsElements size.
	
	self shouldnt: [self empty] raise: Error.
	self assert: self empty isEmpty .! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureCopySameContentsTest

	self shouldnt: [self nonEmpty ] raise: Error.
	self deny: self nonEmpty isEmpty.
	
	self shouldnt: [self empty  ] raise: Error.
	self assert: self empty isEmpty.
	
! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureCopyWithOrWithoutSpecificElementsTest

	self shouldnt: [self nonEmpty ] raise: Error.
	self deny: self nonEmpty 	isEmpty .
		
	self shouldnt: [self indexInNonEmpty ] raise: Error.
	self assert: self indexInNonEmpty > 0. 
	self assert: self indexInNonEmpty <= self nonEmpty size.! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureCopyWithReplacementTest

	self shouldnt: [self replacementCollection   ]raise: Error.
	self shouldnt: [self oldSubCollection]  raise: Error.
	
	self shouldnt: [self collectionWith1TimeSubcollection ]raise: Error.
	self assert: (self howMany: self oldSubCollection  in: self collectionWith1TimeSubcollection  ) = 1.
	
	! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureEmptyTest

self shouldnt: [ self nonEmpty ] raise: Error.
self deny: self nonEmpty isEmpty.

self shouldnt: [ self empty ] raise: Error.
self assert: self empty isEmpty.! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureIncludeTest
	| elementIn |
	self shouldnt: [ self nonEmpty ]raise: Error.
	self deny: self nonEmpty isEmpty.
	
	self shouldnt: [ self elementNotIn ]raise: Error.
		
	elementIn := true.
	self nonEmpty detect: 
		[ :each | each = self elementNotIn ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	
	self shouldnt: [ self anotherElementNotIn ]raise: Error.
		
	elementIn := true.
	self nonEmpty detect: 
	[ :each | each = self anotherElementNotIn ]
	ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	
	self shouldnt: [ self empty ] raise: Error.
	self assert: self empty isEmpty.
	
! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureIncludeWithIdentityTest
	| element |
	self	shouldnt: [ self collectionWithCopyNonIdentical ]raise: Error.
	element := self collectionWithCopyNonIdentical anyOne.
	self deny: element == element copy.
! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureIndexAccessTest
	| res |
	self 
		shouldnt: [ self collectionMoreThan1NoDuplicates ]
		raise: Error.
	self assert: self collectionMoreThan1NoDuplicates size = 5.
	res := true.
	self collectionMoreThan1NoDuplicates 
		detect: [ :each | (self collectionMoreThan1NoDuplicates occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false.
	self 
		shouldnt: [ self elementInForIndexAccessing ]
		raise: Error.
	self assert: (self collectionMoreThan1NoDuplicates includes: self elementInForIndexAccessing).
	self 
		shouldnt: [ self elementNotInForIndexAccessing ]
		raise: Error.
	self deny: (self collectionMoreThan1NoDuplicates includes: self elementNotInForIndexAccessing)! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureIterateSequencedReadableTest

	| res |
	
	self shouldnt: self nonEmptyMoreThan1Element  raise: Error.
	self assert: self nonEmptyMoreThan1Element  size > 1.
	
	
	self shouldnt: self empty raise: Error.
	self assert: self empty isEmpty .
	
	res := true.
	self nonEmptyMoreThan1Element    
	detect: [ :each | (self nonEmptyMoreThan1Element    occurrencesOf: each) > 1 ]
	ifNone: [ res := false ].
	self assert: res = false.! !

!SMutantLinkedListTest methodsFor: 'test - fixture' stamp: 'Milos 4/20/2011 23:04'!
test0FixtureIterateTest


| res |
self shouldnt: [ self collectionWithoutNilElements ] raise: Error.

self assert: ( self collectionWithoutNilElements  occurrencesOf: nil) = 0.

res := true.
self collectionWithoutNilElements   
	detect: [ :each | (self collectionWithoutNilElements   occurrencesOf: each) > 1 ]
	ifNone: [ res := false ].
self assert: res = false.! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureOccurrencesTest
	| tmp |
	self shouldnt: [self empty ]raise: Error.
	self assert: self empty isEmpty.

	self shouldnt: [ self collectionWithoutEqualElements ] raise: Error.
	self deny: self collectionWithoutEqualElements isEmpty.
	
	tmp := OrderedCollection new.
	self collectionWithoutEqualElements do: [ 
		:each |
		self deny: (tmp includes: each).
		tmp add: each.
		 ].
	
	
	self shouldnt: [ self elementNotInForOccurrences ] raise: Error.
	self deny: (self collectionWithoutEqualElements includes: self elementNotInForOccurrences)! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixturePrintTest

	self shouldnt: [self nonEmpty ] raise: Error.
	self deny: self nonEmpty  isEmpty.! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureRequirementsOfTAddTest
	self 
		shouldnt: [ self collectionWithElement ]
		raise: Exception.
	self 
		shouldnt: [ self otherCollection ]
		raise: Exception.
	self 
		shouldnt: [ self element ]
		raise: Exception.
	self assert: (self collectionWithElement includes: self element).
	self deny: (self otherCollection includes: self element)! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureSequencedElementAccessTest
	self 
		shouldnt: [ self moreThan4Elements ]
		raise: Error.
	self assert: self moreThan4Elements size >= 4.
	self 
		shouldnt: [ self subCollectionNotIn ]
		raise: Error.
	self subCollectionNotIn 
		detect: [ :each | (self moreThan4Elements includes: each) not ]
		ifNone: [ self assert: false ].
	self 
		shouldnt: [ self elementNotInForElementAccessing ]
		raise: Error.
	self deny: (self moreThan4Elements includes: self elementNotInForElementAccessing).
	self 
		shouldnt: [ self elementInForElementAccessing ]
		raise: Error.
	self assert: (self moreThan4Elements includes: self elementInForElementAccessing)! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureSetAritmeticTest
	self 
		shouldnt: [ self collection ]
		raise: Error.
	self deny: self collection isEmpty.
	self 
		shouldnt: [ self nonEmpty ]
		raise: Error.
	self deny: self nonEmpty isEmpty.
	self 
		shouldnt: [ self anotherElementOrAssociationNotIn ]
		raise: Error.
	self collection isDictionary 
		ifTrue: 
			[ self deny: (self collection associations includes: self anotherElementOrAssociationNotIn key) ]
		ifFalse: 
			[ self deny: (self collection includes: self anotherElementOrAssociationNotIn) ].
	self 
		shouldnt: [ self collectionClass ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureSubcollectionAccessTest
	self 
		shouldnt: [ self moreThan3Elements ]
		raise: Error.
	self assert: self moreThan3Elements size > 2! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureTConvertTest
	"a collection of number without equal elements:"
	| res |
	self shouldnt: [ self collectionWithoutEqualElements ]raise: Error.
		
	res := true.
	self collectionWithoutEqualElements 
		detect: [ :each | (self collectionWithoutEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false.
	
	
! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0FixtureTRemoveTest
	| duplicate |
	self shouldnt: [ self empty ]raise: Error.
	self shouldnt: [ self nonEmptyWithoutEqualElements]  raise:Error.
	self deny: self nonEmptyWithoutEqualElements isEmpty.
	duplicate := true.
	self nonEmptyWithoutEqualElements detect: 
		[:each | (self nonEmptyWithoutEqualElements occurrencesOf: each) > 1] 			
		ifNone: [duplicate := false].
	self assert: duplicate = false.
	
	
	self shouldnt: [ self elementNotIn ] raise: Error.
	self assert: self empty isEmpty.
	self deny: self nonEmptyWithoutEqualElements isEmpty.
	self deny: (self nonEmptyWithoutEqualElements includes: self elementNotIn)! !

!SMutantLinkedListTest methodsFor: 'tests - fixture' stamp: 'Milos 4/20/2011 23:05'!
test0TStructuralEqualityTest
	self shouldnt: [self empty] raise: Error.
	self shouldnt: [self nonEmpty] raise: Error.
	self assert: self empty isEmpty.
	self deny: self nonEmpty isEmpty.! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test10removeFirst
	list add: link1.
	list add: link2.
	list add: link3.
	list add: link4.
	
	self assert: list size = 4.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link3.
	self assert: list fourth == link4.
	
	list removeFirst.
	self assert: list size = 3.
	self assert: list first == link2.
	self assert: list second == link3.
	self assert: list third == link4.
	
	list removeFirst.
	self assert: list size = 2.
	self assert: list first == link3.
	self assert: list second == link4.
	
	list removeFirst.
	self assert: list size = 1.
	self assert: list first == link4.
	
	list removeFirst.
	self assert: list isEmpty! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test11removeLast
	list add: link1.
	list add: link2.
	list add: link3.
	list add: link4.
	
	self assert: list size = 4.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link3.
	self assert: list fourth == link4.
	
	list removeLast.
	self assert: list size = 3.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link3.
	
	list removeLast.
	self assert: list size = 2.
	self assert: list first == link1.
	self assert: list second == link2.
	
	list removeLast.
	self assert: list size = 1.
	self assert: list first == link1.
	
	list removeFirst.
	self assert: list isEmpty! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test12remove
	list add: link1.
	list add: link2.
	list add: link3.
	list add: link4.
	
	self assert: list size = 4.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link3.
	self assert: list fourth == link4.
	
	list remove: link3.
	self assert: list size = 3.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link4.
	
	list remove: link2.
	self assert: list size = 2.
	self assert: list first == link1.
	self assert: list second == link4.
	
	list remove: link1.
	self assert: list size = 1.
	self assert: list first == link4.
	
	list remove: link4.
	self assert: list isEmpty! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test13remove
	list add: link1.
	list add: link2.
	list add: link3.
	list add: link4.
	
	self assert: list size = 4.
	self assert: list first == link1.
	self assert: list second == link2.
	self assert: list third == link3.
	self assert: list fourth == link4.
	
	list remove: link1.
	self assert: list size = 3.
	self assert: list first == link2.
	self assert: list second == link3.
	self assert: list third == link4.
	
	list remove: link4.
	self assert: list size = 2.
	self assert: list first == link2.
	self assert: list second == link3.
	
	list remove: link2.
	self assert: list size = 1.
	self assert: list first == link3.
	
	list remove: link3.
	self assert: list isEmpty! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
test14removeIfAbsent
	list add: link1.
	
	self assert: list size = 1.
	self assert: list first == link1.
	
	list remove: link1.
	self assert: list isEmpty.
	
	[list remove: link1]
		on: Error
		do: [^ self].
		
	"The execution should not get here. If yes, something went wrong."
	self assert: false! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:09'!
test22addAll
	| link5 link6 link7 link8 listToBeAdded |
	link5 := Link new.
	link6 := Link new.
	link7 := Link new.
	link8 := Link new.
	
	list
		add: link1;
		add: link2;
		add: link3;
		add: link4.
		
	listToBeAdded := SMutantLinkedList new.
	listToBeAdded
		add: link5;
		add: link6;
		add: link7;
		add: link8.
		
	list addAll: listToBeAdded.
	
	self should: [(list at: 1) == link1].
	self should: [(list at: 2) == link2].
	self should: [(list at: 3) == link3].
	self should: [(list at: 4) == link4].
	self should: [(list at: 5) == link5].
	self should: [(list at: 6) == link6].
	self should: [(list at: 7) == link7].
	self should: [(list at: 8) == link8].! !

!SMutantLinkedListTest methodsFor: 'tests' stamp: 'Milos 4/20/2011 23:09'!
testAddAfter

	| l first |
	l := SMutantLinkedList new.
	first := self class new n: 1.
	
	l add: first.
	l add: (self class new n: 3).
	self assert: (l collect:[:e | e n]) asArray  = #(1 3).
	l add: (self class new n: 2) after: first.
	self assert: (l collect:[:e | e n]) asArray  = #(1 2 3).! !

!SMutantLinkedListTest methodsFor: 'tests' stamp: 'Milos 4/20/2011 23:10'!
testAddAfterLast

	| l last |
	l := SMutantLinkedList new.
	last := self class new n: 2.
	l add: (self class new n: 1).
	l add: last.
	self assert: (l collect:[:e | e n]) asArray  = #(1 2). 
	l add: (self class new n: 3) after: last.
	self assert: (l collect:[:e | e n]) asArray  = #(1 2 3).! !

!SMutantLinkedListTest methodsFor: 'tests' stamp: 'Milos 4/20/2011 23:10'!
testAddAfterLast2
	"LinkedListTest new testAddAfterLast2"

	| l first second third fourth |
	l := SMutantLinkedList new.
	first := self class new n: 1.
	second := self class new n: 2.
	third := self class new n: 3.
	fourth :=self class new n: 4.
	l addLast: first.
	l addLast: second.
	self assert: (l collect:[:e | e n]) asArray  = #(1 2). 
	l add: third after: second.
	self assert: (l collect:[:e | e n]) asArray  = #(1 2 3).
	l addLast: fourth.
	self assert: (l collect:[:e | e n]) asArray  = #(1 2 3 4).! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAfter
	"self debug: #testAfter"
	self assert: (self moreThan4Elements after: (self moreThan4Elements at: 1)) = (self moreThan4Elements at: 2).
	self 
		should: 
			[ self moreThan4Elements after: (self moreThan4Elements at: self moreThan4Elements size) ]
		raise: Error.
	self 
		should: [ self moreThan4Elements after: self elementNotInForElementAccessing ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAfterIfAbsent
	"self debug: #testAfterIfAbsent"
	self assert: (self moreThan4Elements 
			after: (self moreThan4Elements at: 1)
			ifAbsent: [ 33 ]) = (self moreThan4Elements at: 2).
	self assert: (self moreThan4Elements 
			after: (self moreThan4Elements at: self moreThan4Elements size)
			ifAbsent: [ 33 ]) == 33.
	self assert: (self moreThan4Elements 
			after: self elementNotInForElementAccessing
			ifAbsent: [ 33 ]) = 33! !

!SMutantLinkedListTest methodsFor: 'tests - subcollections access' stamp: 'Milos 4/20/2011 23:05'!
testAllButFirst
	"self debug: #testAllButFirst"
	| abf col |
	col := self moreThan3Elements.
	abf := col allButFirst.
	self deny: abf first = col first.
	self assert: abf size + 1 = col size! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testAllButFirstDo
	
	| result |
	result:= OrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButFirstDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i +1))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!SMutantLinkedListTest methodsFor: 'tests - subcollections access' stamp: 'Milos 4/20/2011 23:05'!
testAllButFirstNElements
	"self debug: #testAllButFirst"
	| abf col |
	col := self moreThan3Elements.
	abf := col allButFirst: 2.
	1 
		to: abf size
		do: [ :i | self assert: (abf at: i) = (col at: i + 2) ].
	self assert: abf size + 2 = col size! !

!SMutantLinkedListTest methodsFor: 'tests - subcollections access' stamp: 'Milos 4/20/2011 23:05'!
testAllButLast
	"self debug: #testAllButLast"
	| abf col |
	col := self moreThan3Elements.
	abf := col allButLast.
	self deny: abf last = col last.
	self assert: abf size + 1 = col size! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testAllButLastDo
	
	| result |
	result:= OrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButLastDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i ))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!SMutantLinkedListTest methodsFor: 'tests - subcollections access' stamp: 'Milos 4/20/2011 23:05'!
testAllButLastNElements
	"self debug: #testAllButFirst"
	| abf col |
	col := self moreThan3Elements.
	abf := col allButLast: 2.
	1 
		to: abf size
		do: [ :i | self assert: (abf at: i) = (col at: i) ].
	self assert: abf size + 2 = col size! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testAllSatisfy

	| element |
	" when all element  satisfy the condition, should return true : "
	self assert: ( self collectionWithoutNilElements  allSatisfy: [:each | (each notNil) ] ).
	
	" when all element don't satisfy the condition, should return false : "
	self deny: ( self collectionWithoutNilElements  allSatisfy: [:each | (each notNil) not ] ).
	
	" when only one element doesn't satisfy the condition' should return false'"
	element := self collectionWithoutNilElements anyOne.
	self deny: ( self collectionWithoutNilElements  allSatisfy: [:each | (each = element) not] ).! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testAllSatisfyEmpty

	self assert: ( self empty allSatisfy: [:each | false]).
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testAnySastify

	| element |
	" when all elements satisty the condition, should return true :"
	self assert: ( self collectionWithoutNilElements anySatisfy: [:each | each notNil ]).
	
	" when only one element satisfy the condition, should return true :"
	element := self collectionWithoutNilElements anyOne.
	self assert: ( self collectionWithoutNilElements  anySatisfy: [:each | (each = element)  ]   ).
	
	" when all elements don't satisty the condition, should return false :"
	self deny: ( self collectionWithoutNilElements anySatisfy: [:each | (each notNil) not ]).
! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: Array! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
testAsBag

	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: Bag! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsCommaStringEmpty

	self assert: self empty asCommaString = ''.
	self assert: self empty asCommaStringAnd = ''.
	

! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsCommaStringMore

	"self assert: self oneTwoThreeItemCol asCommaString = '1, 2, 3'.
	self assert: self oneTwoThreeItemCol asCommaStringAnd = '1, 2 and 3'
"

	| result resultAnd index allElementsAsString |
	result:= self nonEmpty asCommaString .
	resultAnd:= self nonEmpty asCommaStringAnd .
 
	index := 1.
	(result findBetweenSubStrs: ',' )do:
		[:each |
		index = 1
			ifTrue: [self assert: each= ((self nonEmpty at:index)asString)]
			ifFalse: [self assert: each= (' ',(self nonEmpty at:index) asString)].
		index:=index+1
		].
	
	"verifying esultAnd :"
	allElementsAsString:=(resultAnd findBetweenSubStrs: ',' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size )
			ifTrue: [
			i = 1
				ifTrue:[self assert: (allElementsAsString at:i)=((self nonEmpty at:i) asString)]
				ifFalse:[self assert: (allElementsAsString at:i)=(' ',(self nonEmpty at:i) asString)]
				].
		i=(allElementsAsString size)
			ifTrue:[ 
			i = 1
				ifTrue:[self assert: (allElementsAsString at:i)=( (self nonEmpty at:i ) asString ,' and ', (self nonEmpty at: ( i + 1) ) asString )]
				ifFalse:[self assert: (allElementsAsString at:i)=( ' ' , (self nonEmpty at:i ) asString ,' and ', (self nonEmpty at: ( i + 1) ) asString )]
				].
		
		
			].! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsCommaStringOne
	
	"self assert: self oneItemCol asCommaString = '1'.
	self assert: self oneItemCol asCommaStringAnd = '1'."

	self assert: self nonEmpty1Element  asCommaString = (self nonEmpty1Element first asString).
	self assert: self nonEmpty1Element  asCommaStringAnd = (self nonEmpty1Element first asString).
	! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
testAsIdentitySet
	"test with a collection without equal elements :"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: IdentitySet.
! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: OrderedCollection! !

!SMutantLinkedListTest methodsFor: 'tests - converting' stamp: 'Milos 4/20/2011 23:04'!
testAsSet
	| |
	"test with a collection without equal elements :"
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: Set.
	! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsStringOnDelimiterEmpty

	| delim emptyStream |
	delim := ', '.
	emptyStream := ReadWriteStream on: ''.
	self empty asStringOn: emptyStream delimiter: delim.
	self assert: emptyStream contents = ''.
! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsStringOnDelimiterLastEmpty

	| delim emptyStream |
	delim := ', '.
	emptyStream := ReadWriteStream on: ''.
	self empty asStringOn: emptyStream delimiter: delim last:'and'.
	self assert: emptyStream contents = ''.
! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsStringOnDelimiterLastMore

	| delim multiItemStream result last allElementsAsString |
	
	delim := ', '.
	last := 'and'.
	result:=''.
	multiItemStream := ReadWriteStream on:result.
	self nonEmpty  asStringOn: multiItemStream delimiter: ', ' last: last.
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 )
			ifTrue: [self assert: (allElementsAsString at:i)=((self nonEmpty at:i)asString)].
		i=(allElementsAsString size-1)
			ifTrue:[ self deny: (allElementsAsString at:i)=(last)asString].
		i=(allElementsAsString size)
			ifTrue: [self assert: (allElementsAsString at:i)=((self nonEmpty at:(i-1))asString)].
			].
	
! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsStringOnDelimiterLastOne

	| delim oneItemStream result |
	
	delim := ', '.
	result:=''.
	oneItemStream := ReadWriteStream on: result.
	self nonEmpty1Element  asStringOn: oneItemStream delimiter: delim last: 'and'.
	oneItemStream do:[:each | self assert: each = (self nonEmpty1Element first asString)].
	

	! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsStringOnDelimiterMore

	| delim multiItemStream result index |
	"delim := ', '.
	multiItemStream := '' readWrite.
	self oneTwoThreeItemCol asStringOn: multiItemStream delimiter: ', '.
	self assert: multiItemStream contents = '1, 2, 3'."
	
	delim := ', '.
	result:=''.
	multiItemStream := ReadWriteStream on:result.
	self nonEmpty  asStringOn: multiItemStream delimiter: ', '.
	
	index:=1.
	(result findBetweenSubStrs: ', ' )do:
		[:each |
		self assert: each= ((self nonEmpty at:index)asString).
		index:=index+1
		].! !

!SMutantLinkedListTest methodsFor: 'tests - comma and delimiter' stamp: 'Milos 4/20/2011 23:04'!
testAsStringOnDelimiterOne

	| delim oneItemStream result |
	"delim := ', '.
	oneItemStream := '' readWrite.
	self oneItemCol asStringOn: oneItemStream delimiter: delim.
	self assert: oneItemStream contents = '1'."
	
	delim := ', '.
	result:=''.
	oneItemStream := ReadWriteStream on: result.
	self nonEmpty1Element  asStringOn: oneItemStream delimiter: delim.
	oneItemStream do:[:each | self assert: each = (self nonEmpty1Element first asString)].
	

	! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAt
	"self debug: #testAt"
	"
	self assert: (self accessCollection at: 1) = 1.
	self assert: (self accessCollection at: 2) = 2.
	"
	| index |
	index := self moreThan4Elements indexOf: self elementInForElementAccessing.
	self assert: (self moreThan4Elements at: index) = self elementInForElementAccessing! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtAll
	"self debug: #testAtAll"
	"	self flag: #theCollectionshouldbe102030intheFixture.
	
	self assert: (self accessCollection atAll: #(2 1)) first = self accessCollection second.
	self assert: (self accessCollection atAll: #(2)) first = self accessCollection second."
	| result |
	result := self moreThan4Elements atAll: #(2 1 2 ).
	self assert: (result at: 1) = (self moreThan4Elements at: 2).
	self assert: (result at: 2) = (self moreThan4Elements at: 1).
	self assert: (result at: 3) = (self moreThan4Elements at: 2).
	self assert: (self moreThan4Elements atAll: #()) = self moreThan4Elements species new! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtIfAbsent
	"self debug: #testAt"
	| absent |
	absent := false.
	self moreThan4Elements 
		at: self moreThan4Elements size + 1
		ifAbsent: [ absent := true ].
	self assert: absent = true.
	absent := false.
	self moreThan4Elements 
		at: self moreThan4Elements size
		ifAbsent: [ absent := true ].
	self assert: absent = false! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtLast
	"self debug: #testAtLast"
	| index |
	self assert: (self moreThan4Elements atLast: 1) = self moreThan4Elements last.
	"tmp:=1.
	self do:
		[:each | 
		each =self elementInForIndexAccessing 
			ifTrue:[index:=tmp].
		tmp:=tmp+1]."
	index := self moreThan4Elements indexOf: self elementInForElementAccessing.
	self assert: (self moreThan4Elements atLast: index) = (self moreThan4Elements at: self moreThan4Elements size - index + 1)! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtLastError
	"self debug: #testAtLast"
	self 
		should: [ self moreThan4Elements atLast: self moreThan4Elements size + 1 ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtLastIfAbsent
	"self debug: #testAtLastIfAbsent"
	self assert: (self moreThan4Elements 
			atLast: 1
			ifAbsent: [ nil ]) = self moreThan4Elements last.
	self assert: (self moreThan4Elements 
			atLast: self moreThan4Elements size + 1
			ifAbsent: [ 222 ]) = 222! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtOutOfBounds
	"self debug: #testAtOutOfBounds"
	self 
		should: [ self moreThan4Elements at: self moreThan4Elements size + 1 ]
		raise: Error.
	self 
		should: [ self moreThan4Elements at: -1 ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtPin
	"self debug: #testAtPin"
	self assert: (self moreThan4Elements atPin: 2) = self moreThan4Elements second.
	self assert: (self moreThan4Elements atPin: 99) = self moreThan4Elements last.
	self assert: (self moreThan4Elements atPin: -99) = self moreThan4Elements first! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtRandom
	| result |
	result := self nonEmpty atRandom .
	self assert: (self nonEmpty includes: result).! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:04'!
testAtWrap
	"self debug: #testAt"
	"
	self assert: (self accessCollection at: 1) = 1.
	self assert: (self accessCollection at: 2) = 2.
	"
	| index |
	index := self moreThan4Elements indexOf: self elementInForElementAccessing.
	self assert: (self moreThan4Elements atWrap: index) = self elementInForElementAccessing.
	self assert: (self moreThan4Elements atWrap: index + self moreThan4Elements size) = self elementInForElementAccessing.
	self assert: (self moreThan4Elements atWrap: index - self moreThan4Elements size) = self elementInForElementAccessing.
	self assert: (self moreThan4Elements atWrap: 1 + self moreThan4Elements size) = (self moreThan4Elements at: 1)! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testBasicCollect

	| res index |
	index := 0.
	res := self collectionWithoutNilElements  collect: [
		:each | 
		index := index + 1.
		each 
		].
	
	res do:[:each | self assert: (self collectionWithoutNilElements occurrencesOf: each) = (res occurrencesOf: each)].
	self assert: index =  self collectionWithoutNilElements size.
	 ! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testBasicCollectEmpty

	| res |
	res := self empty collect: [:each | each class].
	self assert: res isEmpty
	! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:05'!
testBefore
	"self debug: #testBefore"
	self assert: (self moreThan4Elements before: (self moreThan4Elements at: 2)) = (self moreThan4Elements at: 1).
	self 
		should: [ self moreThan4Elements before: (self moreThan4Elements at: 1) ]
		raise: Error.
	self 
		should: [ self moreThan4Elements before: 66 ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:05'!
testBeforeIfAbsent
	"self debug: #testBefore"
	self assert: (self moreThan4Elements 
			before: (self moreThan4Elements at: 1)
			ifAbsent: [ 99 ]) = 99.
	self assert: (self moreThan4Elements 
			before: (self moreThan4Elements at: 2)
			ifAbsent: [ 99 ]) = (self moreThan4Elements at: 1)! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testCollectFromTo
	
	| result |
	result:=self nonEmptyMoreThan1Element 
		collect: [ :each | each ]
		from: 1
		to: (self nonEmptyMoreThan1Element size - 1).
		
	1 to: result size
		do: [ :i | self assert: (self nonEmptyMoreThan1Element at: i) = (result at: i) ].
	self assert: result size = (self nonEmptyMoreThan1Element size - 1)! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testCollectOnEmpty
	self assert: (self empty collect: [:e | self fail]) isEmpty! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testCollectThenSelectOnEmpty

	self assert: (self empty collect: [:e | self fail] thenSelect: [:e | self fail]) isEmpty! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyAfter
	| result index collection |
	collection := self collectionWithoutEqualsElements .
	index:= self indexInForCollectionWithoutDuplicates .
	result := collection   copyAfter: (collection  at:index ).
	
	"verifying content: "
	(1) to: result size do: 
		[:i |
		self assert: (collection   at:(i + index ))=(result at: (i))].

	"verify size: "
	self assert: result size = (collection   size - index).! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyAfterEmpty
	| result |
	result := self empty copyAfter: self collectionWithoutEqualsElements first.
	self assert: result isEmpty.
	! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyAfterLast
	| result index collection |
	collection := self collectionWithoutEqualsElements .
	index:= self indexInForCollectionWithoutDuplicates .
	result := collection   copyAfterLast: (collection  at:index ).
	
	"verifying content: "
	(1) to: result size do: 
		[:i |
		self assert: (collection   at:(i + index ))=(result at: (i))].

	"verify size: "
	self assert: result size = (collection   size - index).! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyAfterLastEmpty
	| result |
	result := self empty copyAfterLast: self collectionWithoutEqualsElements first.
	self assert: result isEmpty.! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res element |
	element := self elementToAdd.
	res := self empty copyWith: element.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: (element value))! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyFromTo
	| result  index collection |
	collection := self collectionWithoutEqualsElements .
	index :=self indexInForCollectionWithoutDuplicates .
	result := collection   copyFrom: index  to: collection  size .
	
	"verify content of 'result' : "
	1 to: result size do:
		[:i | 
		self assert: (result at:i)=(collection  at: (i + index - 1))].
	
	"verify size of 'result' : "
	self assert: result size = (collection  size - index + 1).! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res element |
	element := self elementToAdd .
	res := self nonEmpty copyWith: element.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: (element value)).
	self nonEmpty do: [ :each | res includes: each ]! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyNonEmptyWithout
	"self debug: #testCopyNonEmptyWithout"
	
	| res anElementOfTheCollection |
	anElementOfTheCollection :=  self nonEmpty anyOne.
	res := (self nonEmpty copyWithout: anElementOfTheCollection).
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self deny: (res includes: anElementOfTheCollection).
	self nonEmpty do:
		[:each | (each = anElementOfTheCollection) 
					ifFalse: [self assert: (res includes: each)]].
	
! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: (each)) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyNonEmptyWithoutAllNotIncluded
	"self debug: #testCopyNonEmptyWithoutAllNotIncluded"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionNotIncluded.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!SMutantLinkedListTest methodsFor: 'tests - copy' stamp: 'Milos 4/20/2011 23:04'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!SMutantLinkedListTest methodsFor: 'tests - copying with replacement' stamp: 'Milos 4/20/2011 23:04'!
testCopyReplaceAllWith1Occurence
	| result  firstIndexesOfOccurrence index endPartIndexResult endPartIndexCollection |
	
	result := self collectionWith1TimeSubcollection  copyReplaceAll: self oldSubCollection with: self replacementCollection .
	
	"detecting indexes of olSubCollection"
	firstIndexesOfOccurrence  := self firstIndexesOf: self oldSubCollection in: self collectionWith1TimeSubcollection .
	index:= firstIndexesOfOccurrence at: 1.
	
	"verify content of 'result' : "
	"first part of 'result'' : '"

	1 to: (index -1) do: 
		[
		:i |  
		self assert: (self collectionWith1TimeSubcollection  at:i)=(result at: i)
		].

	" middle part containing replacementCollection : "
	
	index to: (index + self replacementCollection size-1) do: 
		[
		:i |
		self assert: ( result at: i )=(self replacementCollection at: ( i - index + 1 ))
		].
	
	" end part :"
	
	endPartIndexResult :=  index + self replacementCollection  size .
	endPartIndexCollection :=   index + self oldSubCollection size  .
	
	1 to: (result size - endPartIndexResult - 1 ) do:
		[ 
		:i |
		self assert: (result at: ( endPartIndexResult + i - 1 ) ) = (self collectionWith1TimeSubcollection  at: ( endPartIndexCollection + i - 1 ) ).
		].
	
	
	! !

!SMutantLinkedListTest methodsFor: 'tests - copying with replacement' stamp: 'Milos 4/20/2011 23:04'!
testCopyReplaceFromToWith
	| result  indexOfSubcollection lastIndexOfOldSubcollection lastIndexOfReplacementCollection |
	
	indexOfSubcollection := (self firstIndexesOf: self oldSubCollection  in:  self collectionWith1TimeSubcollection) at: 1. 
	lastIndexOfOldSubcollection := indexOfSubcollection + self oldSubCollection size -1.
	lastIndexOfReplacementCollection := indexOfSubcollection + self replacementCollection  size -1.
	
	result := self collectionWith1TimeSubcollection  copyReplaceFrom: indexOfSubcollection  to: lastIndexOfOldSubcollection   with: self replacementCollection .
	
	"verify content of 'result' : "
	"first part of 'result'  "
	
	1 to: (indexOfSubcollection  - 1) do: 
		[ 
		:i | 
		self assert: (self collectionWith1TimeSubcollection  at:i) = (result at: i)
		].
	
	" middle part containing replacementCollection : "
	
	(indexOfSubcollection ) to: ( lastIndexOfReplacementCollection  ) do: 
		[
		:i |
		self assert: (result at: i)=(self replacementCollection at: (i - indexOfSubcollection +1))
		].
	
	" end part :"
	1 to: (result size - lastIndexOfReplacementCollection   ) do:
		[ 
		:i |
		self assert: (result at: ( lastIndexOfReplacementCollection  + i  ) ) = (self collectionWith1TimeSubcollection  at: ( lastIndexOfOldSubcollection  + i  ) ).
		].
	
	
	

	
	! !

!SMutantLinkedListTest methodsFor: 'tests - copying with replacement' stamp: 'Milos 4/20/2011 23:04'!
testCopyReplaceFromToWithInsertion
	| result  indexOfSubcollection |
	
	indexOfSubcollection := (self firstIndexesOf: self oldSubCollection  in:  self collectionWith1TimeSubcollection) at: 1. 
	
	result := self collectionWith1TimeSubcollection  copyReplaceFrom: indexOfSubcollection  to: ( indexOfSubcollection - 1 ) with: self replacementCollection .
	
	"verify content of 'result' : "
	"first part of 'result'' : '"
	
	1 to: (indexOfSubcollection -1) do: 
		[
		:i | 
		self assert: (self collectionWith1TimeSubcollection  at:i)=(result at: i)
		].
	
	" middle part containing replacementCollection : "
	indexOfSubcollection  to: (indexOfSubcollection  + self replacementCollection size-1) do: 
		[
		:i |
		self assert: ( result at: i )=(self replacementCollection at: ( i - indexOfSubcollection +1 ))
		].
	
	" end part :"
	(indexOfSubcollection  + self replacementCollection size) to: (result size) do:
		[:i|
		self assert: (result at: i)=(self collectionWith1TimeSubcollection  at: (i-self replacementCollection size))].
	
	" verify size: "	
	self assert: result size=(self collectionWith1TimeSubcollection  size + self replacementCollection size).
	

	

	
	! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyUpTo
	| result index collection |
	collection := self collectionWithoutEqualsElements .
	index:= self indexInForCollectionWithoutDuplicates .
	result := collection   copyUpTo: (collection  at:index).
	
	"verify content of 'result' :"
	1 to: result size do: [:i| self assert: (collection   at:i)=(result at:i)].
	
	"verify size of 'result' :"
	self assert: result size = (index-1).
	! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyUpToEmpty
	| result |
	result := self empty copyUpTo: self collectionWithoutEqualsElements first.
	self assert: result isEmpty.
	! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyUpToLast
	| result index collection |
	collection := self collectionWithoutEqualsElements .
	index:= self indexInForCollectionWithoutDuplicates .
	result := collection   copyUpToLast: (collection  at:index).
	
	"verify content of 'result' :"
	1 to: result size do: [:i| self assert: (collection   at:i)=(result at:i)].
	
	"verify size of 'result' :"
	self assert: result size = (index-1).! !

!SMutantLinkedListTest methodsFor: 'tests - copying part of sequenceable' stamp: 'Milos 4/20/2011 23:04'!
testCopyUpToLastEmpty
	| result |
	result := self empty copyUpToLast: self collectionWithoutEqualsElements first.
	self assert: result isEmpty.! !

!SMutantLinkedListTest methodsFor: 'tests - copying with or without' stamp: 'Milos 4/20/2011 23:04'!
testCopyWithFirst

	| index element result |
	index:= self indexInNonEmpty .
	element:= self nonEmpty at: index.
	
	result := self nonEmpty copyWithFirst: element.	
	
	self assert: result size = (self nonEmpty size + 1).
	self assert: result first = element .
	
	2 to: result size do:
	[ :i |
	self assert: (result at: i) = ( self nonEmpty at: ( i - 1 ))].! !

!SMutantLinkedListTest methodsFor: 'tests - copying with or without' stamp: 'Milos 4/20/2011 23:04'!
testCopyWithSequenceable

	| result index element |
	index := self indexInNonEmpty .
	element := self nonEmpty at: index.
	result := self nonEmpty copyWith: (element ).
	
	self assert: result size = (self nonEmpty size + 1).
	self assert: result last = element .
	
	1 to: (result size - 1) do:
	[ :i |
	self assert: (result at: i) = ( self nonEmpty at: ( i  ))].! !

!SMutantLinkedListTest methodsFor: 'tests - copying with or without' stamp: 'Milos 4/20/2011 23:04'!
testCopyWithoutFirst

	| result |
	result := self nonEmpty copyWithoutFirst.
	
	self assert: result size = (self nonEmpty size - 1).
	
	1 to: result size do:
		[:i |
		self assert: (result at: i)= (self nonEmpty at: (i + 1))].! !

!SMutantLinkedListTest methodsFor: 'tests - copying with or without' stamp: 'Milos 4/20/2011 23:04'!
testCopyWithoutIndex
	| result index |
	index := self indexInNonEmpty .
	result := self nonEmpty copyWithoutIndex: index .
	
	"verify content of 'result:'"
	1 to: result size do:
		[:i | 
		i<( index ) ifTrue: [self assert: ((result at:i )= (self nonEmpty at:i))].
		i>=( index ) ifTrue: [self assert: (result at:i )= (self nonEmpty at:(i+1))]].
	
	"verify size of result : "
	self assert: result size=(self nonEmpty size -1).! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testDetect

	| res element |
	element := self collectionWithoutNilElements anyOne .
	 
	res := self collectionWithoutNilElements  detect: [:each | each = element].
	self assert: (res  = element).

	
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testDetectIfNone

	| res element |
	res := self collectionWithoutNilElements  detect: [:each | each notNil not] ifNone: [100].
	self assert: res  = 100.
	
	element := self collectionWithoutNilElements anyOne.
	res := self collectionWithoutNilElements  detect: [:each | each = element] ifNone: [100].
	self assert: res  = element.

	
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testDetectSequenced
" testing that detect keep the first element returning true for sequenceable collections "

	| element result |
	element := self nonEmptyMoreThan1Element   at:1.
	result:=self nonEmptyMoreThan1Element  detect: [:each | each notNil ].
	self assert: result = element. ! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testDifference
	"Answer the set theoretic difference of two collections."
	"self debug: #testDifference"
	
	self assert: (self collection difference: self collection) isEmpty.
	self assert: (self empty difference: self collection) isEmpty.
	self assert: (self collection difference: self empty) = self collection	
! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testDifferenceWithNonNullIntersection
	"Answer the set theoretic difference of two collections."
	"self debug: #testDifferenceWithNonNullIntersection"
	"	#(1 2 3) difference: #(2 4) 
	->  #(1 3)"
	| res overlapping |
	overlapping := self collectionClass 
		with: self anotherElementOrAssociationNotIn
		with: self anotherElementOrAssociationIn.
	res := self collection difference: overlapping.
	self deny: (res includes: self anotherElementOrAssociationIn).
	overlapping do: [ :each | self deny: (res includes: each) ]! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testDifferenceWithSeparateCollection
	"Answer the set theoretic difference of two collections."
	"self debug: #testDifferenceWithSeparateCollection"
	| res separateCol |
	separateCol := self collectionClass with: self anotherElementOrAssociationNotIn.
	res := self collection difference: separateCol.
	self deny: (res includes: self anotherElementOrAssociationNotIn).
	self assert: res = self collection.
	res := separateCol difference: self collection.
	self deny: (res includes: self collection anyOne).
	self assert: res = separateCol! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testDo! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testDo2
	"dc: Bad test, it assumes that a new instance of #speciesClass allows addition with #add:. This is not the case of Interval for which species is Array."
	"res := self speciesClass new.  
	self collection do: [:each | res add: each class].
	self assert: res = self result. "
	| collection cptElementsViewed cptElementsIn |
	collection := self collectionWithoutNilElements.
	cptElementsViewed := 0.
	cptElementsIn := OrderedCollection new.
	collection do: 
		[ :each | 
		cptElementsViewed := cptElementsViewed + 1.
		" #do doesn't iterate with the same objects than those in the collection for FloatArray( I don' t know why ) . That's why I use #includes: and not #identityIncludes:  '"
		(collection includes: each) ifTrue: [
			" the collection used doesn't include equal elements. Therefore each element viewed should not have been viewed before "
			( cptElementsIn includes: each ) ifFalse: [ cptElementsIn add: each ] .
			]. 
		].
	self assert: cptElementsViewed = collection size.
	self assert: cptElementsIn size  = collection size.
	
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testDoSeparatedBy
	| string expectedString beforeFirst |
	
	string := ''.
	self collectionWithoutNilElements  
		do: [ :each | string := string , each asString ]
		separatedBy: [ string := string , '|' ].
		
	expectedString := ''.
	beforeFirst := true.
	self collectionWithoutNilElements  do: 
		[ :each | 
		beforeFirst = true 
			ifTrue: [ beforeFirst := false ]
			ifFalse: [ expectedString := expectedString , '|' ].
		expectedString := expectedString , each asString ].
	self assert: expectedString = string! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testDoWithout
	"self debug: #testDoWithout"
	
	| res element collection |
	collection := self collectionWithoutNilElements .	
	res := OrderedCollection new.  
	element := self collectionWithoutNilElements anyOne .
	collection  do: [:each | res add: each] without: element  .
	" verifying result :"
	self assert: res size = (collection  size - (collection  occurrencesOf: element)).
	res do: [:each | self assert: (collection occurrencesOf: each) = ( res occurrencesOf: each ) ].
	! !

!SMutantLinkedListTest methodsFor: 'test - equality' stamp: 'Milos 4/20/2011 23:04'!
testEqualSign
	"self debug: #testEqualSign"

	self deny: (self empty = self nonEmpty).! !

!SMutantLinkedListTest methodsFor: 'test - equality' stamp: 'Milos 4/20/2011 23:04'!
testEqualSignIsTrueForNonIdenticalButEqualCollections
	"self debug: #testEqualSignIsTrueForNonIdenticalButEqualCollections"
		
	self assert: (self empty = self empty copy). 
	self assert: (self empty copy = self empty).
	self assert: (self empty copy = self empty copy).
		
	self assert: (self nonEmpty = self nonEmpty copy). 
	self assert: (self nonEmpty copy = self nonEmpty).
	self assert: (self nonEmpty copy = self nonEmpty copy).! !

!SMutantLinkedListTest methodsFor: 'test - equality' stamp: 'Milos 4/20/2011 23:04'!
testEqualSignOfIdenticalCollectionObjects
	"self debug: #testEqualSignOfIdenticalCollectionObjects"
	
	self assert: (self empty = self empty). 
	self assert: (self nonEmpty = self nonEmpty). 
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testFindFirst

	| element result |
	element := self nonEmptyMoreThan1Element   at:1.
	 result:=self nonEmptyMoreThan1Element  findFirst: [:each | each =element].
	
	self assert: result=1. ! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testFindFirstNotIn

	| result |
	
	 result:=self empty findFirst: [:each | true].
	
	self assert: result=0. ! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testFindLast

	| element result |
	element := self nonEmptyMoreThan1Element  at:self nonEmptyMoreThan1Element  size.
	 result:=self nonEmptyMoreThan1Element  findLast: [:each | each =element].
	
	self assert: result=self nonEmptyMoreThan1Element  size. ! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testFindLastNotIn

	| result |
	
	 result:=self empty findFirst: [:each | true].
	
	self assert: result=0. ! !

!SMutantLinkedListTest methodsFor: 'tests - subcollections access' stamp: 'Milos 4/20/2011 23:05'!
testFirstNElements
	"self debug: #testFirstNElements"
	| result |
	result := self moreThan3Elements first: self moreThan3Elements size - 1.
	1 
		to: result size
		do: [ :i | self assert: (result at: i) = (self moreThan3Elements at: i) ].
	self assert: result size = (self moreThan3Elements size - 1).
	self 
		should: [ self moreThan3Elements first: self moreThan3Elements size + 1 ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:05'!
testFirstSecondThird
	"self debug: #testFirstSecondThird"
	self assert: self moreThan4Elements first = (self moreThan4Elements at: 1).
	self assert: self moreThan4Elements second = (self moreThan4Elements at: 2).
	self assert: self moreThan4Elements third = (self moreThan4Elements at: 3).
	self assert: self moreThan4Elements fourth = (self moreThan4Elements at: 4)! !

!SMutantLinkedListTest methodsFor: 'tests - copying with or without' stamp: 'Milos 4/20/2011 23:04'!
testForceToPaddingStartWith

	| result element |
	element := self nonEmpty at: self indexInNonEmpty .
	result := self nonEmpty forceTo: (self nonEmpty size+2) paddingStartWith: ( element ).
	
	"verify content of 'result' : "
	1 to: 2   do:
		[:i | self assert: ( element ) = ( result at:(i) ) ].
	
	3 to: result size do:
		[:i | self assert: ( result at:i ) = ( self nonEmpty at:(i-2) ) ].

	"verify size of 'result' :"
	self assert: result size = (self nonEmpty size + 2).! !

!SMutantLinkedListTest methodsFor: 'tests - copying with or without' stamp: 'Milos 4/20/2011 23:04'!
testForceToPaddingWith

	| result element |
	element := self nonEmpty at: self indexInNonEmpty .
	result := self nonEmpty forceTo: (self nonEmpty size+2) paddingWith: ( element ).
	
	"verify content of 'result' : "
	1 to: self nonEmpty  size do:
		[:i | self assert: ( self nonEmpty at: i ) = ( result at:(i) ). ].
	
	(result size - 1) to: result size do:
		[:i | self assert: ( result at:i ) = ( element ) ].

	"verify size of 'result' :"
	self assert: result size = (self nonEmpty size + 2).! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testFromToDo
	
	| result |
	result:= OrderedCollection  new.
	
	self nonEmptyMoreThan1Element  from: 1 to: (self nonEmptyMoreThan1Element  size -1) do: [:each | result add: each].
	
	1 to: (self nonEmptyMoreThan1Element  size -1) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:i )=(result at:i)].
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIdentityIncludes
	" test the comportement in presence of elements 'includes' but not 'identityIncludes' "
	" can not be used by collections that can't include elements for wich copy doesn't return another instance "
	| collection element |
	self 
		shouldnt: [ self collectionWithCopyNonIdentical ]
		raise: Error.
	collection := self collectionWithCopyNonIdentical.
	element := collection anyOne copy.
	"self assert: (collection includes: element)."
	self deny: (collection identityIncludes: element)! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIdentityIncludesNonSpecificComportement
	" test the same comportement than 'includes: '  "
	| collection |	
	collection := self nonEmpty  .
	
	self deny: (collection identityIncludes: self elementNotIn ).
	self assert:(collection identityIncludes: collection anyOne)
! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIdentityIndexOf
	"self debug: #testIdentityIndexOf"
	| collection element |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection identityIndexOf: element) = (collection indexOf: element)! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIdentityIndexOfIAbsent
	| collection element |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			identityIndexOf: element
			ifAbsent: [ 0 ]) = 1.
	self assert: (collection 
			identityIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 55 ]) = 55! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIfEmpty

	self nonEmpty ifEmpty: [ self assert: false] .
	self empty ifEmpty: [ self assert: true] .
	

	! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIfEmptyifNotEmpty

	self assert: (self empty ifEmpty: [true] ifNotEmpty: [false]).
	self assert: (self nonEmpty ifEmpty: [false] ifNotEmpty: [true]).
	! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIfEmptyifNotEmptyDo
	"self debug #testIfEmptyifNotEmptyDo"
	
	self assert: (self empty ifEmpty: [true] ifNotEmptyDo: [:s | false]).
	self assert: (self nonEmpty ifEmpty: [false] ifNotEmptyDo: [:s | true]).
	self assert: (self nonEmpty 
					ifEmpty: [false]
					ifNotEmptyDo: [:s | s]) == self nonEmpty.! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIfNotEmpty

	self empty ifNotEmpty: [self assert: false].
	self nonEmpty ifNotEmpty: [self assert: true].
	self assert: (self nonEmpty ifNotEmpty: [:s | s ]) = self nonEmpty
	! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIfNotEmptyDo

	self empty ifNotEmptyDo: [:s | self assert: false].
	self assert: (self nonEmpty ifNotEmptyDo: [:s | s]) == self nonEmpty
! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIfNotEmptyDoifNotEmpty

	self assert: (self empty ifNotEmptyDo: [:s | false] ifEmpty: [true]).
	self assert: (self nonEmpty 
					ifNotEmptyDo: [:s | s] 
					ifEmpty: [false]) == self nonEmpty! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIfNotEmptyifEmpty

	self assert: (self empty ifNotEmpty: [false] ifEmpty: [true]).
	self assert: (self nonEmpty ifNotEmpty: [true] ifEmpty: [false]).
	! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIncludesAllOfAllThere
	"self debug: #testIncludesAllOfAllThere'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: { self nonEmpty anyOne }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty).! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIncludesAllOfNoneThere
	"self debug: #testIncludesAllOfNoneThere'"
	self deny: (self empty includesAllOf: self nonEmpty ).
	self deny: (self nonEmpty includesAllOf: { self elementNotIn. self anotherElementNotIn })! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIncludesAnyOfAllThere
	"self debug: #testIncludesAnyOfAllThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self assert: (self nonEmpty includesAnyOf: { self nonEmpty anyOne }).
	self assert: (self nonEmpty includesAnyOf: self nonEmpty).! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIncludesAnyOfNoneThere
	"self debug: #testIncludesAnyOfNoneThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self deny: (self nonEmpty includesAnyOf: { self elementNotIn. self anotherElementNotIn })! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIncludesElementIsNotThere
	"self debug: #testIncludesElementIsNotThere"
	
	self deny: (self nonEmpty includes: self elementNotIn).
	self assert: (self nonEmpty includes: self nonEmpty anyOne).
	self deny: (self empty includes: self elementNotIn)! !

!SMutantLinkedListTest methodsFor: 'tests - includes' stamp: 'Milos 4/20/2011 23:05'!
testIncludesElementIsThere
	"self debug: #testIncludesElementIsThere"
	
	self assert: (self nonEmpty includes: self nonEmpty anyOne).! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIndexOf
	"self debug: #testIndexOf"
	| tmp index collection |
	collection := self collectionMoreThan1NoDuplicates.
	tmp := collection size.
	collection reverseDo: 
		[ :each | 
		each = self elementInForIndexAccessing ifTrue: [ index := tmp ].
		tmp := tmp - 1 ].
	self assert: (collection indexOf: self elementInForIndexAccessing) = index! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| collection |
	collection := self collectionMoreThan1NoDuplicates.
	self assert: (collection 
			indexOf: collection first
			ifAbsent: [ 33 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 33 ]) = 33! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			indexOf: element
			startingAt: 2
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			indexOf: element
			startingAt: 1
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			startingAt: 1
			ifAbsent: [ 99 ]) = 99! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIndexOfStartingAtIfAbsent
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			indexOf: element
			startingAt: 2
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			indexOf: element
			startingAt: 1
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			startingAt: 1
			ifAbsent: [ 99 ]) = 99! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIndexOfSubCollectionStartingAt
	"self debug: #testIndexOfIfAbsent"
	| subcollection index collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1.
	self assert: index = 1.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2.
	self assert: index = 0! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testIndexOfSubCollectionStartingAtIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| index absent subcollection collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1
		ifAbsent: [ absent := true ].
	self assert: absent = false.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2
		ifAbsent: [ absent := true ].
	self assert: absent = true! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testInjectInto
	|result|
	result:= self collectionWithoutNilElements 
		inject: 0
		into: [:inj :ele | ele notNil ifTrue: [ inj + 1 ]].
	
	self assert: self collectionWithoutNilElements size = result .! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testIntersectionBasic
	"self debug: #testIntersectionBasic"
	| inter |
	inter := self collection intersection: (self collectionClass with: self anotherElementOrAssociationIn).
	self deny: inter isEmpty.
	self assert: (inter includes: self anotherElementOrAssociationIn value)! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testIntersectionEmpty
	"self debug: #testIntersectionEmpty"
	
	| inter |
	inter := self empty intersection: self empty.
	self assert: inter isEmpty. 
	inter := self empty intersection: self collection .
	self assert: inter =  self empty.
	! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testIntersectionItself
	"self debug: #testIntersectionItself"
	
	self assert: (self collection intersection: self collection) = self collection.
	! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testIntersectionTwoSimilarElementsInIntersection
	"self debug: #testIntersectionBasic"
	| inter |
	inter := self collection intersection: (self collectionClass with: self anotherElementOrAssociationIn).
	self assert: (self collection occurrencesOf: self anotherElementOrAssociationIn) = self numberOfSimilarElementsInIntersection.
	self assert: (inter includes: self anotherElementOrAssociationIn value)! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIsEmpty

	self assert: (self empty isEmpty).
	self deny: (self nonEmpty isEmpty).! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testIsEmptyOrNil

	self assert: (self empty isEmptyOrNil).
	self deny: (self nonEmpty isEmptyOrNil).! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testKeysAndValuesDo
	"| result |
	result:= OrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	1 to: result size do:
		[:i|
		self assert: (result at:i)=((self nonEmptyMoreThan1Element at:i)+i)]"
	|  indexes elements |
	indexes:= OrderedCollection new.
	elements := OrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testKeysAndValuesDoEmpty
	| result |
	result:= OrderedCollection new.
	
	self empty  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	self assert: result isEmpty .! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:05'!
testLast
	"self debug: #testLast"
	self assert: self moreThan4Elements last = (self moreThan4Elements at: self moreThan4Elements size)! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testLastIndexOf
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection lastIndexOf: element) = 1.
	self assert: (collection lastIndexOf: self elementNotInForIndexAccessing) = 0! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testLastIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			lastIndexOf: element
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 99 ]) = 99! !

!SMutantLinkedListTest methodsFor: 'tests - index access' stamp: 'Milos 4/20/2011 23:05'!
testLastIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection last.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size
			ifAbsent: [ 99 ]) = collection size.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size - 1
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			startingAt: collection size
			ifAbsent: [ 99 ]) = 99! !

!SMutantLinkedListTest methodsFor: 'tests - subcollections access' stamp: 'Milos 4/20/2011 23:05'!
testLastNElements
	"self debug: #testLastNElements"
	| result |
	result := self moreThan3Elements last: self moreThan3Elements size - 1.
	1 
		to: result size
		do: [ :i | self assert: (result at: i) = (self moreThan3Elements at: i + 1) ].
	self assert: result size = (self moreThan3Elements size - 1).
	self 
		should: [ self moreThan3Elements last: self moreThan3Elements size + 1 ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - element accessing' stamp: 'Milos 4/20/2011 23:05'!
testMiddle
	"self debug: #testMiddle"
	self assert: self moreThan4Elements middle = (self moreThan4Elements at: self moreThan4Elements size // 2 + 1)! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testNoneSatisfy

	| element |
	self assert: ( self collectionWithoutNilElements  noneSatisfy: [:each | each notNil not ] ).
	element := self collectionWithoutNilElements anyOne.
	self deny: ( self collectionWithoutNilElements  noneSatisfy: [:each | (each = element)not ] ).! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testNoneSatisfyEmpty

	self assert: ( self empty noneSatisfy: [:each | false]).
	! !

!SMutantLinkedListTest methodsFor: 'tests - empty' stamp: 'Milos 4/20/2011 23:05'!
testNotEmpty

	self assert: (self nonEmpty  notEmpty).
	self deny: (self empty notEmpty).! !

!SMutantLinkedListTest methodsFor: 'tests - occurrencesOf' stamp: 'Milos 4/20/2011 23:05'!
testOccurrencesOf
	| collection |
	collection := self collectionWithoutEqualElements .
	
	collection do: [ :each | self assert: (collection occurrencesOf: each) = 1 ].! !

!SMutantLinkedListTest methodsFor: 'tests - occurrencesOf' stamp: 'Milos 4/20/2011 23:05'!
testOccurrencesOfEmpty
	| result |
	result := self empty occurrencesOf: (self collectionWithoutEqualElements anyOne).
	self assert: result = 0! !

!SMutantLinkedListTest methodsFor: 'tests - occurrencesOf' stamp: 'Milos 4/20/2011 23:05'!
testOccurrencesOfNotIn
	| result |
	result := self collectionWithoutEqualElements occurrencesOf: self elementNotInForOccurrences.
	self assert: result = 0! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testPairsCollect
	
	| index result |
	index:=0.
	
	result:=self nonEmptyMoreThan1Element  pairsCollect: 
		[:each1 :each2 | 
		self assert: ( self nonEmptyMoreThan1Element indexOf: each2 ) = (index := index + 2).
		(self nonEmptyMoreThan1Element indexOf: each2) = ((self nonEmptyMoreThan1Element indexOf: each1) + 1).
		].
	
	result do: 
		[:each | self assert: each = true].
	
! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testPairsDo
	| index |
	index:=1.
	
	self nonEmptyMoreThan1Element  pairsDo: 
		[:each1 :each2 | 
		self assert:(self nonEmptyMoreThan1Element at:index)=each1.
		self assert:(self nonEmptyMoreThan1Element at:(index+1))=each2.
		index:=index+2].
	
	self nonEmptyMoreThan1Element size odd
		ifTrue:[self assert: index=self nonEmptyMoreThan1Element size]
		ifFalse:[self assert: index=(self nonEmptyMoreThan1Element size+1)].! !

!SMutantLinkedListTest methodsFor: 'tests - printing' stamp: 'Milos 4/20/2011 23:05'!
testPrintElementsOn

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printElementsOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).
			].! !

!SMutantLinkedListTest methodsFor: 'tests - printing' stamp: 'Milos 4/20/2011 23:05'!
testPrintNameOn

	| aStream result |
	result:=''.
	aStream:= ReadWriteStream on: result.
	
	self nonEmpty printNameOn: aStream .
	Transcript show: result asString.
	self nonEmpty class name first isVowel
		ifTrue:[ self assert: aStream contents =('an ',self nonEmpty class name ) ]
		ifFalse:[self assert: aStream contents =('a ',self nonEmpty class name)].! !

!SMutantLinkedListTest methodsFor: 'tests - printing' stamp: 'Milos 4/20/2011 23:05'!
testPrintOn
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i=1
			ifTrue:[
			self accessCollection class name first isVowel 
				ifTrue:[self assert: (allElementsAsString at:i)='an' ]
				ifFalse:[self assert: (allElementsAsString at:i)='a'].].
		i=2
			ifTrue:[self assert: (allElementsAsString at:i)=self accessCollection class name].
		i>2
			ifTrue:[self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).].	
			].! !

!SMutantLinkedListTest methodsFor: 'tests - printing' stamp: 'Milos 4/20/2011 23:05'!
testPrintOnDelimiter
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	
	
	self nonEmpty printOn: aStream delimiter: ', ' .
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i))
			].! !

!SMutantLinkedListTest methodsFor: 'tests - printing' stamp: 'Milos 4/20/2011 23:05'!
testPrintOnDelimiterLast

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= OrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream delimiter: ', ' last: 'and'.
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 )
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self deny: (allElementsAsString at:i)=('and')asString].
		i=(allElementsAsString size)
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
			].! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testReject

	| res element |
	res := self collectionWithoutNilElements  reject: [:each | each notNil not].
	self assert: res size = self collectionWithoutNilElements size.
	
	element := self collectionWithoutNilElements anyOne.
	res := self collectionWithoutNilElements  reject: [:each | each = element].
	self assert: res size = (self collectionWithoutNilElements size - 1).
	
	
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testRejectEmpty

	| res |
	res := self empty reject: [:each | each odd].
	self assert: res size = self empty size
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testRejectNoReject

	| res |
	res := self collectionWithoutNilElements  reject: [:each | each notNil not].
	self assert: res size = self collectionWithoutNilElements size.
	! !

!SMutantLinkedListTest methodsFor: 'testing' stamp: 'Milos 4/20/2011 23:04'!
testRemoveAll
	| list2 |
	list add: link1.
	list add: link2.
	list add: link3.
	list add: link4.
	list2 := list copy.
	list removeAll.
	
	self assert: list size = 0.
	self assert: list2 size = 4 description: 'the copy has not been modified'! !

!SMutantLinkedListTest methodsFor: 'tests - remove' stamp: 'Milos 4/20/2011 23:05'!
testRemoveAllError
	"self debug: #testRemoveElementThatExists"
	| el res subCollection |
	el := self elementNotIn.
	subCollection := self nonEmptyWithoutEqualElements copyWith: el.
	self 
		should: [ res := self nonEmptyWithoutEqualElements removeAll: subCollection ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - remove' stamp: 'Milos 4/20/2011 23:05'!
testRemoveAllFoundIn
	"self debug: #testRemoveElementThatExists"
	| el res subCollection |
	el := self nonEmptyWithoutEqualElements anyOne.
	subCollection := (self nonEmptyWithoutEqualElements copyWithout: el) copyWith: self elementNotIn.
	self 
		shouldnt: 
			[ res := self nonEmptyWithoutEqualElements removeAllFoundIn: subCollection ]
		raise: Error.
	self assert: self nonEmptyWithoutEqualElements size = 1.
	self nonEmptyWithoutEqualElements do: [ :each | self assert: each = el ]! !

!SMutantLinkedListTest methodsFor: 'tests - remove' stamp: 'Milos 4/20/2011 23:05'!
testRemoveAllSuchThat
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self nonEmptyWithoutEqualElements anyOne.
	subCollection := self nonEmptyWithoutEqualElements copyWithout: el.
	self nonEmptyWithoutEqualElements removeAllSuchThat: [ :each | subCollection includes: each ].
	self assert: self nonEmptyWithoutEqualElements size = 1.
	self nonEmptyWithoutEqualElements do: [ :each | self assert: each = el ]! !

!SMutantLinkedListTest methodsFor: 'tests - remove' stamp: 'Milos 4/20/2011 23:05'!
testRemoveElementFromEmpty
	"self debug: #testRemoveElementFromEmpty"
	self 
		should: [ self empty remove: self nonEmptyWithoutEqualElements anyOne ]
		raise: Error! !

!SMutantLinkedListTest methodsFor: 'tests - remove' stamp: 'Milos 4/20/2011 23:05'!
testRemoveElementReallyRemovesElement
	"self debug: #testRemoveElementReallyRemovesElement"
	| size |
	size := self nonEmptyWithoutEqualElements size.
	self nonEmptyWithoutEqualElements remove: self nonEmptyWithoutEqualElements anyOne.
	self assert: size - 1 = self nonEmptyWithoutEqualElements size! !

!SMutantLinkedListTest methodsFor: 'tests - remove' stamp: 'Milos 4/20/2011 23:05'!
testRemoveElementThatExists
	"self debug: #testRemoveElementThatExists"
	| el res |
	el := self nonEmptyWithoutEqualElements anyOne.
	self 
		shouldnt: [ res := self nonEmptyWithoutEqualElements remove: el ]
		raise: Error.
	self assert: res == el! !

!SMutantLinkedListTest methodsFor: 'tests - remove' stamp: 'Milos 4/20/2011 23:05'!
testRemoveIfAbsent
	"self debug: #testRemoveElementThatExists"
	| el res |
	el := self elementNotIn.
	self 
		shouldnt: 
			[ res := self nonEmptyWithoutEqualElements 
				remove: el
				ifAbsent: [ 33 ] ]
		raise: Error.
	self assert: res == 33! !

!SMutantLinkedListTest methodsFor: 'tests - copying same contents' stamp: 'Milos 4/20/2011 23:04'!
testReverse
	| result |
	result := self nonEmpty reverse .
	
	"verify content of 'result: '"
	1 to: result size do:
		[:i | self assert: ((result at:i)=(self nonEmpty at:(self nonEmpty size-i+1)))].
	"verify size of 'result' :"
	self assert: result size=self nonEmpty size.! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testReverseDo
	| result |
	result:= OrderedCollection new.
	self nonEmpty reverseDo: [: each | result add: each].
	
	1 to: result size do:
		[:i|
		self assert: (result at: i)=(self nonEmpty at:(self nonEmpty size-i+1))].! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testReverseDoEmpty
	| result |
	result:= OrderedCollection new.
	self empty reverseDo: [: each | result add: each].
	
	self assert: result isEmpty .! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testReverseWithDo
		
	| secondCollection result index |
	result:= OrderedCollection new.
	index := self nonEmptyMoreThan1Element size + 1.
	secondCollection:= self nonEmptyMoreThan1Element  copy.
	
	self nonEmptyMoreThan1Element  reverseWith: secondCollection do:
		[:a :b |
		self assert: (self nonEmptyMoreThan1Element indexOf: a  ) = (index := index - 1 ).
		result add: (a = b)].
	
	1 to: result size do:
		[:i|
		self assert: (result at:i)=(true)].
	self assert: result size =  self nonEmptyMoreThan1Element size.! !

!SMutantLinkedListTest methodsFor: 'tests - copying same contents' stamp: 'Milos 4/20/2011 23:04'!
testReversed
	| result |
	result := self nonEmpty reversed .
	
	"verify content of 'result: '"
	1 to:  result size do:
		[:i | self assert: ((result at:i)=(self nonEmpty at:(self nonEmpty size-i+1)))].
	"verify size of 'result' :"
	self assert: result size=self nonEmpty size.! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testSelect

	| res element |
	res := self collectionWithoutNilElements  select: [:each | each notNil].
	self assert: res size = self collectionWithoutNilElements size.
	
	element := self collectionWithoutNilElements anyOne.
	res := self collectionWithoutNilElements  select: [:each | (each = element) not].
	self assert: res size = (self collectionWithoutNilElements size - 1).
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterating' stamp: 'Milos 4/20/2011 23:05'!
testSelectOnEmpty

	self assert: (self empty select: [:e | self fail]) isEmpty
	! !

!SMutantLinkedListTest methodsFor: 'tests - copying same contents' stamp: 'Milos 4/20/2011 23:04'!
testShallowCopy
	| result |
	result := self nonEmpty shallowCopy .
	
	"verify content of 'result: '"
	1 to: self nonEmpty size do:
		[:i | self assert: ((result at:i)=(self nonEmpty at:i))].
	"verify size of 'result' :"
	self assert: result size=self nonEmpty size.! !

!SMutantLinkedListTest methodsFor: 'tests - copying same contents' stamp: 'Milos 4/20/2011 23:04'!
testShallowCopyEmpty
	| result |
	result := self empty shallowCopy .
	self assert: result isEmpty .! !

!SMutantLinkedListTest methodsFor: 'tests - copying same contents' stamp: 'Milos 4/20/2011 23:04'!
testShuffled
	| result |
	result := self nonEmpty shuffled .
	
	"verify content of 'result: '"
	result do: [:each | self assert: (self nonEmpty occurrencesOf: each)=(result occurrencesOf: each)].
	"verify size of 'result' :"
	self assert: result size=self nonEmpty size.! !

!SMutantLinkedListTest methodsFor: 'tests - printing' stamp: 'Milos 4/20/2011 23:05'!
testStoreOn
" for the moment work only for collection that include simple elements such that Integer"

"| string str result cuttedResult index elementsAsStringExpected elementsAsStringObtained tmp |
string := ''.
str := ReadWriteStream  on: string.
elementsAsStringExpected := OrderedCollection new.
elementsAsStringObtained := OrderedCollection new.
self nonEmpty do: [ :each | elementsAsStringExpected  add: each asString].

self nonEmpty storeOn: str.
result := str contents .
cuttedResult := ( result findBetweenSubStrs: ';' ).

index := 1.

cuttedResult do:
	[ :each |
	index = 1 
		ifTrue: [ self assert: (each beginsWith: ( tmp := '((' , self nonEmpty class asString , ' new) add: '           )).
				tmp := each copyFrom: ( tmp size + 1) to: ( each size ).
				elementsAsStringObtained add: tmp.
				index := index + 1. ]
		ifFalse:  [ 
		 index < cuttedResult size
			ifTrue:[self assert: (each beginsWith: ( tmp:=  ' add: '   )).
				tmp := each copyFrom: ( tmp size + 1) to: ( each size ).
				elementsAsStringObtained add: tmp.
					index := index + 1.]
			ifFalse: [self assert: ( each = ' yourself)' ) ].
			]
	
	].


	elementsAsStringExpected do: [ :each | self assert: (elementsAsStringExpected occurrencesOf: each ) = ( elementsAsStringObtained occurrencesOf: each) ]"

! !

!SMutantLinkedListTest methodsFor: 'tests - adding' stamp: 'Milos 4/20/2011 23:04'!
testTAdd

	| added |
	added := self otherCollection add: self element.
	self assert: added = self element. "equality or identity ?"
	self assert: (self otherCollection includes: self element).

	! !

!SMutantLinkedListTest methodsFor: 'tests - adding' stamp: 'Milos 4/20/2011 23:04'!
testTAddAll
	| added collection toBeAdded |
	collection := self collectionWithElement .
	toBeAdded := self otherCollection .
	added := collection addAll: toBeAdded .
	self assert: added == toBeAdded .	"test for identiy because #addAll: has not reason to copy its parameter."
	self assert: (collection includesAllOf: toBeAdded )! !

!SMutantLinkedListTest methodsFor: 'tests - adding' stamp: 'Milos 4/20/2011 23:04'!
testTAddIfNotPresentWithElementAlreadyIn

	| added oldSize collection element |
	collection := self collectionWithElement .
	oldSize := collection size.
	element := self element .
	self assert: (collection  includes: element ).
	
	added := collection  addIfNotPresent: element .
	
	self assert: added == element .	"test for identiy because #add: has not reason to copy its parameter."
	self assert: collection  size = oldSize! !

!SMutantLinkedListTest methodsFor: 'tests - adding' stamp: 'Milos 4/20/2011 23:04'!
testTAddIfNotPresentWithNewElement

	| added oldSize collection element |
	collection := self otherCollection .
	oldSize := collection  size.
	element := self element .
	self deny: (collection  includes: element ).
	
	added := collection  addIfNotPresent: element .
	self assert: added == element . "test for identiy because #add: has not reason to copy its parameter."
	self assert: (collection  size = (oldSize + 1)).

	! !

!SMutantLinkedListTest methodsFor: 'tests - adding' stamp: 'Milos 4/20/2011 23:04'!
testTWrite
	| added collection element |
	collection := self otherCollection  .
	element := self element .
	added := collection  write: element .
	
	self assert: added == element .	"test for identiy because #add: has not reason to copy its parameter."
	self assert: (collection  includes: element )	.
	self assert: (collection  includes: element ).
	
	! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testUnion
	"self debug: #testUnionOfEmpties"
	
	| union |
	union := self empty union: self nonEmpty.
	self containsAll: union of: self empty andOf: self nonEmpty.
	union := self nonEmpty union: self empty.
	self containsAll: union of: self empty andOf: self nonEmpty.
	union := self collection union: self nonEmpty.
	self containsAll: union of: self collection andOf: self nonEmpty.! !

!SMutantLinkedListTest methodsFor: 'tests - set arithmetic' stamp: 'Milos 4/20/2011 23:05'!
testUnionOfEmpties
	"self debug: #testUnionOfEmpties"
	
	self assert:  (self empty union: self empty) isEmpty.
	
	! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testWithCollect
	
	| result newCollection index collection |

	index := 0.
	collection := self nonEmptyMoreThan1Element .
	newCollection := collection  copy.
	result:=collection   with: newCollection collect: [:a :b | 
		self assert: (collection  indexOf: a ) = ( index := index + 1).
		self assert: (a = b).
		b].
	
	1 to: result size do:[: i | self assert: (result at:i)= (collection  at: i)].
	self assert: result size = collection  size.! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testWithCollectError
	self should: [self nonEmptyMoreThan1Element with: self empty collect:[:a :b | ]] raise: Error.! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testWithDo
	
	| secondCollection result index |
	result:= OrderedCollection new.
	secondCollection:= self nonEmptyMoreThan1Element  copy.
	index := 0.
	
	self nonEmptyMoreThan1Element  with: secondCollection do:
		[:a :b |
		self assert: (self nonEmptyMoreThan1Element indexOf: a) = ( index := index + 1).
		result add: (a =b)].
	
	1 to: result size do:
		[:i|
		self assert: (result at:i)=(true)].
	self assert: result size = self nonEmptyMoreThan1Element size.! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testWithDoError
	
	self should: [self nonEmptyMoreThan1Element with: self empty do:[:a :b | ]] raise: Error.! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testWithIndexCollect
	
	| result index collection |
	index := 0.
	collection := self nonEmptyMoreThan1Element .
	result := collection  withIndexCollect: [:each :i | 
		self assert: i = (index := index + 1).	
		self assert: i = (collection  indexOf: each) .
		each] . 
	
	1 to: result size do:[: i | self assert: (result at:i)= (collection at: i)].
	self assert: result size = collection size.! !

!SMutantLinkedListTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'Milos 4/20/2011 23:05'!
testWithIndexDo
	
	"| result |
	result:=Array new: self nonEmptyMoreThan1Element size.
	self nonEmptyMoreThan1Element  withIndexDo: [:each :i | result at:i put:(each+i)].
	
	1 to: result size do:[: i | self assert: (result at:i)= ((self nonEmptyMoreThan1Element at: i) + i)]"
	|  indexes elements |
	indexes:= OrderedCollection new.
	elements := OrderedCollection new.
	
	self nonEmptyMoreThan1Element  withIndexDo: 
		[:value :i  |
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	! !

!SMutantLinkedListTest methodsFor: 'tests - begins ends with' stamp: 'Milos 4/20/2011 23:04'!
testsBeginsWith
	
	self assert: (self nonEmpty beginsWith:(self nonEmpty copyUpTo: self nonEmpty size)).
	self assert: (self nonEmpty beginsWith:(self nonEmpty )).
	self deny: (self nonEmpty beginsWith:(self nonEmpty copyWith:self nonEmpty first)).! !

!SMutantLinkedListTest methodsFor: 'tests - begins ends with' stamp: 'Milos 4/20/2011 23:04'!
testsBeginsWithEmpty
	
	self deny: (self nonEmpty beginsWith:(self empty)).
	self deny: (self empty beginsWith:(self nonEmpty )).
! !

!SMutantLinkedListTest methodsFor: 'tests - begins ends with' stamp: 'Milos 4/20/2011 23:04'!
testsEndsWith
	
	self assert: (self nonEmpty endsWith:(self nonEmpty copyWithoutFirst)).
	self assert: (self nonEmpty endsWith:(self nonEmpty )).
	self deny: (self nonEmpty endsWith:(self nonEmpty copyWith:self nonEmpty first)).! !

!SMutantLinkedListTest methodsFor: 'tests - begins ends with' stamp: 'Milos 4/20/2011 23:04'!
testsEndsWithEmpty
	
	self deny: (self nonEmpty endsWith:(self empty )).
	self deny: (self empty  endsWith:(self nonEmpty )).
	! !

TestCase subclass: #SimpleBankAccountTest
	instanceVariableNames: 'bankAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Examples'!

!SimpleBankAccountTest methodsFor: 'running' stamp: 'Milos 4/24/2011 14:30'!
setUp
	bankAccount := BankAccount balance: 50.! !

!SimpleBankAccountTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 14:30'!
testWithdrawSuccessful
	bankAccount withdraw: 30.
	self assert: [bankAccount balance = 20].! !

!SimpleBankAccountTest methodsFor: 'tests' stamp: 'Milos 4/24/2011 14:30'!
testWithdrawUnsuccessful
	bankAccount withdraw: 70.
	self assert: [bankAccount balance = 50].! !
